import javax.swing.JPanel;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;

public class CAboutDlg extends JDialog {

	private JPanel jContentPane = null;
	private JLabel NPIcon = null;
	private JPanel jPanel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel = null;
	private JLabel jLabel2 = null;
	/**
	 * This is the default constructor
	 */
	public CAboutDlg(wnp pwnp) {                                   //~5929R~
		super(pwnp,null,true);	//modal                            //~5929R~
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(392, 110);
      if (wnp.Sjlang)                                              //~5C21I~
		this.setTitle("o[W");
      else                                                         //~5C21I~
		this.setTitle("Version Info.");                            //~5C21I~
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel2 = new JLabel();
			jLabel2.setText("    ");
			jLabel2.setPreferredSize(new java.awt.Dimension(10,40));
			NPIcon = new JLabel();
			NPIcon.setText("     ");
			NPIcon.setIcon(new ImageIcon(getClass().getResource("/wnp.gif")));//~5B15R~
			NPIcon.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			NPIcon.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
			NPIcon.setPreferredSize(new java.awt.Dimension(60,50));
			jContentPane = new JPanel();
			jContentPane.setLayout(new BoxLayout(getJContentPane(), BoxLayout.X_AXIS));
			jContentPane.setBackground(new java.awt.Color(0,50,0));
			jContentPane.setPreferredSize(new java.awt.Dimension(300,100));
			jContentPane.add(jLabel2, null);
			jContentPane.add(NPIcon, null);
			jContentPane.add(getJPanel(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jLabel = new JLabel();
          if (wnp.Sjlang)                                          //~5C21I~
			jLabel.setText("  Copyright (C) ؔ@w");
          else                                                     //~5C21I~
			jLabel.setText("  Copyright (C) Everyshow Gaku");      //~5C22R~
			jLabel.setForeground(java.awt.Color.white);
			jLabel.setFont(new java.awt.Font(wnp.Sfontname, java.awt.Font.PLAIN, 14));//~5C21R~
			jLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLabel.setPreferredSize(new java.awt.Dimension(300,60));
			jLabel1 = new JLabel();
			jLabel1.setForeground(java.awt.Color.white);
          if (wnp.Sjlang)                                          //~5C21I~
			jLabel1.setText("  iv Vesion 1.2 2005/12/22");   //+5C22R~
          else                                                     //~5C21I~
			jLabel1.setText("  Number Place Puzzle Vesion 1.2 2005/12/22");//+5C22R~
			jLabel1.setFont(new java.awt.Font(wnp.Sfontname, java.awt.Font.PLAIN, 14));//~5C21R~
			jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLabel1.setVerticalAlignment(javax.swing.SwingConstants.TOP);
			jLabel1.setPreferredSize(new java.awt.Dimension(300,60));
			jPanel = new JPanel();
			jPanel.setLayout(new BoxLayout(getJPanel(), BoxLayout.Y_AXIS));
			jPanel.setBackground(new java.awt.Color(0,50,0));
			jPanel.setPreferredSize(new java.awt.Dimension(200,100));
			jPanel.add(jLabel1, null);
			jPanel.add(jLabel, null);
		}
		return jPanel;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
