//CID://+va23R~:                                                   //+va23R~
//******************************************************************************//~va01I~
//va23:051221 langauge ctl(English and japanese)                   //+va23I~
//va01:051013 5*5 support                                          //~va01I~
//******************************************************************************//~va01I~
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

public class CDocument {
public static final String FILTER_DESC="xnp files";                //~5A06I~
public static final String FILTER_EXT="xnp";                       //~5A06I~
	private wnp pwnp=null;
	public CPattern pPattern=null;                                      //~5925I~
    private boolean Modified=false;                                        //~5925I~
    private String filename=null;                                  //~5925I~
///////////////////////////////////////////////////////////////////////////////~5925I~
                                                                   //~5925I~
public CDocument()                                                 //~5925I~
{   
	pwnp=wnp.awnp;                                                 //~5A07R~
}                                                                  //~5925I~
public boolean  OnNewDocument()                                    //~5929R~
{                                                                  //~5925I~
	pPattern= new CPattern();                                        //~5925I~
    filename=pPattern.Name;                                        //~5A06R~
	return true;                                                   //~5925I~
}                                                                  //~5925I~
                                                                   //~5925I~
public boolean  OnOpenDocument(View PView,String Pfilename,boolean Prestore)//~5A07R~
{                                                                  //~5A06M~
    if (!Prestore && Pfilename==null)                              //~5A07R~
    {                                                              //~5A06I~
    	JFileChooser fc=new JFileChooser();                        //~5A06R~
	    setupfc(fc);                                               //~5A06I~
        int rc=fc.showOpenDialog(pwnp);                            //~5A06I~
        if (rc!=JFileChooser.APPROVE_OPTION)                       //~5A06R~
        	return false;                                          //~5A06I~
		File fh=fc.getSelectedFile();                              //~5A06I~
        filename=fh.getPath();                                     //~5A06I~
        pwnp.fcCurrentDir=fc.getCurrentDirectory().getPath();      //~5A07R~
//System.out.println("file dlg rc="+rc+",file="+filename+",Dir="+pwnp.fcCurrentDir);//~5A13R~
    }                                                              //~5A06I~
    else                                                           //~5A06I~
        filename=Pfilename;                                        //~5A06I~
	pPattern=new CPattern();                                       //~5A06R~
	if (Serialize(filename,0)==0)	//read                         //~5A06R~
    {                                                              //~5A07I~
	    PView.OnUpdate(Prestore);	//update Cpattern & CreateBoard//~5A10R~
        if (!Prestore)    //not restore                            //~5A07R~
            pwnp.addMRUmenu(filename);  //input filename           //~5A07R~
    }                                                              //~5A07I~
	return true;                                                   //~5A06M~
}                                                                  //~5A06M~
                                                                   //~5A06M~
public boolean  OnSaveDocument()                                   //~5A06R~
{                                                                  //~5A06M~
    filename=pPattern.Name;                                        //~5A06I~
	if (Serialize(filename,1)!=0)	//write to current filename    //~5A06R~
    	return false;                                              //~5A06I~
    pwnp.addMRUmenu(filename);                                     //~5A07R~
	return true;                                                   //~5A06M~
}                                                                  //~5A06M~
public boolean  OnSaveAsDocument()                                 //~5A06R~
{                                                                  //~5A06M~
	String newname;                                                //~5A06I~
    JFileChooser fc=new JFileChooser();                            //~5A06I~
    setupfc(fc);                                                   //~5A06I~
    int rc=fc.showSaveDialog(pwnp);                                //~5A06R~
    if (rc!=JFileChooser.APPROVE_OPTION)                           //~5A06I~
    	return false;                                              //~5A06I~
	File fh=fc.getSelectedFile();                                  //~5A06I~
    newname=fh.getPath();                                          //~5A06R~
    pwnp.fcCurrentDir=fc.getCurrentDirectory().getPath();               //~5A07R~
//System.out.println("newname="+newname+",CurDir="+pwnp.fcCurrentDir);//~5A13R~
	String desc=fc.getFileFilter().getDescription();               //~5A06R~
    if (desc.equals(FILTER_DESC))	//append xnp                       //~5A06I~
    {                                                              //~5A06I~
        int pos = newname.lastIndexOf('.');                        //~5A06I~
                                                                   //~5A06I~
        String ext=null;                                           //~5A06I~
        if (pos > 0 &&  pos < newname.length() - 1)                //~5A06I~
        {                                                          //~5A06I~
            ext = newname.substring(pos+1).toLowerCase();   //~5A06I~
            if (!ext.equals(FILTER_EXT))                           //~5A06I~
            	ext=null;                                          //~5A06I~
        }                                                          //~5A06I~
        if (ext==null)                                             //~5A06I~
        	newname+="."+FILTER_EXT;                               //~5A06I~
    }                                                              //~5A06I~
//System.out.println("file dlg rc="+rc+",file="+newname+",desc="+desc+",dir="+fc.getCurrentDirectory().getPath());//~5A13R~
	if (Serialize(newname,1)!=0)	//write                        //~5A06R~
    	return false;                                              //~5A06I~
    pwnp.addMRUmenu(newname);                                      //~5A07I~
	return true;                                                   //~5A06M~
}                                                                  //~5A06M~
private void  setupfc(JFileChooser Pfc)                             //~5A06I~
{                                                                  //~5A06I~
	Pfc.addChoosableFileFilter(new xnpfilter());                    //~5A06R~
    if (pwnp.fcCurrentDir!=null)                                   //~5A07R~
    	Pfc.setCurrentDirectory(new File(pwnp.fcCurrentDir));      //~5A07R~
}                                                                  //~5A06I~
                                                                   //~5A06M~
///////////////////////////////////////////////////////////////////////////////~5925I~
                                                                   //~5925I~
int Serialize(String Pfilename,int Pwritesw)                       //~5A06R~
{   
	int rc=4;                                                       //~5A06I~
    //************************                                         //~5A06I~
	File Pfile=new File(Pfilename);                                //~5A06R~
    if (Pwritesw!=0)                                                  //~5A06I~
    {                                                              //~5A06I~
        try{                                                       //~5A06I~
    	    	FileWriter fw=new FileWriter(Pfilename);           //~5A06I~
    			pPattern.Serialize(fw,Pfile,Pwritesw);             //~5A06R~
                fw.close();                                        //~5A06I~
                rc=0;                                              //~5A06I~
        }                                                          //~5A06I~
        catch(IOException e)                                      //~5A06I~
        {                                                          //~5A06I~
			e.printStackTrace();                                   //~5A06I~
//System.out.println("Write IO exveption");                        //~5A13R~
          if (wnp.Sjlang)                                          //+va23I~
			JOptionPane.showMessageDialog(null,Pfilename+":o̓G[","NP", JOptionPane.ERROR_MESSAGE);//~5A06I~
          else                                                     //+va23I~
			JOptionPane.showMessageDialog(null,Pfilename+":Output failed","NP", JOptionPane.ERROR_MESSAGE);//+va23I~
        }                                                          //~5A06I~
        catch(Exception e)                                         //~5A06I~
        {                                                          //~5A06I~
              e.printStackTrace();                                 //~5A06I~
            if (wnp.Sjlang)                                        //+va23I~
              JOptionPane.showMessageDialog(null,Pfilename+":o̓G[","NP", JOptionPane.ERROR_MESSAGE);//~5A06I~
            else                                                   //+va23I~
              JOptionPane.showMessageDialog(null,Pfilename+":Output","NP", JOptionPane.ERROR_MESSAGE);//+va23I~
        }                                                          //~5A06I~
    }                                                              //~5A06I~
    else                                                           //~5A06I~
    {                                                              //~5A06I~
        try{                                                       //~5A06I~
    	    	FileReader fr=new FileReader(Pfilename);           //~5A06R~
    	    	BufferedReader br=new BufferedReader(fr);          //~5A06I~
//System.out.println("Read file="+Pfilename);                      //~5A13R~
    			pPattern.Serialize(br,Pfile,Pwritesw);             //~5A06R~
                br.close();                                        //~5A06R~
                rc=0;                                              //~5A06I~
        }                                                          //~5A06I~
        catch(FileNotFoundException e)                            //~5A06I~
        {                                                          //~5A06I~
//		e.printStackTrace();                                   //~5A06I~
//System.out.println("Not found IO exveption");                    //~5A13R~
          if (wnp.Sjlang)                                          //+va23I~
			JOptionPane.showMessageDialog(null,Pfilename+"܂","NP", JOptionPane.ERROR_MESSAGE);//~5A06I~
          else                                                     //+va23I~
			JOptionPane.showMessageDialog(null,Pfilename+" not Found","NP", JOptionPane.ERROR_MESSAGE);//+va23I~
        }                                                          //~5A06I~
        catch(IOException e)                                      //~5A06I~
        {                                                          //~5A06I~
//			e.printStackTrace();                                   //~5A06I~
//System.out.println("Read IO exveption");                         //~5A13R~
          if (wnp.Sjlang)                                          //+va23I~
			JOptionPane.showMessageDialog(null,Pfilename+":̓G[","NP", JOptionPane.ERROR_MESSAGE);//~5A06R~
          else                                                     //+va23I~
			JOptionPane.showMessageDialog(null,Pfilename+":Input failed","NP", JOptionPane.ERROR_MESSAGE);//+va23I~
        }                                                          //~5A06I~
        catch(Exception e)                                         //~5A06I~
        {                                                          //~5A06I~
            e.printStackTrace();                                   //~5A06I~
          if (wnp.Sjlang)                                          //+va23I~
        	JOptionPane.showMessageDialog(null,Pfilename+":̓G[","NP", JOptionPane.ERROR_MESSAGE);//~5A06I~
          else                                                     //+va23I~
        	JOptionPane.showMessageDialog(null,Pfilename+":Input failed","NP", JOptionPane.ERROR_MESSAGE);//+va23I~
        }                                                          //~5A06I~
    }                                                              //~5A06I~
    return rc;                                                     //~5A06R~
}                                                                  //~5925I~
                                                                   //~5925I~
public void  OnUpdateFileSave()                                    //~5929R~
{                                                                  //~5925I~
    pwnp.Save.setEnabled(pPattern.ChkData());                     //~5925R~
//  pwnp.ButtonSave.setEnabled(pPattern.ChkData());                //~va01R~
}                                                                  //~5925I~
                                                                   //~5925I~
public void  OnUpdateFileSaveAs()                                  //~5929R~
{                                                                  //~5925I~
    pwnp.Saveas.setEnabled(pPattern.ChkData());                   //~5925I~
                                                                   //~5925I~
}                                                                  //~5925I~
public void SetModifiedFlag(boolean modflg)                                          //~5925I~
{                                                                  //~5925I~
    Modified=modflg;                                                    //~5925I~                                                                 //~5925I~
}  
public boolean GetModified()                                          //~5925I~
{                                                                  //~5925I~
    return Modified;                                                    //~5925I~                                                                 //~5925I~
}     //~5925I~
public String GetPathName()                                        //~5925I~
{                                                                  //~5925I~
    return filename;                                               //~5925I~
                                                                   //~5925I~
}                                                                  //~5925I~
public void SetPathName(String Ppathname)                          //~5925I~
{                                                                  //~5925I~
    filename=Ppathname;                                            //~5925I~
                                                                   //~5925I~
}                                                                  //~5925I~
public class xnpfilter extends FileFilter {                        //~5A06I~
                                                                   //~5A06I~
    public boolean accept(File f) {                                //~5A06I~
        if (f.isDirectory()) {                                     //~5A06I~
            return true;                                           //~5A06I~
        }                                                          //~5A06I~
                                                                   //~5A06I~
        String ext=f.getName();       
        int pos = ext.lastIndexOf('.');

        if (pos > 0 &&  pos < ext.length() - 1)
        {
            ext = ext.substring(pos+1).toLowerCase();//~5A06I~
            if (ext.equals(FILTER_EXT))                            //~5A06R~
            	return true;                                       //~5A06I~
        }                                                          //~5A06I~
        return false;                                              //~5A06I~
    }                                                              //~5A06I~
    //The description of this filter                               //~5A06I~
    public String getDescription() {                               //~5A06I~
        return FILTER_DESC; // "xnp files";                        //~5A06R~
    }                                                              //~5A06I~
}//class xnpfilter                                                 //~5A06I~
}//class CDocument                                                 //~5A06R~
