//CID://+va23R~:                                                   //~va23R~
//*****************************************************************//~v012I~
//va23:051221 langauge ctl(English and japanese)                   //~va23I~
//va17:051113 reverse by rbutton on num button                     //~va17I~
//va01:051013 5*5 support                                          //~va01I~
//v012:051004 dosenot write answer when in solving                 //~v012I~
//*****************************************************************//~v012I~
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Timer;

public class View implements ActionListener{                                                 //~5921I~
                                                                 //~5921I~
private static final boolean TRUE=true;                            //~5924I~
private static final boolean FALSE=false;                          //~5924I~
public static  Board aBoard=null;                                  //~5922I~
//    CWnpmfcDoc* GetDocument();                                   //~5921I~
private   CPattern pPattern;                                      //~5921R~
private   ButtonDlg  pButtonDlg;                                  //~5921I~
private   boolean        BtnStatus;
private   int            ElapsedTime;                              //~5923I~
private  Clientpanel pCP;                                          //~5927R~
private  wnp pwnp=null;                                            //~5925R~
//private  int Soldnum=-1,num;                                     //~v010R~
public   CDocument pDoc;                                           //~5929R~

/*===================================================================//~9C25I~
===================================================================*///~9C25I~
//                                                                 //~5921R~
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
public  View(Clientpanel cp,wnp Pwnp)                              //~5925R~
{
    /*                                                             //~9C25I~
    -----------------------------------------------------------    //~9C25I~
    -----------------------------------------------------------*/  //~9C25I~
    pCP=cp;                                                        //~5927R~
    pwnp=Pwnp;                                                     //~5925R~
    aBoard=new Board(this);                                        //~5922R~
    ElapsedTime=0;                                                 //~5923I~
    aBoard.SetNum(1,this);                                         //~5923R~
    pDoc=new CDocument();                                           //~5926I~
    pDoc.OnNewDocument();                                          //~5926I~
	OnCreate();                                                    //~5927I~
	OnUpdate(true);	//craete board from pattern                    //~v012R~
}

//public void ~CWnpmfcView()                                       //~5921R~
//{                                                                //~5921R~
//}                                                                //~5921R~

/////////////////////////////////////////////////////////////////////////////

public void OnDraw(Graphics g)                                     //~5926R~
{

//System.out.println("View:OnDraw");                               //~v012R~
    ShowMovement();                                                //~0101R~
    aBoard.Show(g);                                                //~5926R~
                                                                   //~0102I~
    DrawPatternName(g);                                      //~0102I~
                                                                   //~0102I~

}

/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////

private int OnCreate()                //~5921R~
{
                                         //~9C31M~
    OpenBtnDlg();                                                   // <---//~9C31M~

	return 0;
}


                                                                   //~9C28I~
private void EnableNumButton(boolean enable)                       //~5921R~
{                                                                  //~0101I~
	if (BtnStatus==enable)                                         //~0102I~
    	return;                                                    //~0102I~
	BtnStatus=enable;                                              //~0102I~
    pCP.BtnNum0.setEnabled(enable);                                //~5927R~
    pCP.BtnNum1.setEnabled(enable);                                //~5927R~
    pCP.BtnNum2.setEnabled(enable);                                //~5927R~
    pCP.BtnNum3.setEnabled(enable);                                //~5927R~
    pCP.BtnNum4.setEnabled(enable);                                //~5927R~
    pCP.BtnNum5.setEnabled(enable);                                //~5927R~
    pCP.BtnNum6.setEnabled(enable);                                //~5927R~
    pCP.BtnNum7.setEnabled(enable);                                //~5927R~
    pCP.BtnNum8.setEnabled(enable);                                //~5927R~
    pCP.BtnNum9.setEnabled(enable);                                //~5927R~
    if (wnp.BOARDTYPE>=wnp.BOARDTYPE4)                             //~va01I~
    {                                                              //~va01I~
	    pCP.BtnNum10.setEnabled(enable);                           //~va01I~
        pCP.BtnNum11.setEnabled(enable);                           //~va01I~
        pCP.BtnNum12.setEnabled(enable);                           //~va01I~
        pCP.BtnNum13.setEnabled(enable);                           //~va01I~
        pCP.BtnNum14.setEnabled(enable);                           //~va01I~
        pCP.BtnNum15.setEnabled(enable);                           //~va01I~
        pCP.BtnNum16.setEnabled(enable);                           //~va01I~
    }                                                              //~va01I~
    if (wnp.BOARDTYPE>=wnp.BOARDTYPE5)                             //~va01I~
    {                                                              //~va01I~
	    pCP.BtnNum17.setEnabled(enable);                           //~va01I~
        pCP.BtnNum18.setEnabled(enable);                           //~va01I~
        pCP.BtnNum19.setEnabled(enable);                           //~va01I~
        pCP.BtnNum20.setEnabled(enable);                           //~va01I~
        pCP.BtnNum21.setEnabled(enable);                           //~va01I~
        pCP.BtnNum22.setEnabled(enable);                           //~va01I~
        pCP.BtnNum23.setEnabled(enable);                           //~va01I~
        pCP.BtnNum24.setEnabled(enable);                           //~va01I~
        pCP.BtnNum25.setEnabled(enable);                           //~va01I~
    }                                                              //~va01I~
}                                                                  //~0101I~
                                                                   //~0101I~
private void ShowMovement()                                        //~5921R~
{
    /*                                                             //~0110M~
    ----------------------------------------------------           //~0110M~
    ----------------------------------------------------*/         //~0110M~
    String s;                                                      //~5921R~
    if ((aBoard.Flags & Board.F_THREAD)!=0)	//in waiting make thread       //~0110I~
    {                                                              //~0110I~
        long ctime=System.currentTimeMillis();                        //~0110I~
        long span=ctime-aBoard.StartTime;                     //~0110I~
      if (wnp.Sjlang)                                              //~va23I~
        s=span/1000+" bo";              //~0110I~
      else                                                         //~va23I~
        s=span/1000+" sec elapsed";                                //~va23I~
	}                                                              //~0110I~
    else                                                           //~0110I~
    	if (((aBoard.Flags & Board.F_MODEMAKE)!=0) && aBoard.GetMode()==Board.MODE_ENDQDATA)//~0129R~
         if (wnp.Sjlang)                                           //~va23I~
    		s=" "+pPattern.Seed;                   //~0129R~
         else                                                      //~va23I~
    		s="Prob "+pPattern.Seed;                               //~va23I~
        else                                                       //~0129I~
         if (wnp.Sjlang)                                           //~va23I~
    		s="c"+(wnp.PEG_MAX-aBoard.GetPath())+"";      //~0129R~
         else                                                      //~va23I~
    		s=(wnp.PEG_MAX-aBoard.GetPath())+" remain";            //~va23R~

    wnp.LabelStatus1.setText(s);                                     //~0101R~
                                                                   //~0101I~
    String smsg=aBoard.GetMsg();                                  //~0101I~
    wnp.LabelStatus2.setText(smsg);                                  //~0101I~
                                                                 //~0110I~
}



/*                                                                 //~9C25I~
=======================================================================//~9C25I~
     CWnpmfcView::OpenBtnDlg                                <--- ֐̒ǉ//~9C25R~
=======================================================================//~9C25I~
=======================================================================*///~9C25I~
private void  OpenBtnDlg()                                         //~5921R~
{                                                                  //~9C25I~
    pButtonDlg = new ButtonDlg( this,aBoard );                   //~9C25I~
//  pButtonDlg.Create();                                          //~9C25I~
//  pButtonDlg.ShowWindow( SW_SHOW );                             //~9C25I~
    Dimension rp;
    Point pt=pwnp.getLocation();//~9C31I~
    rp=pwnp.getSize();  //get window pos of parent                 //~5927R~
    pt.x+=rp.width;                                                //~5927R~
    pt.y+=wnp.TOOLBAR_HEIGHT; 
    pButtonDlg.setLocation(pt);
    pButtonDlg.show();
   
}                                                                  //~9C25I~
/*                                                                 //~9C25I~
=======================================================================//~9C25I~
     CWnpmfcVieww::CloseBtnDlg                               <--- ֐̒ǉ//~9C25R~
=======================================================================//~9C25I~
=======================================================================*///~9C25I~
//private void    CloseBtnDlg()                                      //~5921R~
//{                                                                  //~9C25I~
//    if (pButtonDlg==null)                                               //~9C31I~
//    	return;                                                    //~9C31I~
//    pButtonDlg.DestroyWindow();                                   //~9C25I~
//    pButtonDlg = null;                                             //~9C25I~
//}                                                                  //~9C25I~
/*                                                                 //~9C25I~
=======================================================================//~9C25I~
=======================================================================*///~9C25I~
private void OnNum0()                                              //~5921R~
{                                                                  //~9C25I~
    aBoard.SetNum(0,this);           //force                       //~5923I~
    SetPegCursor(0);                                               //~9C25I~
//    SetFocus();                                                    //~5923I~
}                                                                  //~9C25I~
private void OnNumx(int Pbtnno)                                    //~v012I~
{                                                                  //~v012M~
    SetPegCursor(Pbtnno);                                          //~v012I~
}                                                                  //~v012I~

//=======================================================================*///~9C25I~
private void SetPegCursor(int Pnum)                                //~5924R~
{                                                                  //~9C25I~
	int num=Pnum;                                                  //~v010R~
	if ((aBoard.Flags & Board.F_MODEMAKE)!=0)                            //~5924R~
    	num=0;                                                     //~5923I~
//  if (num==Soldnum)                                              //~v010R~
//  	return;                                                    //~v010R~
	if (Pnum!=0)                                                      //~5923I~
		aBoard.SetNum(Pnum,null);                                     //~5923I~
//  pwnp.BGpaneFG.setCursor(pwnp.cursortbl[num]);                  //~va23R~
    pCP.setCursor(pwnp.cursortbl[num]);			                   //~va23R~
}                                                                  //~9C25I~
//=======================================================================*///~9C25I~
private void OnAnswer()                                            //~5921R~
{                                                                  //~0101I~
	ElapsedTime=0;                                                 //~5923I~
	aBoard.OnAnswer();                                             //~0101I~
    BtnProc();                                                     //~0101I~
}                                                                  //~0101I~
public void OnMake()                                               //~5925R~
{	                                                               //~0101I~
	ElapsedTime=0;                                                 //~5923I~
	aBoard.OnMake();                                               //~0101I~
    BtnProc();                                                     //~0101I~
}                                                                  //~0101I~
private void OnRchk()                                              //~5921R~
{                                                                  //~0101I~
	aBoard.OnRchk(0);                                              //~0122R~
    BtnProc();                                                     //~0101I~
}                                                                  //~0101I~
private void OnNext()                                              //~5921R~
{                                                                  //~0101I~
	aBoard.OnNext(0);                                              //~0122R~
    BtnProc();                                                     //~0101I~
}                                                                  //~0101I~
private void OnGo(){                                               //~5921R~
	aBoard.OnGo(0);                                                //~0122R~
    BtnProc();                                                     //~0101I~
    pDoc.SetModifiedFlag(true);                                    //~v012I~
}                                                                  //~0101I~
public void OnEndThread(){                                        //~5921R~
int rc;                                                            //~5923I~
	rc=aBoard.OnEndThread();                                       //~5923R~
    if (rc!=0)			//make normal end                              //~5923I~
		OnAnswer();                                                //~5923I~
    BtnProc();                                                     //~0109I~
}                                                                  //~0109I~
private void OnTimer(ActionEvent e) {                              //~5924R~
	ElapsedTime=aBoard.OnTimer(e);                                  //~5924R~
    BtnProc();                                                     //~0109I~
}                                                                  //~0109I~
private void OnSetend()                                            //~5921R~
{                                                                  //~0101I~
    ElapsedTime=0;                                                 //~5923I~
	aBoard.OnSetend(0);                                            //~0130R~
    BtnProc();                                                     //~0101I~
}                                                                  //~0101I~
private void OnSort()                                              //~5921R~
{                                                                  //~0130I~
	if (aBoard.OnSort())	//success                              //~5923I~
    	GetDocument().SetModifiedFlag(true);//avoid popup           //~5923I~
    BtnProc();                                                     //~0130I~
}                                                                  //~0130I~
private void OnStop()                                              //~5921R~
{                                                                  //~0110I~
	aBoard.OnStop();                                               //~0110I~
    BtnProc();                                                     //~0110I~
}                                                                  //~0110I~
private void OnClear()                                             //~5921R~
{                                                                  //~9C25I~
	ElapsedTime=0;                                                 //~5923I~
    aBoard.OnClear();                                                //~9C31I~
    BtnProc();                                                     //~0101I~
    pDoc.SetModifiedFlag(true);                                    //~v012I~
}                                                                  //~9C25I~
private void OnRestore()                                           //~5921R~
{                                                                  //~0123I~
    CDocument pdoc=GetDocument();                                  //~5924R~
//    pPattern->RestoreOrgData();         //restore original data  //~0129R~
//    aBoard.CreateBoard(pPattern);                                //~0129R~
    pdoc.SetModifiedFlag(FALSE);//avoid popup             //~5924R~
    String str=pdoc.GetPathName();	//current filename             //~5924R~
//  pdoc.SetPathName("c:\\xnpdmy");	//avoid bypass by the reason alraedy open//~v012R~
    pdoc.OnOpenDocument(this,str,true); //true:restore	           //~v012R~
    BtnProc();                                                     //~0123I~
}                                                                  //~0123I~
//=======================================================================*///~0101M~
private void BtnProc()                                             //~5921R~
{                                                                  //~0101M~
    pButtonDlg.SetDlgBtn();		//set Clear btn status             //~5924R~
	boolean numbtnon=aBoard.ShowNumBtn();                              //~0101R~
//System.out.println("BtnProc ShowNumBtn rc="+(numbtnon?1:0));     //~va01R~
	EnableNumButton(numbtnon);                                     //~0110R~
    if (!numbtnon)			//button disable                       //~0101I~
		SetPegCursor(0);                                            //~0101I~
    else                                                           //~5923I~
		SetPegCursor(aBoard.GetNum());                             //~5923I~
    Invalidate( FALSE );                                           //~0101M~
}	                                                               //~0101M~
//=======================================================================*///~5927I~
public void OnLButtonDown(int nFlags, Point point)                 //~5927R~
{                                                                  //~9C28I~
	if (aBoard.DropDown(point,-1))                                 //~0102R~
    	pButtonDlg.SetDlgBtn();		//set Clear btn status         //~5924R~
    if (GetDocument().pPattern.GetModified()!=0) //chk data modified  //~5924R~
        GetDocument().SetModifiedFlag(true);   //notify doc updated    //~5924R~
                                                                   //~0123I~
                             //~9C30I~
    Invalidate( FALSE );                                           //~9C31I~
}                                                                  //~9C28I~
//=======================================================================*///~5923I~
public void OnRButtonDown(int nFlags, Point point)                 //~5927R~
{                                                                  //~5923I~
	boolean rc;                                                       //~5923I~
//**********************                                           //~5923I~
	rc=aBoard.SetMemo(point,-1);	//by mouse                     //~5923I~
                          //~5923I~
    if (rc)		//need invalidate                                  //~5923I~
    	Invalidate( FALSE );                                       //~5923I~
}                                                                  //~5923I~
//=======================================================================*///~v010I~
public void OnMouseWheel(int Pdest)                                //~v010I~
{                                                                  //~v010I~
	int btnnum=aBoard.GetNum();                                    //~v010I~
    if (Pdest>0)   //forward                                       //~v010I~
        btnnum++;                                                  //~v010I~
    else                                                           //~v010I~
        btnnum--;                                                  //~v010I~
    if (btnnum<0)                                                  //~v010I~
        btnnum=wnp.MAP_SIZE;                                       //~v012R~
    else                                                           //~v010I~
        if (btnnum==wnp.MAP_SIZE+1)                                //~va01R~
        	btnnum=0;                                              //~v010I~
    if (btnnum==0)                                                 //~v010I~
		OnNum0();                                                  //~v010I~
    else                                                           //~v010I~
	    SetPegCursor(btnnum);                                      //~v010I~
}                                                                  //~v010I~
                                                                 //~9C30I~
//private boolean OnSetCursor(int nHitTest,int message)  //~5924R~
//{                                                                  //~9C30I~
//	SetPegCursor(aBoard.GetNum());                                 //~9C30I~
//	return TRUE;                                                   //~9C30I~
//}                                                                  //~9C30I~
                                                                   //~9C30I~
public  void OnUpdate(boolean Prestoresw)                          //~v012R~
{
	pPattern=GetDocument().pPattern;                               //~5924R~
		aBoard.CreateBoard(pPattern);                              //~v012R~
    	BtnProc();                                                 //~v012R~
    if (Prestoresw)                                                //~v012R~
    	aBoard.ActSeed=pPattern.Seed;	//from read file           //~v012I~
}
private void DrawPatternName(Graphics pDC)                             //~5921R~
{                                                                  //~0102I~
	String pno;                                             //~5923I~
    if (aBoard.ActSeed!=0)                                            //~5923I~
		pno=" (#"+aBoard.ActSeed+")";                      //~5923I~
    else                                                           //~5923I~
    	pno="";                                                 //~5923I~
    if (ElapsedTime!=0)                                               //~5923I~
    {                                                              //~5923I~
    	int ss=ElapsedTime%60;                                     //~5923I~
    	int mm=ElapsedTime/60;                                     //~5923I~
        if (ss!=0)                                                    //~5923I~
            mm++;                                                  //~5923I~
      if (wnp.Sjlang)                                              //~va23I~
    	pno=pno+" "+mm+"o";                   //~5923I~
      else                                                         //~va23I~
    	pno=pno+" "+mm+"min";                                      //+va23R~
	}                                                              //~5923I~
    if (aBoard.Score!=0)                                              //~5923I~
    	pno=pno+",Score:"+aBoard.Score+"/"+aBoard.ScoreMax;//~5923I~
    else                                                           //~5923I~
    	if (aBoard.ScoreMax!=0)                                       //~5923I~
    		pno=pno+",MaxScore:"+aBoard.ScoreMax;   //~5923I~
	String str=GetDocument().pPattern.Name;                        //~v012R~
    int pos=str.lastIndexOf(System.getProperty("file.separator")); //~v012R~
    if (pos>0)                                                     //~v012I~
    	str=str.substring(pos+1);                                  //~v012I~
	str="Name["+str+"]"+pno;                                       //~v012I~
                //~5924R~
//  pDC.setColor(new Color(0,0,0));                                //~5927R~
//	pDC.SetBkMode(TRANSPARENT);                                    //~5924R~
//  pDC.drawString(str,wnp.NAME_POSX,wnp.NAME_POSY);               //~5927R~
    pCP.LabelFilename.setText(str);                                //~5927I~
                                                                   //~0130I~
                              //~5924R~
//  pDC.drawString(aBoard.sProbLevel,wnp.LEVEL_POSX,wnp.NAME_POSY);//~5927R~
    pCP.LabelLevel.setText(aBoard.sProbLevel);                     //~5927I~
//  pDC.setColor(Board.COL_TXT_SIGN);                              //~5927R~
//  str="          By "+wnp.MY_SIGN;                               //~5927R~
//  pDC.drawString(str,wnp.SIGN_POSX,wnp.SIGN_POSY);               //~5927R~
                                 //~5924R~
}                                                                  //~0102I~
//CFont GetMemoFont()                                            //~5924R~
//{                                                                  //~5923I~
//	return MemoFont;                                               //~5924R~
//}                                                                  //~5923I~

public void OnKeyDown(int nChar,int nRepCnt,int nFlags)            //~5929R~
{
                                               //~0102M~
    int rc;                                                    //~5923I~
    if (aBoard.GetKbFocus()<0)	//no forcus                        //~5923R~
    {                                                              //~0102M~
      if (wnp.Sjlang)                                              //~va23I~
    	aBoard.SetTempMsg("}EXŃL[͈ʒuw肵Ă");//~0102M~
      else                                                         //~va23I~
    	aBoard.SetTempMsg("specify keyboard focus by mouse");      //~va23I~
	    Invalidate( FALSE );                                       //~0102M~
    	return;                                                    //~0102M~
    }                                                              //~0102M~
//System.out.println("keydown char="+nChar+",flag="+nFlags);       //~va17R~
	rc=aBoard.KeyProc(nChar);                                      //~5923I~
    if (rc==-1)		//no samenum status changed                    //~5923I~
        return;                                                    //~5923I~
	if (rc!=0)	//reset dlg btn status                                 //~5923I~
    	pButtonDlg.SetDlgBtn();		//set Clear btn status         //~5924R~
    Invalidate( FALSE );                                           //~0102M~
}
//=======================================================================*///~5923I~
public void OnKeyUp(int nChar, int nRepCnt, int nFlags)            //~5929R~
{                                                                  //~5923I~
//System.out.println("keyup char="+nChar+",flag="+nFlags);         //~va17R~
    if (aBoard.KeyUpProc(nChar))                                   //~5923I~
    	Invalidate(FALSE);                                         //~5923I~
}                                                                  //~5923I~
//=======================================================================*///~5923I~
//void OnParentNotify(int Pid,LPARAM pParm)                         //~5924R~
//{                                                                  //~5923I~
//	if ((Pid & 0xffff)!=WM_RBUTTONDOWN)                            //~5923I~
//		return;                                                    //~5923I~
//	NumRButton(Point(pParm));                                     //~5923I~
//	return;                                                        //~5923I~
//}                                                                  //~5923I~
//=======================================================================*///~5923I~
//=rbutton on Num button-->set same num                            //~5923I~
//=rc:1:redraw required 0:out of interest                          //~5923I~
//=======================================================================*///~5923I~
void NumRButton(int Pnum)                                          //~va17R~
{                                                                  //~va17R~
    aBoard.SetSameNum(-Pnum);     //samenum display                //~va17R~
    Invalidate( FALSE );                                           //~va17R~
    return;     //redraw                                           //~va17R~
}                                                                  //~va17R~

public void actionPerformed(ActionEvent e) {
	if (e.getSource() instanceof Timer)                            //~5924I~
    {                                                              //~5924I~
    	OnTimer(e);                                                //~5924I~
    }                                                              //~5924I~
    else                                                           //~5924I~
    {                                                              //~5924I~
        String cmd=e.getActionCommand();                           //~5924R~
        if (cmd.substring(0,3).equals("Num"))                      //~v012I~
        {	                                                       //~v012I~
        	int btnno=Integer.parseInt(cmd.substring(3));          //~v012I~
            if (btnno==0)                                          //~v012I~
	            OnNum0();                                          //~v012I~
            else                                                   //~v012I~
	            OnNumx(btnno);                                     //~v012I~
        }                                                          //~v012I~
    }                                                              //~v012M~
	pwnp.requestFocus();	//get kbd forcus to get kbd event	   //~va17R~
}
void Invalidate(boolean Opt){                                                 //~5924I~
	pCP.repaint();                                                 //~5927R~
}                                                                  //~5924I~
CDocument GetDocument(){                                    //~5924I~
	return pDoc;                                                   //~5924I~
}                                                                  //~5924I~
public void Dlgreq(int msgid){                                     //~5925R~
//	int msgid=Ppostmsgid.intValue();                               //~5925R~
	switch(msgid){                                                 //~5925R~
    case Board.IDC_GO:                                                   //~5925I~
    	OnGo();                                                    //~5925I~
    	break;                                                     //~5925I~
	case Board.IDC_STOP:                                                 //~5925I~
    	OnStop();                                                  //~5925I~
    	break;                                                     //~5925I~
	case Board.IDC_RCHK:                                                 //~5925I~
    	OnRchk();                                                  //~5925I~
    	break;                                                     //~5925I~
	case Board.IDC_NEXT:                                                 //~5925I~
    	OnNext();                                                  //~5925I~
    	break;                                                     //~5925I~
	case Board.IDC_CLEAR:                                                //~5925I~
    	OnClear();                                                 //~5925I~
    	break;                                                     //~5925I~
	case Board.IDC_RESTORE:                                              //~5925I~
    	OnRestore();                                               //~5925I~
    	break;                                                     //~5925I~
	case Board.IDC_SETEND:                                               //~5925I~
    	OnSetend();                                                //~5925I~
    	break;                                                     //~5925I~
	case Board.IDC_SORT:                                                 //~5925I~
    	OnSort();                                                  //~5925I~
    	break;                                                     //~5925I~
    }                                                              //~5925I~
}//Dlgreq                                                          //~5925I~

}//class View                                                      //~5921I~
