//CID://+va23R~:                                                   //+va23R~
//*****************************************************************//~va01I~
//va23:051221 langauge ctl(English and japanese)                   //+va23I~
//va01:051013 5*5 support                                          //~va01I~
//*****************************************************************//~va01I~
import java.awt.Point;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.jar.JarFile;
import java.util.zip.ZipEntry;

import javax.swing.JOptionPane;

public class Wnpctl {                                             //~5A04R~
static private final String WNP_PROP0="wnp.prop0";                 //~5A13I~
	private	ButtonDlg pParent;                                     //~5925I~
    private	Wnpctlsub pPswdDlg;                                      //~5925I~
 
	private String file0,file1;                                    //~5A12R~
	private long ts0,ts1;                                          //~5A12I~
    int  execjarsw=0;                                              //~5A13I~
    URL file0url;                                                  //~5A13I~
//=======================================================================//~5925I~
public Wnpctl(ButtonDlg p_parent)                                 //~5A04R~
{                                                                  //~5925I~
	pParent=p_parent;                                              //~5925I~
}                                                                  //~5925I~
//=======================================================================//~5925I~
//=rc 0:pswd ok,-1:waiting pswd input,1:dialog issed now,4:pswd err//~5925I~
//=======================================================================//~5925I~
public int  CheckCtl()                                             //~5A13R~
{                                                                  //~5925I~
	int rc;                                                        //~5A12R~
    Point pt;                                                      //~5A05I~
    String inputstr,cp;                                            //~5A12R~
//*********************                                            //~5925I~
	cp=wnp.class.getResource("wnp.class").getPath();               //~5A12M~
//System.out.println("resource="+cp);                              //~va01R~
    file0=getfile0name(cp);                                        //~5A12M~
    if (file0==null)                                           //~5A13I~
    {                                                              //~5A13I~
      if (wnp.Sjlang)                                              //+va23I~
		JOptionPane.showMessageDialog(pParent,"jar̂܂܎sĂB\n(java -jar wnp.jar)","NP",JOptionPane.ERROR_MESSAGE);//~5A28R~
      else                                                         //+va23I~
		JOptionPane.showMessageDialog(pParent,"execute jar itself\n(java -jar wnp.jar)","NP",JOptionPane.ERROR_MESSAGE);//+va23I~
    	System.exit(16);                                           //~5A13I~
    }                                                              //~5A13I~
    file1=getfile1name(cp);                                        //~5A12M~
//System.out.println("filename0="+file0+",filename1="+file1);      //~5A13R~
	ts0=getfile0ts(file0);                                      //~5A13I~
    if (ChkFile1()==0)   //pswd file chk                           //~5A12R~
    	return 0;		//pswd ok                                  //~5925I~
    pPswdDlg = new Wnpctlsub(pParent);                                  //~5A05R~
                                                                   //~5A05I~
    pt=pParent.getLocation();                                      //~5A05I~
    pt.y+=40;                                                      //~5A05I~
    pPswdDlg.setLocation(pt);                                      //~5A05I~
                                                                   //~5A05I~
    pPswdDlg.show();                                               //~5A05R~
    inputstr=pPswdDlg.Pswddlginput;                                //~5A12R~
    pPswdDlg=null;	//for gc//~5A05I~
    if (inputstr==null)                                            //~5A13I~
    	inputstr="";                                               //~5A13I~
    rc=ChkFile0(inputstr);                                        //~5A12R~
    if (rc==0)                                                     //~5A13R~
    {                                                              //~5A13I~
      if (wnp.Sjlang)                                              //+va23I~
		JOptionPane.showMessageDialog(pParent,"pX[h͂󂯕t܂B\nӁFsςƍē͂KvɂȂ邱Ƃ܂B",//~5A13I~
						"NP", JOptionPane.INFORMATION_MESSAGE);    //~5A13I~
      else                                                         //+va23I~
		JOptionPane.showMessageDialog(pParent,"password accepted\nNote:it may be requested again by environment change.",//+va23I~
						"NP", JOptionPane.INFORMATION_MESSAGE);    //+va23I~
    	updatefile();                                              //~5A13I~
    }                                                              //~5A13I~
    else                                                           //~5A13I~
    {                                                              //~5A12I~
      if (wnp.Sjlang)                                              //+va23I~
		JOptionPane.showMessageDialog(pParent,"pX[ȟł","NP", JOptionPane.ERROR_MESSAGE);//~5A13I~
      else                                                         //+va23I~
		JOptionPane.showMessageDialog(pParent,"Invalid password","NP", JOptionPane.ERROR_MESSAGE);//+va23I~
    	try {
			Thread.sleep(60000);                                   //~5A13R~
		} catch (InterruptedException e) {
	
			e.printStackTrace();
		}	//1min                             //~5A12I~
    }                                                              //~5A12I~
    return rc;			//pswd err                                 //~5A05R~
}                                                                  //~5925I~
//=======================================================================//~5925I~

//=======================================================================//~5925I~
// chk file1 data==enc(path,ts1+ts0)                               //~5A13R~
//=======================================================================//~5A12I~
int  ChkFile1()                                                    //~5A12R~
{                                                                  //~5925I~

    File File1;                                              //~5A12I~
    long f1data,encdata;                                           //~5A13R~
//*******************************************************          //~5A04I~
	File1=new File(file1);                                         //~5A12I~
    if (!(File1.exists() && File1.isFile()))                       //~5A12I~
    	return 4;                                                  //~5A12I~
    ts1=File1.lastModified();                                      //~5A12M~
//System.out.println("chkfile1:get last modified file1="+file1+"="+Long.toHexString(ts1));//~5A13R~
	f1data=getfiledata(file1);                                     //~5A12I~
	encdata=encript(file1,ts1+ts0);                                //~5A13R~
//System.out.println("file1 enc data="+Long.toHexString(encdata)); //~5A13R~
	if (f1data!=encdata)                                           //~5A13R~
        return 4;                                                  //~5A12M~
    return 0;		//pswd already chked                           //~5A12M~
}//chkfile1                                                        //~5A12M~
//=======================================================================//~5A05I~
// chk file0 data==enc(pswd,ts0)                                   //~5A12I~
//=======================================================================//~5A12I~
int  ChkFile0(String Pinputpswd)                                      //~5A12R~
{                                                                  //~5A05I~

    long file0data;                                                //~5A12I~
//*******************************************************          //~5A05I~
   	file0data=getfile0data();                                      //~5A13R~
//System.out.println("inputpswd="+Pinputpswd+",file0data="+Long.toHexString(file0data));//~5A13R~
//System.out.println("encinput pswd="+Long.toHexString(encript(Pinputpswd,ts0)));//~5A13R~
	if (file0data==0)
		return 4;
	if (encript(Pinputpswd,ts0)!=file0data)	//input pswd ok        //~5A12I~
    	return 4;                                                  //~5A12I~
//    System.out.println("input pswd ok");                         //~5A13R~
	return 0;                                                      //~5A12R~
}                                                                  //~5A05I~
//=======================================================================//~5925I~
//*****************************************************            //~5A12I~
//*gen property filename                                           //~5A12I~
//*****************************************************            //~5A12I~
private String getfile0name(String Ppath)                          //~5A12I~
{                                                                  //~5A12I~
	int pos;                                                       //~5A12I~
    String fnm,jarnm;                                              //~5A13I~
//******************************                                   //~5A12I~
//System.out.println("resource="+Ppath);                           //~va01R~
	file0url=wnp.class.getResource(WNP_PROP0);                     //~5A13I~
    if (file0url==null)                                             //~5A29I~
    {                                                              //~5A29I~
    	if (Ppath.indexOf("!")<0)                                    //~va01I~
	        return null;                                           //~va01I~
      if (wnp.Sjlang)                                              //+va23I~
		JOptionPane.showMessageDialog(pParent,"jar܂B","NP",JOptionPane.ERROR_MESSAGE);//~5A29I~
      else                                                         //+va23I~
		JOptionPane.showMessageDialog(pParent,"incorrect jar","NP",JOptionPane.ERROR_MESSAGE);//+va23I~
    	System.exit(16);                                           //~5A29I~
    }                                                              //~5A29I~
//System.out.println(WNP_PROP0+"resource="+file0url+",path="+file0url.getPath());//~va01R~
    String protocol=file0url.getProtocol();                        //~5A13I~
    fnm=file0url.getFile();                                        //~5A13I~
//System.out.println("protocol="+protocol+",filename="+fnm);       //~va01R~
    if (!protocol.equals("jar"))                                   //~5A13I~
    {                                                              //~5A13I~
//      return fnm.substring(5).replace("wnp.class",WNP_PROP0);    //~va01R~
        return null;                                               //~va01R~
    }                                                              //~5A13I~
    pos=fnm.indexOf("!");                                          //~5A13I~
    if (pos<0)                                                     //~5A13I~
        return null;                                               //~5A13I~
    execjarsw=1;                                                   //~5A13I~
    jarnm=fnm.substring(5,pos);                                    //~5A13I~
//System.out.println("jarnm="+jarnm);                              //~va01R~
    return jarnm;                                                  //~5A13I~
}                                                                  //~5A12I~
//*****************************************************            //~5A13I~
//*get file0 timestamp                                             //~5A13I~
//*****************************************************            //~5A13I~
private long getfile0ts(String Pjarname)                           //~5A13I~
{                                                                  //~5A13I~
	long ts;                                                       //~5A13I~
//*****************************                                    //~5A13I~
	if (execjarsw==0)                                              //~5A13I~
    {                                                              //~5A13I~
    	File fh=new File(Pjarname);                                //~5A13I~
        return fh.lastModified();                                  //~5A13I~
    }                                                              //~5A13I~
    try{                                                           //~5A13I~
        JarFile jarf=new JarFile(Pjarname);                        //~5A13I~
//		System.out.println("jarfile="+jarf);                       //~5A13R~
		ZipEntry ze=jarf.getEntry(WNP_PROP0);                      //~5A13I~
//		System.out.println("Zipentry="+ze);                        //~5A13R~
		ts=ze.getTime();                                           //~5A13I~
//		System.out.println("ze time="+Long.toHexString(ts));       //~5A13R~
    }                                                              //~5A13I~
    catch (java.lang.Exception e){                                 //~5A13I~
//		System.out.println(Pjarname+" dose not contain "+WNP_PROP0);//~5A13R~
        return 0;                                                  //~5A13I~
    }                                                              //~5A13I~
    return ts;                                                     //~5A13I~
}//getfile0ts                                                      //~5A13I~
//*****************************************************            //~5A13I~
//*get file0 timestamp                                             //~5A13I~
//*****************************************************            //~5A13I~
private long getfile0data()                                        //~5A13I~
{                                                                  //~5A13I~
	long f0data=0;                                                 //~5A13I~
//*****************************                                    //~5A13I~
	if (execjarsw==0)                                              //~5A13I~
    {                                                              //~5A13I~
    	getfiledata(file0);                                        //~5A13I~
    }                                                              //~5A13I~
    try{                                                           //~5A13I~
        InputStream is=file0url.openStream();                      //~5A13I~
    	DataInputStream dis=new DataInputStream(is);               //~5A13I~
        for (int ii=0;ii<8;ii++)                                   //~5A13I~
        {                                                          //~5A13I~
            byte bt=dis.readByte();                                //~5A13I~
            int bti=(int)bt & 0xff;                                //~5A13I~
            f0data=(f0data<<8)+bti;                                //~5A13I~
        }                                                          //~5A13I~
//System.out.println("f0dat="+Long.toHexString(f0data));           //~5A13R~
        dis.close();                                               //~5A13I~
    }                                                              //~5A13I~
    catch(FileNotFoundException e)                                 //~5A13I~
    {                                                              //~5A13I~
//      System.err.println(WNP_PROP0+" not found in jar");         //~va01R~
        f0data=0;                                                  //~5A13I~
    }                                                              //~5A13I~
    catch(IOException e)                                           //~5A13I~
    {                                                              //~5A13I~
//      System.err.println(WNP_PROP0+" jar read err");             //~va01R~
        f0data=0;                                                  //~5A13I~
    }                                                              //~5A13I~
    return f0data;                                                 //~5A13I~
}//getfile0data                                                    //~5A13I~
//*****************************************************            //~5A12I~
//*gen property filename                                           //~5A12I~
//*****************************************************            //~5A12I~
private String getfile1name(String Ppath)                          //~5A12I~
{                                                                  //~5A12I~
	int pos;                                                       //~5A12I~
//******************************                                   //~5A12I~
	String path=Ppath;                                             //~5A12I~
	if (path.indexOf("file:")==0)	//start by file:               //~5A12I~
    	path=path.substring(5);                                    //~5A12I~
	pos=path.indexOf(".jar!");                                     //~5A12I~
    if (pos<0)	//not found                                        //~5A12I~
    	return path+".prop";                                       //~5A12I~
    return path.substring(0,pos)+".prop";                          //~5A12I~
}                                                                  //~5A12I~
//*****************************************************            //~5A12I~
//*get file0 pswd chk data                                         //~5A12I~
//*****************************************************            //~5A12I~
private long getfiledata(String Pfile)                             //~5A12R~
{                                                                  //~5A12I~
    long fdata=0;                                                  //~5A12R~
//******************************                                   //~5A12I~
    try{                                                           //~5A12I~
    	FileInputStream fis=new FileInputStream(Pfile);            //~5A12R~
    	DataInputStream dis=new DataInputStream(fis);              //~5A12I~
        for (int ii=0;ii<8;ii++)                                   //~5A12I~
        {                                                          //~5A12I~
       		byte bt=dis.readByte();                                //~5A12I~
         	int bti=(int)bt & 0xff;                                //~5A12I~
       		fdata=(fdata<<8)+bti;                                  //~5A12R~
        }                                                          //~5A12I~
        dis.close();                                               //~5A12I~
    }                                                              //~5A12I~
    catch(FileNotFoundException e)                                 //~5A12I~
    {                                                              //~5A12I~
//    	System.err.println(Pfile+" not found");                    //~va01R~
        return 0;                                                  //~5A12I~
    }                                                              //~5A12I~
    catch(IOException e)                                           //~5A12I~
    {                                                              //~5A12I~
//    	System.err.println(Pfile+" read err");                     //~va01R~
        return 0;                                                  //~5A12I~
    }                                                              //~5A12I~
//System.out.println("file="+Pfile+",data="+Long.toHexString(fdata));//~5A13R~
    return fdata;                                                  //~5A12R~
}                                                                  //~5A12I~
//*****************************************************            //~5A12I~
//*chk pswd ok status by file2 modified time                       //~5A12I~
//*****************************************************            //~5A12I~
private int updatefile()                                           //~5A12I~
{                                                                  //~5A12I~

    long file1data=0;                                              //~5A13R~

//******************************
    File File1=new File(file1);//~5A12I~
    try{                                                           //~5A12I~
        FileOutputStream fos=new FileOutputStream(file1);          //~5A12I~
        DataOutputStream dos=new DataOutputStream(fos);            //~5A12I~
       	dos.writeLong(file1data);                                   //~5A12I~
        dos.close();                                               //~5A12I~
//System.out.println("written");                                   //~5A13R~
    }                                                              //~5A12I~
    catch(IOException e)                                           //~5A12I~
    {                                                              //~5A12I~
//    	System.err.println(file1+" write err");                    //~va01R~
        return 4;                                                  //~5A12I~
    }                                                              //~5A12I~
//update file1                                                     //~5A12I~
	ts1=File1.lastModified();                                      //~5A12I~
//System.out.println("file1 ts="+Long.toHexString(ts1));           //~5A13R~
	file1data=encript(file1,ts1+ts0);                              //~5A13R~
	try{                                                           //~5A12I~
    	FileOutputStream fos=new FileOutputStream(file1);          //~5A12I~
        DataOutputStream dos=new DataOutputStream(fos);            //~5A12I~
       	dos.writeLong(file1data);                                   //~5A12I~
        dos.close();                                               //~5A12I~
		File1.setLastModified(ts1);                                //~5A12I~
		ts1=File1.lastModified();                                  //~5A12I~
//System.out.println("file1 written pswd="+Long.toHexString(file1data));//~5A13R~
//System.out.println("file1 ts="+Long.toHexString(ts1));           //~5A13R~
    }                                                              //~5A12I~
    catch(IOException e)                                           //~5A12I~
    {                                                              //~5A12I~
//    	System.err.println(File1.getPath()+" write err");          //~va01R~
        return 4;                                                  //~5A12I~
    }                                                              //~5A12I~
    return 0;                                                      //~5A12I~
}                                                                  //~5A12I~
//*****************************************************            //~5A12I~
//*generate encripted pswd                                         //~5A12I~
//*****************************************************            //~5A12I~
private long encript(String Ppath,long Pkey)                       //~5A12I~
{                                                                  //~5A12I~
    long chksum=0,key;                                             //~5A12I~
    int  ii,jj,len;                                                //~5A12I~
//******************************                                   //~5A12I~
    len=Ppath.length();                                            //~5A12I~
	for (ii=0,jj=0;ii<len;ii++,jj++)                               //~5A12I~
    {                                                              //~5A12I~
    	if (jj>7)                                                  //~5A12I~
        	jj=0;                                                  //~5A12I~
        key=(Pkey<<jj*8)+(Pkey>>(8-jj)*8);                         //~5A12I~
//System.out.println("key1="+Long.toHexString((Pkey<<jj*8)));      //~5A12I~
//System.out.println("key2="+Long.toHexString((Pkey>>(8-jj)*8)));  //~5A12I~
        chksum+=(Ppath.charAt(ii) & 255)*key;                      //~5A12I~
//System.out.println("key="+Long.toHexString(key)+",chksum="+Long.toHexString(chksum));//~5A12I~
//System.out.println("char at "+ii+" = "+Integer.toHexString((int)(Ppath.charAt(ii))));//~5A12I~
    }                                                              //~5A12I~
//System.out.println("Pkey="+Long.toHexString(Pkey)+",chksum="+Long.toHexString(chksum));//~5A13R~
    return chksum;                                                 //~5A12I~
}                                                                  //~5A12I~
}//class pswd                                                      //~5A04R~
