import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;

//CID://+v0.4R~:                                                   //~v0.4R~
//*************************************************************
//*XNP.c   Number Place Puzzle
//*format
//*      xnp  datafile
//*           datafile fmt
//*            9*9 matrix seperated by comma.set '0' for space.
//*            a line is  like as  7,8,0,0,0,0,0,5,2
//*************************************************************
//*000104 xnp v0.1:no rgid when no patern data                     //~v0.4I~
//*000103 xnp v0.1:Win(C++) support                                //~v0.1I~
//*v100 first
//*************************************************************
public class xnp {                                                 //~v0.4I~
private static final String VERSION="v1.2";                         //~v0.4R~
private static final String PGMID="xnp";                            //~v0.4R~
private static final String OSTYPE="J";                             //~v0.4I~
private static final String __DATE__="2005/10/01";                  //~v0.4I~
                                                                   //~v0.4I~
private static final int  MAP_SIZE=9;                              //~v0.4I~
private static final int  PEG_MAX        =81;      //9x9=81 ؃O̍ő吔//~v0.4I~
                                                                   //~v0.4I~
//private static final int BUFFSZ=512;                               //~v0.4I~
//private static final int MAXNUMSTRSZ=5;                            //~v0.4I~
private static final int GBL_UERR_DBCSSET=0x02;     //external set //~5A01I~
private static final int GBL_UERR_DBCSMODE=0x04;//dbcs             //~5A01I~
//*************************************************************
//********************
private static	String Spgmver;                                          //~v0.4R~
private static  int  Soptions=xnpsub.XNP_RIGID|xnpsub.XNP_PRINTIDATA;     //~v0.4R~
private static  int  Sqmakesw=0;                                          //~v0.4R~
private static  int  Ssetlimit=xnpsub2.SETMAX;      //dencity             //~v0.4R~
private static  int  Srepeatmax=0;		//loop max time limit(seconds)     //~v0.4R~
private static  int  Stmsgfreq=0;  		//time msg frequency each 10 seconds//~v0.4R~
private static  int  Sseed=0;          		//random-no seed           //~v0.4R~
private static  int  Splan=0;          		//strategy of search pos for make//~v0.4R~
private static  int  Srchkmaxlevel=0;          		//strategy of search pos for make//~v0.4R~
private static  int  Slevel=0;
private static xnpsub asub1=new xnpsub(MAP_SIZE);                  //~5A01R~
private static xnpsub2 asub2=new xnpsub2(asub1,MAP_SIZE);          //~5A01R~
private static int Guerropt=0;                                     //~5A01I~
//********************
public static void main(String[] parmp) {                          //~v0.4I~
    int parmno,posparmno=0,atoiwk,sortopt=0,cptrpos,idx,parmc,parmlen;//~5A01R~
    String cptr,fnm=null;                                       //~v0.4R~
    char ch;                                                       //~v0.4I~
//**********************
    parmc=parmp.length;                                          //~v0.4I~
	Spgmver="# "+PGMID+":"+VERSION+": ";                           //~v0.4R~
//#ifdef DPMI                 //DPMI version                       //~v0.4R~
//    putenv("LFN=Y");                 //need for ufileisvfat      //~v0.4R~
//    ufileisvfat(ISVFAT_FORCE);      //force vfat                 //~v0.4R~
//#endif                      //DPMI or not                        //~v0.4R~
	if (parmc<1)
    {
    	help();
        System.exit (4);                                           //~v0.4R~
    }
//*******************************
//* parm process                *
//*******************************
	for (parmno=0;parmno<parmc;parmno++)
	{
  		cptr=parmp[parmno];
        cptrpos=0;                                                 //~v0.4I~
        parmlen=cptr.length();                                     //~5A01I~
  		if(cptr.charAt(cptrpos)=='-')                              //~v0.4R~
  		{//option
    		ch=cptr.charAt(++cptrpos);                      //first option byte//~v0.4R~

			switch(Character.toUpperCase(ch))             //option
    		{
    		case '?':
        		help();
        		System.exit(8);                                     //~v0.4R~
                break;
    		case 'D':       //set limit
                Ssetlimit=xnpsub.uatoi(cptr.substring(cptrpos+1)); //~5A01R~
                if (Ssetlimit==0)                                  //~v0.4R~
                	Ssetlimit=xnpsub2.SETMAX;                      //~v0.4R~
                else
	                if (Ssetlimit<3)
                    	uerrexit("Limit should be >=3.",null);     //~v0.4R~
                break;
    		case 'G':               //strategy                     //~0116I~
			    switch(Character.toUpperCase(cptr.charAt(cptrpos+1)))            //~v0.4R~
    			{                                                  //~0116M~
    			case 0:                                            //~0116M~
    				Splan=0;                                       //~0116M~
        			break;                                         //~0116M~
    			case 'N':		//minimum                          //~0116M~
            		atoiwk=xnpsub.uatoi(cptr.substring(cptrpos+2));//~5A01R~
                	if (atoiwk!=0)                                 //~v0.4R~
                		Splan=-atoiwk;                             //~0116M~
                    else                                           //~0116M~
                    	Splan=-9;                                  //~0116M~
        			break;                                         //~0116M~
    			case 'X':		//maximum                          //~0116M~
            		atoiwk=xnpsub.uatoi(cptr.substring(cptrpos+2));//~5A01R~
                	if (atoiwk!=0)                                 //~v0.4R~
    					Splan=atoiwk;                              //~0116M~
                    else                                           //~0116M~
    					Splan=9;                                   //~0116M~
        			break;                                         //~0116M~
				default:                                           //~0116M~
                	uerrexit("Make strategy option parm("+cptr.substring(cptrpos)+") err",null);//~v0.4R~
                }                                                  //~0116M~
                break;                                             //~0116M~
    		case 'M':          // /M
                Sqmakesw=1;
                if (cptrpos+1<parmlen)                             //~5A01I~
	            	Slevel=Character.toUpperCase(cptr.charAt(cptrpos+1));//~5A01R~
                else                                               //~5A01I~
                	Slevel=0;                                      //~5A01I~
                if (Slevel!=0)                                     //~v0.4R~
                    if (!(Slevel=='H' || Slevel=='M' || Slevel=='E'))
                        uerrexit("Make level option("+cptr.substring(cptrpos+1)+") err",null);//~v0.4R~
                break;
    		case 'P':
                Soptions|=xnpsub.XNP_PILOT;                        //~v0.4R~
                break;
    		case 'R':			// /R
                Soptions|=xnpsub.XNP_REDUNDANTCK;                  //~v0.4R~
                Srchkmaxlevel=xnpsub.uatoi(cptr.substring(cptrpos+1));//~5A01R~
                break;
    		case 'S':
            	atoiwk=xnpsub.uatoi(cptr.substring(cptrpos+1));    //~5A01R~
                if (atoiwk!=0)                                     //~v0.4R~
                	Sseed=atoiwk;
                break;
    		case 'T':           //timeout                          //~0116I~
            	atoiwk=xnpsub.uatoi(cptr.substring(cptrpos+1));    //~5A01R~
                if (atoiwk!=0)                                     //~v0.4R~
                	Srepeatmax=atoiwk;                             //~0116M~
                if ((idx=cptr.substring(cptrpos+1).indexOf('/'))!=0)//~v0.4R~
                {                                                  //~0116M~
            		atoiwk=xnpsub.uatoi(cptr.substring(idx+1));    //~5A01R~
                	if (atoiwk!=0)                                 //~v0.4R~
                		Stmsgfreq=atoiwk;                          //~0116M~
				}                                                  //~0116M~
                break;                                             //~0116M~
    		case 'Y':
                while(++cptrpos<parmlen)                           //~5A01R~
                {
	                ch=cptr.charAt(cptrpos);                       //~5A01I~
                    switch(Character.toUpperCase(ch))             //option
                    {
                    case '9':
                        Guerropt|=GBL_UERR_DBCSSET;     //external set
                        Guerropt|=GBL_UERR_DBCSMODE;//dbcs
                        break;
			   		case 'P':
            		    Soptions|=xnpsub.XNP_PRINTIDATA;           //~v0.4R~
                		break;
			   		case 'R':
            		    Soptions|=xnpsub.XNP_RIGID;                //~v0.4R~
                		break;
			   		case 'S':                                      //~v0.1I~
                    	sortopt=1;                                 //~v0.1I~
            		    Soptions|=xnpsub.XNP_SORT;                 //~v0.4R~
                		break;                                     //~v0.1I~
                    case 'T':
                        Soptions|=xnpsub.XNP_TEST;                 //~v0.4R~
                        break;
                    default :                           //not option
                        uerrexit("undefined option parm("+parmp[parmno]+")",null);//~v0.4R~
                    }
                }
                break;
    		case 'N':
                while(++cptrpos<parmlen)                           //~5A01I~
                {                                                  //~5A01I~
	                ch=cptr.charAt(cptrpos);                       //~5A01I~
                    switch(Character.toUpperCase(ch))             //option
                    {
                    case '9':
                        Guerropt|=GBL_UERR_DBCSSET;     //external set
                        Guerropt&=~GBL_UERR_DBCSMODE;//sbcs
                        break;
			   		case 'P':
            		    Soptions&=~xnpsub.XNP_PRINTIDATA;          //~v0.4R~
                		break;
			   		case 'R':
            		    Soptions&=~xnpsub.XNP_RIGID;               //~v0.4R~
                		break;
			   		case 'S':                                      //~v0.1I~
                    	sortopt=1;                                 //~v0.1I~
            		    Soptions&=~xnpsub.XNP_SORT;                //~v0.4R~
                		break;                                     //~v0.1I~
                    case 'T':
                        Soptions&=~xnpsub.XNP_TEST;                //~v0.4R~
                        break;
                    default :                           //not option
                        uerrexit("undefined option parm("+parmp[parmno]+")",null);//~v0.4R~
                    }
              	}
                break;
    		default	:                           //not option
      			uerrexit("undefined option parm("+parmp[parmno]+")",null);//~v0.4R~
            }//sw
    	}//flag
      	else
      	{//positional parmno
        	posparmno++;
        	switch (posparmno)
        	{
        	case  1:          //first parm
          		fnm=cptr;
          		break;
            default:
              	uerrexit("too many positional parameter("+cptr+")",null);//~v0.4R~
            }//switch by parmno
  		}//option or posparm
	}//for all parm
    if (Sqmakesw!=0)                                               //~v0.4R~
    {                                                              //~v0.1I~
	    if (sortopt==0)                                            //~v0.4R~
            Soptions|=xnpsub.XNP_SORT;	//default for make         //~v0.4R~
        xnpqmkmain(fnm);
	}                                                              //~v0.1I~
    else
    {
    	if (fnm==null)                                             //~v0.4R~
        	uerrexit("Specify Question data file name",
						"f[^t@Cw肵ĉ");
    	xnpansmain(fnm);		//fill initial data
	}
    titlemsg();
    return;
}//main
private static void HELPMSG(String Pemsg,String Pjmsg)                    //~v0.4I~
{                                                                  //~v0.4I~
	String errmsg;                                                 //~v0.4I~
       //~5A01I~
    if ((Guerropt & GBL_UERR_DBCSSET)!=0                           //~5A01I~
    &&  (Guerropt&GBL_UERR_DBCSMODE)==0)                           //~5A01I~
		errmsg=Pemsg;                                              //~5A01R~
    else                                                           //~5A01I~
    if (Pjmsg==null)                                               //~v0.4I~
		errmsg=Pemsg;                                              //~5A01R~
    else                                                           //~v0.4I~
		errmsg=Pjmsg;                                             //~5A01R~
    System.out.print(errmsg);                                      //~5A01R~
}                                                                  //~v0.4I~
public static void uerrexit(String Pemsg,String Pjmsg)             //~5A01R~
{                                                                  //~v0.4I~
	uerrmsg(Pemsg,Pjmsg);                                          //~5A01R~
	System.exit(8);                                                //~v0.4I~
}                                                                  //~v0.4I~
public static String uerrmsg(String Pemsg,String Pjmsg)            //~5A01R~
{                                                                  //~v0.4I~
	String errmsg;                                                 //~5A01I~
    if ((Guerropt & GBL_UERR_DBCSSET)!=0                           //~5A01I~
    &&  (Guerropt&GBL_UERR_DBCSMODE)==0)                           //~5A01I~
		errmsg=Pemsg;                                              //~5A01I~
    else                                                           //~5A01I~
    if (Pjmsg==null)                                               //~5A01I~
		errmsg=Pemsg;                                              //~5A01I~
    else                                                           //~5A01I~
		errmsg=Pjmsg;                                             //~5A01I~
    System.out.println(Spgmver+errmsg);                            //~5A01R~
    return errmsg;                                                 //~5A01I~
}                                                                  //~v0.4I~
static void titlemsg()                                                    //~v0.4R~
{
        HELPMSG(                                                   //~v0.4R~
"# "+PGMID+":"+VERSION+"("+OSTYPE+"):"+__DATE__+": ==== Number Place Puzzle =============== by EBURI-syo\n",//~5A01R~
"# "+PGMID+":"+VERSION+"("+OSTYPE+"):"+__DATE__+": ==== io[v[X pY ======== by ؔ w ==\n");//~5A01R~
    return;                                                        //~v0.4R~
}//titlemsg
static void help()                                                        //~v0.4R~
{
//************
	titlemsg();
HELPMSG(                                                           //~v0.4R~
"This program solves Number Place Puzzle,or make Puzzle automaticaly.\n",
"io[v[X pY肷vOł\n");
HELPMSG(                                                           //~v0.4R~
"\n",
"\n");
HELPMSG(                                                           //~v0.4R~
"format: "+PGMID+" [file-name] [-option ...]\n",                   //~v0.4R~
"`  : "+PGMID+" [t@C] [-IvV ...]\n");             //~v0.4R~
HELPMSG(                                                           //~v0.4R~
"  file-name:Problem data or optional patern data to make puzzle.\n",
" t@C:f[^͖쐬̂Ƃ̃IvṼp^[f[^B\n");
HELPMSG(                                                           //~v0.4R~
".option for solution.\n",
"E𓚗p̃IvVB\n");
HELPMSG(                                                           //~v0.4R~
"   -R      : Redundancy chk.\n",                                  //~v0.4R~
"   -R      : Redundancy chk;Ă悢f[^̗L`FbNB\n");//~v0.4R~
HELPMSG(                                                           //~v0.4R~
".option for making puzzle.\n",
"E쐬p̃IvVB\n");
HELPMSG(                                                           //~v0.4R~
"   -Dcnt   : Density;max count in each box,row,col.\n",           //~v0.4R~
"   -Dcnt   : Density;sAAɍő傢܂ŒuĂ悢B\n");//~v0.4R~
HELPMSG(                                                           //~v0.4R~
"             Default is 5,Minimum 3.\n",
"             ȗl 5 Aŏl 3B\n");
HELPMSG(                                                           //~v0.4R~
"   -M[x]   : Request of Make Puzzle.\n",                          //~v0.4R~
"   -M[x]   : Make;쐬[h̎wB\n");                     //~v0.4R~
HELPMSG(                                                           //~v0.4R~
"             By patern file,specify position where digit is placed if you want.\n",
"             p^[t@Cw肷ΐuꏊwł܂B\n");
HELPMSG(                                                           //~v0.4R~
"             x:Dificulty level request. x=H(hard), M(medium) or E(easy).\n",
"             x:쐬̃x̎wBx=H(), M() ܂ E()D\n");
HELPMSG(                                                           //~v0.4R~
"   -Sseed  : Seed of random-number generation.\n",                //~v0.4R~
"   -Sseed  : Seed;̎̐B\n");                       //~v0.4R~
HELPMSG(                                                           //~v0.4R~
"             Default is time-stamp.Use it to get same result from same data.\n",
"             ȗl͎Bf[^œʂ𓾂ɂ͓gpB\n");
HELPMSG(                                                           //~v0.4R~
".option for both.\n",
"Eʂ̃IvVB\n");
HELPMSG(                                                           //~v0.4R~
"   -P      : Pilot;print intermediate step.\n",                   //~v0.4R~
"   -P      : Pilot;𓚂ɂ܂ł̂܂ł̓r11óB\n");//~v0.4R~
HELPMSG(                                                           //~v0.4R~
"   -Tl[/f] : Timeout limit.Default is in parenthesis.\n",         //~v0.4R~
"   -Tl[/f] : Timeout;(b),ʓ͉/쐬ꂼ̃[hł̏ȗlB\n");//~v0.4R~
HELPMSG(                                                           //~v0.4R~
"             l:limit seconds("+xnpsub.ANS_TIMEOUT+"/"+xnpsub.MAKE_TIMEOUT+" sec),f:iteration msg frequency("+xnpsub.ANS_MSGFREQ+"/"+xnpsub.MAKE_MSGFREQ+" sec).\n",//~5A01R~
"             l:("+xnpsub.ANS_TIMEOUT+"/"+xnpsub.MAKE_TIMEOUT+"b), f:oMSG̕\px("+xnpsub.ANS_MSGFREQ+"/"+xnpsub.MAKE_MSGFREQ+"b)B\n");//~5A01R~

HELPMSG(                                                           //~v0.4R~
"   -Yx,-Nx : Yes/No:x is following option.Default is in ( )\n",   //~v0.4R~
"   -Yx,-Nx : ̗lȃIvV Yes  No  w肷Bʓ͏ȗl\n");//~v0.4R~
HELPMSG(                                                           //~v0.4R~
"      x:p  : print data file contents.\n",
"      x:p  : f[^t@C̓eo͂.(/Yp)\n");
HELPMSG(                                                           //~v0.4R~
"      x:r  : Accept pattern as firmed.loosely use pattern data if -Nr.(-Yr)\n",//~v0.4R~
"      x:r  : p^[f[^炵č쐬B/Nr̂Ƃ͖ڈƂB(-Yr)\n");//~v0.4R~
HELPMSG(                                                           //~v0.4R~
"      x:s  : Sort probrem data.(/Ys for Make mode,/Ns for Answer mode)\n",//~v0.1I~
"      x:s  : f[^𐮗񂷂.(쐬[h/YsA𓚃[h/Ns)\n");//~v0.1I~
HELPMSG(                                                           //~v0.4R~
"  (Ex.) : "+PGMID+" xnpdata.#99 -p;  "+PGMID+" -m -d3; "+PGMID+" -m pat#01 -Np; \n",//~v0.4R~
"  ()  : "+PGMID+" xnpdata.#99 -p;  "+PGMID+" -m -d3; "+PGMID+" -m pat#01 -Np; \n");//~v0.4R~
HELPMSG(                                                           //~v0.4R~
".data fmt   : specify 9 x 9 matrix.\n",
"Ef[^` : 9 x 9 ̍sw肵܂B\n");
HELPMSG(                                                           //~v0.4R~
"  (Ex.)        # Ex (19)\n",
"  ()         #  19B\n");
HELPMSG(                                                           //~v0.4R~
"                 7  8  _    _  _  _    _  5  2\n",
"                 7  8  _    _  _  _    _  5  2\n");
HELPMSG(                                                           //~v0.4R~
"                 2  _  _    _  5  _    _  _  3\n",
"                 2  _  _    _  5  _    _  _  3\n");
HELPMSG(                                                           //~v0.4R~
"                 _  _  _    4  _  6    _  _  _\n",
"                 _  _  _    4  _  6    _  _  _\n");
HELPMSG(                                                           //~v0.4R~
"               #==============================\n",
"               #==============================\n");
HELPMSG(                                                           //~v0.4R~
"                 _  _  1    _  _  _    4  _  _\n",
"                 _  _  1    _  _  _    4  _  _\n");
HELPMSG(                                                           //~v0.4R~
"\n",
"\n");
HELPMSG(                                                           //~v0.4R~
"             .Space line is ignored,first '#' means comment line.\n",
"             .󔒍s͖܂Aŏ '#' ̓RgsłB\n");
HELPMSG(                                                           //~v0.4R~
"             .Another input format is 81 byte continuous digit string per line.\n",
"             .1s81̘A̕w肷`łOKłB\n");
HELPMSG(                                                           //~v0.4R~
"             .A file may contain multiple quetion/patern data.\n",
"             .t@Cɂ͕̖舽̓p^[f[^܂B\n");
HELPMSG(                                                           //~v0.4R~
"             .Non zero digit means the point where digit is placed.\n",
"             .쐬̃p^[f[^̏ꍇݒ肵 0 ȊO̐uB\n");
HELPMSG(                                                           //~v0.4R~
" When too long time is expired,retry after break(Ctrl+C).\n",
" 쐬ŎԂ߂悤ȂAUu[N(Ctrl+C)čĎsĂ݂\n");
HELPMSG(                                                           //~v0.4R~
" Random-number is used,so another seed may change result.\n",
" BgpĂ̂Ŏςė^̂@łB\n");
	return;
}//help
static //*************************************************************
int xnpansmain(String Pfnm)                                        //~v0.4R~
{
	int[][] datatbl=new int[MAP_SIZE][MAP_SIZE];     	//number place	init data table//~v0.4R~
	NPWORKT npwt=new NPWORKT();			//worktbl                  //~v0.4R~
    int  qcnt,failedcnt;                                           //~v0.4R~
    int[][] pi;                                                    //~v0.4I~
	BufferedReader pfh=null;                                            //~v0.4R~
//**********************
	try {                                                          //~v0.4I~
		pfh=new BufferedReader(new FileReader(Pfnm));              //~v0.4I~
    }                                                              //~v0.4I~
    catch(FileNotFoundException e)                                 //~v0.4I~
    {                                                              //~v0.4I~
    	uerrexit(Pfnm+" Open failed",null);                        //~v0.4R~
    }                                                              //~v0.4I~
    if ((Soptions & xnpsub.XNP_PILOT)==0)                          //~v0.4R~
    	Soptions|=(xnpsub.XNP_PILOT|xnpsub.XNP_PILOTNOMSG);        //~v0.4R~
	Soptions|=(Srchkmaxlevel<<12);
    pi=datatbl;                                                    //~v0.4R~
    if (Srepeatmax==0)                                             //~v0.4R~
    	Srepeatmax=xnpsub.ANS_TIMEOUT;                             //~5A01R~
    if (Stmsgfreq==0)                                              //~v0.4R~
    	Stmsgfreq=xnpsub.ANS_MSGFREQ;                              //~5A01R~
	for (qcnt=0,failedcnt=0;;)	//until eof
    {
        if (xnpreaddata(pfh,pi)!=0)                                //~v0.4R~
        	break;
		qcnt++;
    	if (asub1.xnpgetanswer(Soptions & xnpsub.XNP_SOLVMASK,pi,npwt,Stmsgfreq,Srepeatmax)!=0)//~v0.4R~
        	failedcnt++;
	}
    if (qcnt>1)
    	uerrmsg("Result: "+(qcnt-failedcnt)+" success in "+qcnt+" questions",//~v0.4R~
    	        ": "+(qcnt-failedcnt)+"   ( "+qcnt+" ⒆)");//~v0.4R~

	inputclose(pfh);                                               //~5A01R~
    return failedcnt;
}//xnpmain
static //*********************
//*read initial data **
//*********************
int  xnpreaddata(BufferedReader Ppfh,int[][] Pdata)                //~v0.4R~
{
    String buff,pc;                                            //~v0.4R~
    int ii=0,jj,fldno,row,col;                             //~v0.4R~
    int[][] pi;                                                    //~v0.4I~
//************
try{                                                               //~v0.4I~
    for (ii=0,pi=Pdata;ii<9;)
    {
    	if ((buff=Ppfh.readLine())==null)	//read 1 line              //~v0.4R~
        	break;

                                        //~v0.4R~
        if ((Soptions & xnpsub.XNP_PRINTIDATA)!=0)                 //~v0.4R~
            uerrmsg("===>"+buff,null);                             //~v0.4R~
		pc=buff.trim();
		if (pc.length()==0)
			continue;//~v0.4R~
        if (pc.charAt(0)=='#')                                     //~v0.4R~
            continue;
		if (pc.length()==PEG_MAX)	//81 digt and lf               //~v0.4R~
        {
			for (jj=0;jj<PEG_MAX;jj++)                             //~v0.4R~
            {
            	row=jj/MAP_SIZE;                                   //~v0.4I~
            	col=jj%MAP_SIZE;                                   //~v0.4I~
                if (pc.charAt(jj)>='0' && pc.charAt(jj)<='9')      //~v0.4R~
    	    		pi[row][col]=pc.charAt(jj)-'0';                //~v0.4R~
                else
                	pi[row][col]=0;                                //~v0.4R~
            }
            ii=9;
            break;		//return
        }
//printf("data=%s\n",buff);
		StringTokenizer st=new StringTokenizer(pc," \t");        //~v0.4I~
        fldno=st.countTokens();                                     //~v0.4I~

        if (fldno<=0)	//no data or all space
            continue;
		if (fldno!=9)
        	uerrexit("data format err;"+buff,null);                //~v0.4R~
		for (jj=0;jj<9;jj++)                                       //~v0.4R~
        	pi[ii][jj]=xnpsub.uatoi(st.nextToken());               //~5A01R~
        ii++;
    }
}                                                                  //~v0.4I~
catch(IOException e)                                               //~v0.4I~
{                                                                  //~v0.4I~
	uerrexit("Read IO exception",null);                            //~v0.4I~
}                                                                  //~v0.4I~
    if (ii==0)                                                     //~v0.4R~
    	return -1;			//eof
    if (ii<9)
        uerrexit("required just 9 line for each probrem data",null);//~v0.4R~
    return 0;
}//xnpreaddata
private static void  inputclose(BufferedReader Ppfh)                      //~5A01I~
{                                                                  //~5A01I~
//************                                                     //~5A01I~
	try{                                                           //~5A01I~
    		Ppfh.close();                                          //~5A01I~
    }                                                              //~5A01I~
	catch(IOException e)                                           //~5A01I~
	{                                                              //~5A01I~
		uerrexit("Input Close I/O exception",null);                //~5A01I~
	}                                                              //~5A01I~
}//inputclose                                                      //~5A01I~
//*********************                                            //~5A01I~
//*make puzzle       **
//*********************
static int xnpqmkmain(String Ppfnm)                                //~5A01R~
{
	BufferedReader pfh=null;                                            //~v0.4R~
	int[][]  qpattbl=new int[MAP_SIZE][MAP_SIZE],pi;     	//patern reques table//~v0.4R~
	NPWORKT npwt=new NPWORKT();			//worktbl                  //~v0.4R~
    int rc,actseed;                                                        //~v0.4R~
    int[] actseedtb=new int[1];		//output selected seed             //~v0.4R~
//**********************
//init
//patern specification
    if (Srepeatmax==0)                                             //~v0.4R~
    	Srepeatmax=xnpsub.MAKE_TIMEOUT;                            //~5A01R~
    if (Stmsgfreq==0)                                              //~v0.4R~
    	Stmsgfreq=xnpsub.MAKE_MSGFREQ;                             //~5A01R~
	rc=4;
    if (Ppfnm!=null)                                                  //~v0.4R~
    {
    	pi=qpattbl;                                                //~v0.4R~
		try {                                                      //~v0.4I~
		    pfh=new BufferedReader(new FileReader(Ppfnm));                      //~v0.4R~
   		 }                                                         //~v0.4I~
    	catch(FileNotFoundException e)                             //~v0.4I~
    	{                                                          //~v0.4I~
    		uerrexit(Ppfnm+" Open failed",null);                   //~v0.4I~
    	}                                                          //~v0.4I~
		for (;;)
        {
    		if (xnpreaddata(pfh,pi)!=0)			//fill initial data//~v0.4R~
            	break;
			if ((rc=asub2.xnpmakequestion(Soptions & xnpsub.XNP_MAKEMASK, //~v0.4R~
				npwt,pi,Ssetlimit,Stmsgfreq,Srepeatmax,Sseed,Splan,Slevel,actseedtb))!=0)//~v0.4R~
                break;
		}
		inputclose(pfh);                                           //~5A01R~
    }
    else
		rc=asub2.xnpmakequestion(Soptions & xnpsub.XNP_MAKEMASK & ~xnpsub.XNP_RIGID,//~v0.4R~
				npwt,null,Ssetlimit,Stmsgfreq,Srepeatmax,Sseed,Splan,Slevel,actseedtb);//~v0.4R~
	if (rc!=0)                                                     //~v0.4R~
		uerrexit("Sorry,Make failed,Try one more.",null);          //~v0.4R~
    actseed=actseedtb[0];                                          //~v0.4I~
	uerrmsg("Actualy used seed="+actseed,null);                    //+5A01R~
    return 0;
}//xnpqmkmain
}//class xnp                                                       //~v0.4I~
