//CID://+va23R~:                                                   //~va23R~
//******************************************************************************//~v004I~
//va23:051221 langauge ctl(English and japanese)                   //~va23I~
//va21:051114 on success;display "eburi"                           //~va21I~
//va20:051113 kbd input over 9(2 digit input); Shift+,Ctl+(memo),S+C(same num)//~va20I~
//va19:051113 (BUG)memo for 4*4                                    //~va19I~
//va16:051113 option to drop redundancy to make                    //~va16R~
//v043:051112 logic of select minimum candidate place yield crowded unit,so take maximum candidate logic(plan>0)//~v043I~
//v041:051112 try minimum candidate select plan(plan<0)            //~v041I~
//v030:051108 enable clear when make mode to back to anss mode     //~v030I~
//v025:051104 (BUG)at start no input accepted(after automake input avail)//~v025I~
//va03:051104 dencity by slider                                    //~va03I~
//v024:051103 (BUG)restore also score when restore pending game    //~v024I~
//v023:051102 (BUG)open doc ignored after make interrupted by timeout//~v023I~
//v022:051102 redundancy chk:max depth parm missing(no depth chk done at xnpsub)//~v022I~
//v021:051102 redundancy chk:display also reduduncy depth count    //~v021I~
//v020:051102 (BUG)redundant chk display also answer               //~v021I~
//va01:051013 5*5 support                                          //~va01I~
//v019:051101 change color of patern input                         //~va19I~
//v012:051004 dosenot write answer when in solving                 //~v012I~
//vj01:050923 java conversion                                      //~vj01I~
//v004:050922 (BUG) Mode=MODE_NOINPUT; -->Mode=MODE_NOINPUT;       //~v004I~
//v003:000312 clear err only when err exist                        //~v004I~
//v002:000312 enter ans mode after make automaticaly               //~v004I~
//******************************************************************************//~v004I~
//*       ** Board.cpp **                                          //~v004I~
//******************************************************************************//~v004I~
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.util.Arrays;

import javax.swing.SwingUtilities;
import javax.swing.Timer;

public class Board implements Runnable{                            //~vj01R~

//*************************                                        //~5921I~
//*macro                                                           //~5921I~
//*************************                                        //~5921I~
public static final int MODE_INIT     = 0;      //no data exist    //~5921I~
public static final int MODE_NOINPUT  = 1;      //file input end   //~5921I~
public static final int MODE_FILEDATA = 2;      //file input end   //~5921I~
public static final int MODE_KEYINDATA= 3;      //manual data      //~5921I~
public static final int MODE_ENDQDATA = 4;      //made data or id of go answer//~5921I~
public static final int MODE_KEYINANS = 5;      //manual answer input data//~5921I~
public static final int MODE_OUTANS   = 6;      //solved answer data//~5921I~
                                                                   //~5921I~
//public static final int PATTERN_ID    = 10;                      //~va01R~
public static       int PATTERN_ID    = (wnp.MAP_SIZE+1);          //~va01R~
public static final int F_ONTRY   = 0x01;                          //~5921I~
public static final int F_ONGO    = 0x02;	    //next ans by GO   //~5921I~
public static final int F_ONNEXT  = 0x04 ;                         //~5921I~
public static final int F_ONRCHK  = 0x08 ;    //ans by rchkmode    //~5921I~
public static final int F_ONXX    = 0x0f ;    //ans by rchkmode    //~5921I~
public static final int F_THREAD  = 0x10 ;                         //~5921I~
public static final int F_ANSCHK  = 0x20 ;                         //~5921I~
public static final int F_MODEMAKE= 0x40 ;    //make or answer mode//~5921I~
public static final int F_MODEANS = 0x80 ;    //make or answer mode//~5921I~
	                                                               //~5921I~
public static final int F_LVLMASK = 0x0f00 ;                       //~5921I~
public static final int F_LVL0    = 0x0100 ;  //difficuty level    //~5921I~
public static final int F_LVL1    = 0x0200 ;  //difficuty level    //~5921I~
public static final int F_LVL2    = 0x0400 ;  //difficuty level    //~5921I~
public static final int F_LVL3    = 0x0800 ;  //difficuty level    //~5921I~
                                                                   //~5921I~
//public static final int F_DENMASK = 0x0f0000 ;                   //~va03R~
//public static final int F_DEN0    = 0x010000 ;  //density        //~va03R~
//public static final int F_DEN3    = 0x020000 ;  //density        //~va03R~
//public static final int F_DEN4    = 0x040000 ;  //density        //~va03R~
//public static final int F_DEN5    = 0x080000 ;  //density        //~va03R~
                                                                   //~5921I~
public static final int F_RIGID   = 0x100000 ;  //rigid option     //~5921I~
                                                                   //~5921I~
public static final int F_ERROR   = 0x01000000; //err detected      //~5921I~
public static final int F_READFILE= 0x02000000; //pending data read//~vj01I~
public static final int F_NOREDUNDANT= 0x04000000; //pending data read//~va16R~
// enum OBJ_STAT { ST_EMPTY,ST_QDATA,ST_ANS,ST_PAT,ST_ERR,ST_RCHK,GRID1,GRID2};//~5921I~
public static final int ST_EMPTY=0;                                //~vj01R~
public static final int ST_QDATA=1;                                //~vj01R~
public static final int ST_ANS=2;                                  //~vj01R~
public static final int ST_PAT=3;                                  //~vj01R~
public static final int ST_ERR=4;                                  //~vj01R~
public static final int ST_RCHK=5;                                 //~vj01R~
public static final int ST_NEXT=6;                                 //~vj01R~
public static final int GRID1=7;                                   //~vj01R~
public static final int GRID2=8;                                   //~vj01R~
public static final int GRID1_MAKE=9;                              //~vj01R~
public static final int GRID2_MAKE=10;                             //~vj01R~
                                                                   //~v004I~
public static final int IDC_GO=1;	//timer 50ms
public static final int IDC_MAKE=2;
public static final int IDC_ANSWER=3;
public static final int IDC_SETEND=4;  
public static final int IDC_SUCCESS=5;   //~vj01I~
public static final int IDC_RCHK=6;                                //~vj01I~
public static final int IDC_NEXT=7;                                //~vj01I~
public static final int IDC_CLEAR=8;                               //~vj01R~
public static final int IDC_RESTORE=9;                             //~vj01I~
public static final int IDC_SORT=10;                               //~vj01I~
public static final int IDC_STOP=11;                               //~vj01I~
                                                                   //~v004I~
private static final boolean TRUE=true;                            //~v004I~
private static final boolean FALSE=false;                          //~v004I~
//==============================================================================//~5921I~
//                                                                 //~va23R~
//==============================================================================//~5921I~

public static 	String GblNpsubMsg;                                 //~5921I~
public static 	int GblSubthreadsw;                                //~5921I~

//*************************                                        //~5921I~
//*member                                                          //~5921I~
//*************************                                        //~5921I~
public    NPWORKT Npworkt=new NPWORKT();                           //~vj01R~
public    String  sProbLevel;                                      //~5923I~
public   int   ActSeed;                                            //~5923I~
public    View    pView;                                           //~5922R~
                                                                   //~5921I~
public     int      	FixedSeq;		//fixed seqence for next   //~5921I~
public     int      	MaxFixed;		//fixed seqence            //~5921I~
public     int     Flags;                                          //~5921I~
public 	int     Seed;                                              //~5921I~
public 	int     Timeout;                                           //~5921I~
public     long  StartTime;                                        //~5922R~
public     CPattern    pPat;                                       //~5922R~
public     int      	NumCount;      //Num set count             //~5921I~
public     int      Score;                                         //~5923I~
public     int      ScoreMax;                                      //~5923I~
public     int      NumTextFontsz,NumTextPosx,NumTextPosx10,NumTextPosy;//~va01R~
public     int      Dencity;                                       //~va03I~

                                                                   //~5921I~
private   Hole[][]    BoardMap= new Hole[ wnp.MAP_SIZE ][ wnp.MAP_SIZE ];//~va01R~

private   int         Mode;                                        //~5921I~
private   int         CurNum;        //current num of cursor       //~5921I~
private  String sMsg,sTempMsg,sMsgOut,sSuccessMsg;               //~5921I~
private   int      KbFocus;                                        //~5923R~
//private   int   ActSeed;                                         //~5923R~
private   int      NpsubRc;                                        //~5921I~
private   int      SameNum;                                        //~5923I~
private   int      Shiftkey;                                       //~5923I~
private   int      Controlkey;                                     //~va20I~
private   int      CongMsg;   //when wnswe ok                      //~5923I~
private   long    TryStartTime;                                    //~5923I~
private   int      TryTimeSpan;    //sec                           //~5923I~
private   int      Penalty;                                        //~5923I~
private   String   Ssamenumstr=null,Sover10numstr=null,Smemonumstr=null;//~va20I~
private   NPWORKT  Npwtryans=new NPWORKT();                        //~v025R~
private static final int PENALTY_NOTIME=   4;   //6*5=20min is standard(no time penalty)//~5923I~
//    score is multiplyed by 30min/elapsed time(5min unit)         //~5923I~
private static final int PENALTY_SAMENUM=  1;                      //~5923I~
private static final int PENALTY_MEMO=     5;                      //~5923I~
private static final int PENALTY_TIME=    50;   //for each 5 min late//~5923I~
private static final int PENALTY_ERR=    100;   //for each 5 min late//~5923I~
                                                                   //~vj01I~
private static final int MAX_CONG= 6;                              //~vj01I~
	                                                               //~5921I~
//color                                                            //~5922M~
public static Color    COL_BG_EMPTY          ;                     //~vj01R~
public static Color    COL_BG_Q              ;                     //~vj01R~
public static Color    COL_BG_P              ;                     //~vj01R~
public static Color    COL_BG_A              ;                     //~vj01R~
public static Color    COL_BG_E              ;                     //~vj01R~
public static Color    COL_BG_RCHK           ;                     //~vj01R~
public static Color    COL_BG_NEXT           ;                     //~vj01R~
public static Color    COL_BG_FORCUS         ;                     //~vj01R~
public static Color    COL_BG_SAMENUM        ;                     //~vj01R~
public static Color    COL_NUM_Q             ;                     //~vj01R~
public static Color    COL_NUM_P             ;                     //~vj01R~
public static Color    COL_NUM_A             ;                     //~vj01R~
public static Color    COL_NUM_E             ;                     //~vj01R~
public static Color    COL_NUM_RCHK          ;                     //~vj01R~
public static Color    COL_NUM_NEXT          ;                     //~vj01R~
public static Color    COL_GRID_BOX          ;                     //~vj01R~
public static Color    COL_GRID_NUM          ;                     //~vj01R~
public static Color    COL_GRID_BOX_MAKE     ;                     //~vj01R~
public static Color    COL_GRID_NUM_MAKE     ;                     //~vj01R~
public static Color    COL_BG_DLG            ;                     //~vj01R~
public static Color    COL_TXT_DLG           ;                     //~vj01R~
public static Color    COL_TXT_SIGN          ;                     //~vj01R~
                                                                   //~0109R~
                                                                   //~0101I~
private Color  OBJ_COLOR[] = {COL_BG_EMPTY                      //~5921R~
						,COL_BG_Q                                  //~9C31R~
						,COL_BG_A                                  //~9C31R~
						,COL_BG_P                                  //~0101I~
						,COL_BG_E                                  //~0101I~
						,COL_BG_RCHK                               //~0109I~
						,COL_BG_NEXT                               //~v004I~
						,COL_GRID_BOX                              //~0102I~
						,COL_GRID_NUM                              //~v004R~
						,COL_GRID_BOX_MAKE                         //~v004I~
						,COL_GRID_NUM_MAKE};                       //~v004I~

private int[][] pdata;                                             //~vj01R~
private Timer timer_ANS=null,timer_MAKE=null,timer_GO=null,timer_SETEND=null,timer_SUCCESS=null;//~vj01R~
private int timerid=0;
private Object[] plistans,plistmake;  
private xnpsub  sub1=new xnpsub(wnp.BOARDTYPE);                    //~va01R~
private xnpsub2 sub2=new xnpsub2(sub1,wnp.BOARDTYPE);              //~va01R~
private Point wkpoint=new Point();                                 //~v004I~
private int[][]	Stempdata=new int[wnp.MAP_SIZE][wnp.MAP_SIZE];     //~va01R~
private int[] temp=new int[wnp.MAP_SIZE+1];                        //~va19I~
private int Scongdispsw=0;                                         //~va21R~
private final int Scongdisptime=300; 	//300ms                    //+va23R~
private final String[] Scongdispstrj={"","","","ؔ"};      //~va23R~
private final String[] Scongdispstre={"E","Bu","Ri","Eburi","Primary","School"};//~va23R~
private final String[] Scongdispstr;                               //~va23I~
private final Color COL_CONG_STR=new Color(0,170,60);              //~va21I~
private final Color COL_CONG_STR2=new Color(0,20,20);              //~va21I~
private       int  Slevelsummary=0;                                //~va21I~
//*************************                                        //~5921I~
//*method                                                          //~5921I~
//*************************                                        //~5921I~
// O[o֐
//void    BoardToScreen( int bx, int by, int* px, int* py );       //~5921R~
//void    ShowObject( CDC* pDC, int bx, int by,                    //~v004R~
//boolean    ScreenToBoard( int wx, int wy, int* pbx, int* pby );    // <---//~vj01R~
//unsigned int MakeThread(LPVOID Pboard);                          //~vj01R~
//unsigned int AnsThread(LPVOID Plist);                            //~vj01R~
static {                                                           //~5922I~
 COL_BG_EMPTY          =new Color(  0, 30,  0);                    //~vj01R~
 COL_BG_Q              =new Color(  0,  0, 50);                    //~vj01R~
 COL_BG_P              =new Color(  0,  0,200);                    //~va19R~
 COL_BG_A              =new Color(  0,  0,150);                    //~vj01R~
 COL_BG_E              =new Color(255,255,255);                    //~vj01R~
 COL_BG_RCHK           =new Color(  0,  0, 50);                    //~vj01R~
 COL_BG_NEXT           =new Color(  0,  0,100);                    //~vj01R~
 COL_BG_FORCUS         =new Color(255,255,255);                    //~vj01R~
 COL_BG_SAMENUM        =new Color(255,255,  0);                    //~vj01R~
 COL_NUM_Q             =new Color(  0,255,  0);                    //~vj01R~
 COL_NUM_P             =new Color(  0,255,  0);                    //~vj01R~
 COL_NUM_A             =new Color(255,255,255);                    //~vj01R~
 COL_NUM_E             =new Color(255,  0,  0);                    //~vj01R~
 COL_NUM_RCHK          =new Color(255,255,  0);                    //~vj01R~
 COL_NUM_NEXT          =new Color(255,255, 50);                    //~vj01R~
 COL_GRID_BOX          =new Color(  0,130,130);                    //~va03R~
 COL_GRID_NUM          =new Color(  0, 70, 70);                    //~v025R~
 COL_GRID_BOX_MAKE     =new Color( 23,230,230);                    //~vj01R~
 COL_GRID_NUM_MAKE     =new Color( 13,130,130);                    //~vj01R~
 COL_BG_DLG            =new Color(  0, 50,  0);                    //~vj01R~
 COL_TXT_DLG           =new Color(200,200,200);                    //~vj01R~
 COL_TXT_SIGN          =new Color(  0, 70,  0);                    //~vj01R~
}//static initializer                                              //~5922I~
/*                                                                 //~9C09I~
===============================================================================
     Board::Board 
===============================================================================
===============================================================================*/
public Board(View Pview)                                      //~5922R~
{
	pView=Pview;                                                   //~va21I~
	if (wnp.BOARDTYPE==wnp.BOARDTYPE3)                             //~va01I~
    {                                                              //~va01I~
		NumTextPosx=wnp.NUMTEXT_MARGIN*8;                          //~va01I~
		NumTextPosx10=wnp.NUMTEXT_MARGIN*8;                        //~va01I~
		NumTextPosy=wnp.OBJECT_SIZE-4;                             //~va01I~
    	NumTextFontsz=32;                                          //~va01R~
    }                                                              //~va01I~
    else                                                           //~va01I~
	if (wnp.BOARDTYPE==wnp.BOARDTYPE3)                             //~va01I~
    {                                                              //~va01I~
		NumTextPosx10=wnp.NUMTEXT_MARGIN*6;                        //~va01R~
		NumTextPosx=wnp.NUMTEXT_MARGIN*10;                         //~va01R~
		NumTextPosy=wnp.OBJECT_SIZE-5;                             //~va01I~
    	NumTextFontsz=26;                                          //~va01R~
    }                                                              //~va01I~
    else                                                           //~va01I~
    {                                                              //~va01I~
		NumTextPosx10=wnp.NUMTEXT_MARGIN*2;                        //~va01R~
		NumTextPosx=wnp.NUMTEXT_MARGIN*8;                          //~va01R~
		NumTextPosy=wnp.OBJECT_SIZE-6;                             //~va01I~
    	NumTextFontsz=22;                                          //~va01R~
    }                                                              //~va01I~
    pPat = null;                                                   //~vj01R~
    for ( int x = 0; x < wnp.MAP_SIZE; x ++ )                      //~va01R~
        for ( int y = 0; y < wnp.MAP_SIZE; y ++ )                  //~va01R~
            BoardMap[ y ][ x ] = new Hole( x, y );                 //~0102R~
    NumCount=0;                                                    //~0101R~
    Mode=MODE_INIT;                                                //~0116R~
    KbFocus=0;                                                     //~0211R~
    sMsg="";                                                       //~0102R~
    sTempMsg="";                                                   //~0102R~
    sSuccessMsg="";                                                //~0211R~
    sProbLevel="";                                                 //~0211I~
    Flags=0;                                                       //~0109R~
    SameNum=0;                                                     //~0206R~
    CurNum=1;       //cursol number                                //~0212I~
    Shiftkey=0;                                                    //~0206I~
    Controlkey=0;                                                  //~va20I~
    ActSeed=0;                                                     //~0212I~
    MaxFixed=FixedSeq=0;                                           //~0109I~
    TryTimeSpan=0;                                    //~0212I~
    Score=0;                                                       //~0213I~
    ScoreMax=0;                                                    //~0226I~
    xnpsub.Gblwnpmode=1;    //call from wnp                        //~vj01I~
	Npwtryans.clear();                                             //~v025I~
    if (wnp.Sjlang)                                                //~va23I~
		Scongdispstr=Scongdispstrj;                                //~va23I~
    else                                                           //~va23I~
		Scongdispstr=Scongdispstre;                                //~va23I~
}
String GetMsg()                                                    //~v004R~
{                                                                  //~0101I~
    String csnull="";                                             //~0102R~
    if ((Flags&F_THREAD)!=0)                                       //~v004R~
    {                                                              //~va16I~
      if (wnp.Sjlang)                                              //~va23I~
    	sMsgOut="lAe~f{^Œf܂";              //~v003R~
     else                                                          //~va23I~
    	sMsgOut="In meditation, use 'Stop' to break it.";          //~va23I~
	    if (GblNpsubMsg!=null)                                     //~va16I~
    		sMsgOut=sMsgOut+"("+GblNpsubMsg+")";                   //~va16I~
    }                                                              //~va16I~
    else                                                           //~0130I~
	if (!sTempMsg.equals(csnull))                                  //~va01R~
    {                                                              //~0102I~
    	sMsgOut=sTempMsg;                                         //~0102I~
        sTempMsg=csnull;                                           //~0102R~
	}                                                              //~0102I~
    else                                                           //~0102I~
    	sMsgOut=sMsg;                                             //~0102I~
//System.out.println("GetMsg="+sMsgOut+",sTempMsg="+sTempMsg+",flag="+(Flags&F_THREAD));//~va03R~
	return sMsgOut;                                                //~0102R~
}                                                                  //~0101I~
void SetTempMsg(String Pmsg)                                       //~v004R~
{                                                                  //~0102I~
//System.out.println("SetTempMsg="+Pmsg);                          //~va03R~
	sTempMsg=Pmsg;                                                 //~0102I~
}                                                                  //~0102I~
/*
===============================================================================
     Board::~Board 
===============================================================================
===============================================================================*/
//void _Board()                                                    //~vj01R~
//{                                                                //~vj01R~
//    for ( int x = 0; x < wnp.MAP_SIZE; x ++ )                    //~vj01R~
//        for ( int y = 0; y < wnp.MAP_SIZE; y ++ )                //~vj01R~
//            delete  BoardMap[ y ][ x ];                          //~vj01R~
//}                                                                //~vj01R~
//===============================================================================//~0206R~
//return Mode at entry                                             //~0206R~
//===============================================================================*///~0206R~
void    CreateBoard( CPattern pat )                               //~v004R~
{
    int oldmode=Mode;                                              //~0206I~
    int pendsw=0;                                                  //~v012I~
//**********************************                               //~v012R~
    pPat = pat;
    ActSeed=pat.Seed;	//it my be from file                       //~v012I~
    NumCount=0;                                                    //~0101R~
    for ( int bx = 0; bx < wnp.MAP_SIZE; bx ++ )                   //~va01R~
        for ( int by = 0; by < wnp.MAP_SIZE; by ++ )               //~va01R~
        {
            if ( BoardMap[ by ][ bx ]!=null )                      //~vj01R~
            {
//              delete BoardMap[ by ][ bx ];                       //~vj01R~
                BoardMap[ by ][ bx ] = null;                       //~vj01R~
            }
            BoardMap[ by ][ bx ] = new Hole( bx, by );
            int num;                                               //~9C09I~
            if ( (num=pPat.QuestionData[ by ][ bx ])!=0 )          //~vj01R~
            {
                BoardMap[ by ][ bx ].SetNum(num,MODE_FILEDATA,0); //~0116R~
                NumCount++;                                        //~0101R~
            }
            else                                                   //~0116I~
                BoardMap[ by ][ bx ].SetNum(0,0,0);               //~0116I~
        }
    if (NumCount!=0)                                               //~vj01R~
    {                                                              //~0116I~
        if (oldmode==MODE_INIT)                                    //~0206I~
            OnAnswer();                                            //~0206I~
//      else                                                       //~v023R~
//  		if ((Flags & F_MODEMAKE)==0)                           //~v023R~
//      		Flags|=F_MODEANS;                                  //~v023R~
	    Mode=MODE_KEYINDATA;          //next is keyin              //~0116R~
    	Flags&=~F_MODEMAKE;                                        //~v023I~
        Flags|=F_MODEANS;                                          //~v023I~
    }                                                              //~0116I~
//  else                                                           //~v023R~
//      if (!(Flags & F_MODEANS))                                  //~v003R~
//          Flags|=F_MODEMAKE;                                     //~v003R~
//  	if ((Flags & F_MODEMAKE)==0)                               //~v023R~
//      	Flags|=F_MODEANS;                                      //~v023R~
    Flags&=~(F_ERROR|F_ONXX);                                      //~0130R~
//restore pending data                                             //~v012I~
    for ( int ii = 0; ii < wnp.MAP_SIZE; ii ++ )                   //~va01R~
        for ( int jj = 0; jj < wnp.MAP_SIZE; jj ++ )               //~va01R~
        {                                                          //~v012I~
        	if (pPat.PendingData[ii][jj]!=0)                          //~v012I~
            {                                                      //~v012I~
            	pendsw=1;                                          //~v012I~
                break;                                             //~v012I~
            }                                                      //~v012I~
        }                                                          //~v012I~
    if (pendsw!=0)                                                    //~v012I~
    {                                                              //~v012I~
   		Flags&=~F_ONXX;                                            //~v012I~
    	Flags|=F_ONTRY;                                            //~v012I~
    	Flags|=F_READFILE;                                         //~v012I~
        OnSetend(0);    //get anser data                           //~v012I~
        ScoreMax=pPat.ScoreMax;                                   //~v024I~
    }                                                              //~v012I~
    sProbLevel="";                                                 //~0211I~
}
//******************************************                       //~v012I~
//restore pending data                                             //~v012I~
//******************************************                       //~v012I~
void    Restoreprevinput( )                                        //~v012I~
{                                                                  //~v012I~
	int inputnum;                                                  //~v012I~
//***********************                                          //~v012I~
    for ( int ii = 0; ii < wnp.MAP_SIZE; ii ++ )                   //~va01R~
        for ( int jj = 0; jj < wnp.MAP_SIZE; jj ++ )               //~va01R~
        {                                                          //~v012I~
        	inputnum=pPat.PendingData[ii][jj];                     //~v012I~
            if (inputnum!=0)                                          //~v012I~
            {                                                      //~v012I~
                BoardMap[ii][jj].SetNum(inputnum,MODE_KEYINANS,Hole.HOLE_PENDDATA);//~v024R~
                NumCount++;                                        //~v012I~
            }                                                      //~v012I~
        }                                                          //~v012I~
}                                                                  //~v012I~
////===============================================================================*///~0122R~
void    ResetErr(int Pnextclearsw)                                 //~v004R~
{                                                                  //~0122R~
	int err;                                                  //~0212I~
    for ( int bx = 0; bx < wnp.MAP_SIZE; bx ++ )                   //~va01R~
        for ( int by = 0; by < wnp.MAP_SIZE; by ++ )               //~va01R~
        {                                                          //~0212I~
        	err=BoardMap[ by ][ bx ].GetErr();                    //~0212R~
            if (err==0)                                              //~0212I~
            	continue;                                          //~0212I~
            if (err==Hole.HOLE_PENDDATA) 	//keep file input pending data//~v024I~
            	continue;                                          //~v024I~
            err=(err/Hole.HOLE_NEXT)*Hole.HOLE_NEXT;	//clear other than NEXT//~vj01R~
        	if (Pnextclearsw!=0)                                   //~vj01R~
            	if (err>=Hole.HOLE_NEXT)                           //~vj01R~
                	err-=Hole.HOLE_NEXT;                           //~vj01R~
    	    BoardMap[ by ][ bx ].SetNum(-1,-1,err);               //~0212R~
		}	                                                       //~0212I~
}                                                                  //~0122R~
//===============================================================================*///~0102I~
//===============================================================================*///~0103I~
//=for Question case                                               //~0116I~
//===============================================================================*///~0116I~
void    SetAllAnswer()                                             //~v004R~
{                                                                  //~0103I~
	M99  pm99;                                                    //~0103I~
    NPWORKT pnpwt;                                                //~0103I~
    int  mode,err,num;                                             //~0122R~
//*********                                                        //~0103I~
    pnpwt=Npworkt;                                                 //~v004R~
    for ( int bx = 0; bx < wnp.MAP_SIZE; bx ++ )                   //~va01R~
        for ( int by = 0; by < wnp.MAP_SIZE; by ++ )               //~va01R~
        {                                                          //~0103I~
            Hole phole=BoardMap[ bx ][ by ];                       //~vj01R~
		    pm99=pnpwt.m99[bx][by];     //answer                   //~v004R~
            num=phole.GetNum();          //init data              //~0130I~
            if (num==0)					//may set ans	           //~vj01R~
        		if ((Flags&F_MODEANS)!=0)    //ignore ans when make mode//~v004R~
            		num=pm99.fnum;		//result                   //~0130R~
            err=0;                                                 //~0108I~
            if (num!=0)                                            //~vj01R~
                if (MaxFixed!=0 && MaxFixed!=wnp.PEG_MAX)  //err   //~va01R~
                {                                                  //~0122R~
                    if (MaxFixed==pm99.fseq && NpsubRc!=12)  //err stopped not multi sol//~0130R~
                        err=Hole.HOLE_ERR;                         //~vj01R~
                    if (pm99.fnum==0||pm99.dlvl==xnpsub.LEVEL_INIT)	//	init data err//~vj01R~
                    	mode=phole.GetState();                           //~0122R~
                    else                                           //~0122I~
                    	mode=MODE_OUTANS;                          //~0123R~
                }                                                  //~0122R~
                else                                               //~0122R~
                    if (pm99.dlvl==xnpsub.LEVEL_INIT)              //~vj01R~
                        mode=-1;    //no change                    //~0122I~
                    else                                           //~0122I~
						if ((Flags&F_ONRCHK)!=0) //set all when rchk mode//~v004R~
//                          mode=MODE_OUTANS;                      //~v020R~
                            mode=-1;	//nochange                 //~v020R~
                        else                                       //~0108R~
                            mode=-1;	//nochange                 //~0116R~
			else                                                   //~0103I~
            	mode=0;                                            //~0103I~
            if (mode>=0)	//set data                             //~0116I~
            {                                                      //~0123I~
            	phole.SetNum(num,mode,err);                       //~0122R~
            }                                                      //~0123I~
                                                                   //~0103I~
        }                                                          //~0103I~
	if ((Flags & F_ONRCHK)!=0 && MaxFixed==wnp.PEG_MAX)            //~va01R~
    {                                                              //~0129I~
//      Mode=MODE_OUTANS;                                          //~v020R~
//  	FixedSeq=MaxFixed;                                         //~v020R~
//      SaveAnswer();                                              //~v020R~
        MaxFixed=FixedSeq=pnpwt.idatano;		//initial no       //~v020R~
	    pnpwt.seqno=MaxFixed;                                      //~v020R~
    }                                                              //~0129I~
    else                                                           //~0109I~
//        if (!(Flags & F_ONTRY))                                  //~0130R~
        {                                                          //~0130R~
            if (MaxFixed!=wnp.PEG_MAX)  //err                      //~va01R~
                FixedSeq=MaxFixed;                                 //~0130R~
            else                                                   //~0130R~
                FixedSeq=pnpwt.idatano;                           //~0130R~
            if (MaxFixed!=pnpwt.idatano)                          //~0130R~
                Mode=MODE_OUTANS;                                  //~0130R~
        }                                                          //~0130R~
                                                                   //~0129I~
}                                                                  //~0103I~
//===============================================================================*///~v012I~
//get current input number                                         //~v012I~
//===============================================================================*///~v012I~
void    GetInpnum(int [][]Pinpnum)                                   //~v012I~
{                                                                  //~v012I~
	Hole phole;                                                    //~v012I~
    int  ii,jj;                                                    //~v012I~
//*******************************                                  //~v012I~
    for (ii=0;ii<wnp.MAP_SIZE;ii++)                                //~va01R~
        for (jj=0;jj<wnp.MAP_SIZE;jj++)                            //~va01R~
        {                                                          //~v012I~
	    	phole=BoardMap[ii][jj];                                //~v012I~
            if (phole!=null)                                             //~v012I~
	    		Pinpnum[ii][jj]=phole.GetNum();                    //~v012I~
            else                                                   //~v012I~
	    		Pinpnum[ii][jj]=0;                                 //~v012I~
        }                                                          //~v012I~
}                                                                  //~v012I~
//===============================================================================*///~0129I~
//save hole answer data to pattern for answer write                //~0129I~
//===============================================================================*///~0129I~
void    SaveAnswer()                                               //~v004R~
{                                                                  //~0129I~
    for (int ii=0;ii<wnp.MAP_SIZE;ii++)                            //~va01R~
        for (int jj=0;jj<wnp.MAP_SIZE;jj++)                        //~va01R~
	    	pPat.SetAnsData(ii,jj,BoardMap[ii][jj].GetNum());    //~0129I~
}                                                                  //~0129I~
//===============================================================================*///~0312I~
//save xnp result answer                                           //~0312I~
//===============================================================================*///~0312I~
void    SaveAnswerXnp()                                            //~v004R~
{                                                                  //~0312I~
//*******************                                              //~0312I~
    for (int ii=0;ii<wnp.MAP_SIZE;ii++)                            //~va01R~
        for (int jj=0;jj<wnp.MAP_SIZE;jj++)                        //~va01R~
	    	pPat.SetAnsData(ii,jj,Npworkt.m99[ii][jj].fnum);     //answer//~0312R~
}                                                                  //~0312I~
//===============================================================================*///~0129I~
//=che i'll try answer                                             //~0129I~
//===============================================================================*///~0129I~
int CheckAnswer(int Pallsw)                                        //~v004R~
{                                                                  //~0129I~
    int   ii,jj,err=0,num;                                         //~0312R~
    Hole phole;                                                    //~vj01R~
//************                                                     //~0129I~
	ResetErr(0);	//once clear err                               //~0212I~
//row                                                              //~0129I~
    for (ii=0;ii<wnp.MAP_SIZE;ii++)                                //~va01R~
        for (jj=0;jj<wnp.MAP_SIZE;jj++)                            //~va01R~
	    {//~0312R~
        	phole=BoardMap[ii][jj];
		    num=phole.GetNum();                                   //~0312R~
			if (num!=pPat.GetAnsData(ii,jj))                      //~0312I~
		    	if (Pallsw!=0 || num!=0)                           //~vj01R~
                {                                                  //~0312I~
	                err=1;                                         //~0312I~
            		phole.SetNum(-1,-1,Hole.HOLE_ERR);             //~vj01R~
                }                                                  //~0312I~
	    }	//~0312I~
	if (Pallsw!=0)                                                 //~vj01R~
        if (err==0)                                                //~vj01R~
        {                                                          //~0312R~
            CongMsg=0;                                             //~0312R~
            OnSuccess();                                           //~0312R~
            Mode=MODE_OUTANS;                                      //~0312R~
	        long ctime=System.currentTimeMillis();                 //~vj01R~
            long ts=ctime-TryStartTime;                            //~vj01R~
            TryTimeSpan=(int)(ts/1000);                            //~vj01R~
            if (timer_SETEND!=null)                                //~vj01I~
            {                                                      //~vj01I~
            	timer_SETEND.stop();                               //~vj01R~
                timer_SETEND=null;                                 //~vj01I~
            }                                                      //~vj01I~
            CalcScore();                                           //~0312R~
        }                                                          //~0312R~
        else                                                       //~0312R~
        {                                                          //~0312R~
            Flags|=F_ERROR;                                        //~0312R~
          if (wnp.Sjlang)                                          //~va23I~
            SetTempMsg("H");                                  //~0312R~
          else                                                     //~va23I~
            SetTempMsg("CorrectH");                               //~va23I~
        }                                                          //~0312R~
    return err;                                                    //~0312I~
}//CheckAnswer                                                     //~vj01R~
//=============================================================================*///~0211I~
int     OnSuccess()                                                //~v004R~
{                                                                  //~0211I~
	int[] waittm={1,1,1,2,1,3};                          //~vj01R~
    int col;                                                       //~vj01R~
//************************                                         //~va21I~
  if (wnp.Sjlang)                                                  //~va23I~
    SetTempMsg("I");                                          //~0227I~
  else                                                             //~va23I~
    SetTempMsg("DoneI");                                          //~va23I~
    if (CongMsg>=MAX_CONG)                                         //~0211R~
    {                                                              //~0211I~
        Scongdispsw=0;                                             //~va21I~
//System.out.println("onsuccess  repeat="+CongMsg+",score="+Score+",max="+ScoreMax);//~va21R~
        if (CongMsg==MAX_CONG)  //last                             //~va21R~
        {                                                          //~va21R~
    		if ((Slevelsummary & (xnpsub.LEVEL_HARDP2_S|xnpsub.LEVEL_HARDP1_S))!=0)//~va21R~
        	if (Score>(ScoreMax/2))                                //~va21I~
            {                                                      //~va21I~
                Scongdispsw=1;                                     //~va21R~
                timerid=IDC_SUCCESS;                               //~va21R~
                timer_SUCCESS=new Timer(Scongdisptime,pView);   //100ms//~va21R~
                timer_SUCCESS.setCoalesce(true);                   //~va21R~
                timer_SUCCESS.setRepeats(false);                   //~va21R~
                timer_SUCCESS.start();                             //~va21R~
                CongMsg++;                                         //~va21R~
                return 0;                                          //~va21R~
            }                                                      //~va21I~
        }                                                          //~va21R~
        return TryTimeSpan;                                        //~0212R~
	}                                                              //~0211I~
    col=OBJ_COLOR[ST_QDATA].getRGB();                              //~vj01R~
    col=((col & 0x0000ffff)<<8)+((col & 0x00ff0000)>>16);          //~0211R~
    OBJ_COLOR[ST_QDATA]=new Color(col);                            //~vj01R~
                                                                   //~0211R~
    col=OBJ_COLOR[ST_ANS].getRGB();                                //~vj01R~
    col=((col & 0x0000ffff)<<8)+((col & 0x00ff0000)>>16);          //~0211R~
    OBJ_COLOR[ST_ANS]=new Color(col);                              //~vj01R~
                                                                   //~0211R~
    col=OBJ_COLOR[ST_NEXT].getRGB();                               //~vj01R~
    col=((col & 0x0000ffff)<<8)+((col & 0x00ff0000)>>16);          //~0211I~
    OBJ_COLOR[ST_NEXT]=new Color(col);                             //~vj01R~
                                                                   //~0211I~
    col=OBJ_COLOR[GRID1].getRGB();                                 //~vj01R~
    col=((col & 0x0000ffff)<<8)+((col & 0x00ff0000)>>16);          //~0211R~
    OBJ_COLOR[GRID1]=new Color(col);                               //~vj01R~
                                                                   //~0211R~
    col=OBJ_COLOR[GRID2].getRGB();                                 //~vj01R~
    col=((col & 0x0000ffff)<<8)+((col & 0x00ff0000)>>16);          //~0211R~
    OBJ_COLOR[GRID2]=new Color(col);                               //~vj01R~
//    if (CongMsg!=0)                                              //~va21R~
//        if (timer_SUCCESS!=null)                                 //~va21R~
//        {                                                        //~va21R~
//            timer_SUCCESS.stop();                                //~va21R~
//            timer_SUCCESS=null;                                  //~va21R~
//        }                                                        //~va21R~
    timerid=IDC_SUCCESS;                                           //~vj01I~
    timer_SUCCESS=new Timer(waittm[CongMsg]*500,pView);            //~vj01I~
    timer_SUCCESS.setCoalesce(true);                               //~vj01I~
//  timer_SUCCESS.setRepeats(true);                                //~va21R~
    timer_SUCCESS.setRepeats(false);                               //~va21I~
    timer_SUCCESS.start();                                         //~vj01I~
    CongMsg++;                                                     //~0211R~
    return 0;                                                      //~0212I~
}                                                                  //~0211I~
//===============================================================================*///~0108I~
int SetNextAnswer(int Pfixedseq)                                   //~v004R~
{                                                                  //~0108I~
	M99  pm99;                                                     //~vj01R~
    NPWORKT pnpwt;                                                 //~vj01R~
	Hole phole;                                                    //~vj01R~
    int  bx,by;                                                    //~0123R~
//*********                                                        //~0108I~
    pnpwt=Npworkt;                                                 //~v004R~
//reset previous last id                                           //~0108I~
    for (bx = 0; bx < wnp.MAP_SIZE; bx ++ )                        //~va01R~
        for (by = 0; by < wnp.MAP_SIZE; by ++ )                    //~va01R~
        {                                                          //~0108I~
		    pm99=pnpwt.m99[bx][by];     //answer                   //~v004R~
            if (pm99.fnum!=0)                                      //~vj01R~
            {                                                      //~0108I~
            	if (pm99.fseq==Pfixedseq-1)                       //~0108I~
                {                                                  //~0108I~
		            phole=BoardMap[ bx ][ by ];                    //~0108I~
                    if (phole.GetState()==MODE_OUTANS)            //~0116R~
	            		phole.SetNum(pm99.fnum,MODE_OUTANS,0);//reset err//~0123I~
            	}                                                  //~0108I~
            }                                                      //~0108I~
        }                                                          //~0108I~
    for (bx = 0; bx < wnp.MAP_SIZE; bx ++ )                        //~va01R~
        for (by = 0; by < wnp.MAP_SIZE; by ++ )                    //~va01R~
        {                                                          //~0108I~
		    pm99=pnpwt.m99[bx][by];     //answer                   //~v004R~
            if (pm99.fnum!=0)                                      //~vj01R~
            {                                                      //~0108I~
            	if (pm99.fseq==Pfixedseq)                         //~0108I~
                {                                                  //~0108I~
		            phole=BoardMap[ bx ][ by ];                    //~0108I~
            		phole.SetNum(pm99.fnum,MODE_OUTANS,0);       //~0116R~
                    KbFocus=bx*wnp.MAP_SIZE+by;    //set forcus    //~va01R~
                    NumCount++;                                    //~0123I~
                    return 0;                                      //~0108I~
            	}                                                  //~0108I~
            }                                                      //~0108I~
        }                                                          //~0108I~
	return 4;                                                      //~0108I~
}                                                                  //~0108I~
/*
===============================================================================
     Board::Show 
===============================================================================
===============================================================================*/
void    Show(Graphics pDC)                                         //~vj01R~
{
    int sz,idx;                                                    //~va21R~
    long tm;                                                       //~va21I~
//*******************                                              //~va21I~
    if (Scongdispsw!=0)	//display success last char                //~va21R~
    {                                                              //~va21I~
        tm=System.currentTimeMillis()/1000;                        //~va21I~
        idx=(int)tm%4;		//0,1,2,3                              //~va21R~
        if (idx==3)                                                //~va21I~
        {                                                          //~va21I~
	        sz=(wnp.OBJECT_SIZE+wnp.GAP)*wnp.MAP_SIZE/2;           //~va21I~
            if (!wnp.Sjlang)                                       //~va23I~
              	sz/=2;                                             //~va23I~
			pDC.setFont(new java.awt.Font(wnp.Sfontname, java.awt.Font.PLAIN,sz));//~va23R~
        	pDC.setColor(COL_CONG_STR2);                           //~va21I~
        	pDC.drawString(Scongdispstr[idx],0,sz);                //~va21I~
            if (!wnp.Sjlang)                                       //~va23I~
            {                                                      //~va23I~
	        	pDC.drawString(Scongdispstr[idx+1],sz/2,sz+sz);    //~va23I~
	        	pDC.drawString(Scongdispstr[idx+2],sz,sz+sz+sz);   //~va23I~
            }                                                      //~va23I~
        }                                                          //~va21I~
        else                                                       //~va21I~
        {                                                          //~va21I~
	        sz=(wnp.OBJECT_SIZE+wnp.GAP)*wnp.BOARDTYPE;            //~va21I~
			pDC.setFont(new java.awt.Font(wnp.Sfontname, java.awt.Font.PLAIN,sz));//~va23R~
        	pDC.setColor(COL_CONG_STR);                            //~va21R~
        	pDC.drawString(Scongdispstr[idx],idx*sz,(idx+1)*sz);   //~va21R~
        }                                                          //~va21I~
    	return;                                                    //~va21I~
    }                                                              //~va21I~
//System.out.println("Board:Show");                                //~v012R~
    int samenum=SameNum;                                           //~0212I~
    if ((Flags & F_MODEMAKE)!=0)                                   //~v004R~
        samenum=0;                                                 //~0212I~
    ShowGrid(pDC);                                                 //~0101I~
                                                                   //~0205I~
    for ( int bx = 0; bx < wnp.MAP_SIZE; bx ++ )                   //~va01R~
        for ( int by = 0; by < wnp.MAP_SIZE; by ++ )               //~va01R~
        {
            if ( BoardMap[ by ][ bx ]!=null )                      //~vj01R~
            {                                                      //~va03I~
//System.out.println("call hole show bx="+bx+",by="+by+",samenum="+samenum);//~va03R~
                BoardMap[ by ][ bx ].Show( pDC,                    //~vj01R~
                                            (KbFocus==by*wnp.MAP_SIZE+bx)?1:0,//~va01R~
                                             samenum,              //~0212R~
							                 (Flags&F_MODEANS)!=0||Mode==MODE_ENDQDATA);//~v004R~
            }                                                      //~va03I~
        }
}
//=============================================================================*///~9C09I~
void    ShowGrid( Graphics pDC)                                    //~vj01R~
{                                                                  //~9C09M~
    int x, y,bx;                          //~9C09M~
	Color  br1M=OBJ_COLOR[GRID1_MAKE];                             //~va23R~
    Color  br2M=OBJ_COLOR[GRID2_MAKE];                             //~va23R~
	Color  br1A=OBJ_COLOR[GRID1];                                  //~va23R~
    Color  br2A=OBJ_COLOR[GRID2];                                  //~va23R~
    Color  br;                                                     //~vj01I~
    Color old_br=pDC.getColor();                                   //~vj01R~
                                                                   //~vj01I~
    if ((Flags & F_MODEMAKE)!=0)                                   //~v004R~
    	br=br1M;   //inner grid;save cuurrent                      //~vj01R~
    else                                                           //~0212I~
    	br=br1A;   //inner grid;save cuurrent                      //~vj01R~
//System.out.println("ShowGrid1:r="+br.getRed()+",g="+br.getGreen()+",b="+br.getBlue());//~vj01R~
    BoardToScreen( 0,0,wkpoint);                                   //~va23R~
    x=wkpoint.x;y=wkpoint.y;                                       //~v004I~
    pDC.setColor(br);   //outer line                               //~va03I~
    pDC.fillRect( x-wnp.GAP, y-wnp.GAP,                            //~vj01R~
                 (wnp.OBJECT_SIZE+wnp.GAP)*wnp.MAP_SIZE+wnp.GAP,   //~va01R~
                 (wnp.OBJECT_SIZE+wnp.GAP)*wnp.MAP_SIZE+wnp.GAP);  //~va01R~
                                                                   //~9C09I~
    if ((Flags & F_MODEMAKE)!=0)                                   //~vj01R~
    	br=br2M;				//outer grid                       //~vj01R~
    else                                                           //~0212I~
    	br=br2A;				//outer grid                       //~vj01R~
    pDC.setColor(br);   //inner grid;save cuurrent                 //~vj01I~
//System.out.println("ShowGrid2:r="+br.getRed()+",g="+br.getGreen()+",b="+br.getBlue());//~vj01R~
    for ( bx = 0; bx <wnp.MAP_SIZE; bx ++ )      //virtical line   //~va01R~
    {                                                              //~9C09I~
    	BoardToScreen( bx/wnp.BOARDTYPE*wnp.BOARDTYPE,bx%wnp.BOARDTYPE*wnp.BOARDTYPE, wkpoint);//~va23R~
	    x=wkpoint.x;y=wkpoint.y;                                   //~v004I~
	    pDC.fillRect( x, y,(wnp.OBJECT_SIZE+wnp.GAP)*wnp.BOARDTYPE-wnp.GAP,(wnp.OBJECT_SIZE+wnp.GAP)*wnp.BOARDTYPE-wnp.GAP);//~v012R~
	}                                                              //~9C09R~
    br=old_br;                                                     //~vj01I~
    pDC.setColor(br);                                              //~vj01R~
//System.out.println("ShowGrid3 old:r="+br.getRed()+",g="+br.getGreen()+",b="+br.getBlue());//~va03R~
}                                                                  //~9C09M~
                                                                 //~9C09I~
//=============================================================================*///~0101I~
//condition to NumBtn dispable                                     //~0101I~
// return numbutton enable                                         //~0116I~
//=============================================================================*///~0101I~
boolean  ShowNumBtn()                                              //~vj01R~
{                                                                  //~0101I~
	boolean enable=FALSE;                                          //~vj01R~
    if ((Flags&F_THREAD)!=0)                                       //~v004R~
    	return enable;		//false                                //~0129I~
                                                                   //~0130I~
    switch (Mode)                                                 //~0101I~
    {                                                              //~0101I~
    case MODE_INIT:                                                //~0102I~
        enable=TRUE;                                               //~v003I~
      if (wnp.Sjlang)                                              //~va23I~
    	sMsg="ݒ肵ĂB͂t@Cj[efB";//~vj01R~
      else                                                         //~va23I~
    	sMsg="Set question data by manual input,thru file menu or pressing 'Make'.";//~va23I~
        break;                                                     //~0102I~
    case MODE_NOINPUT:                                             //~0122R~
        if ((Flags&F_MODEANS)!=0)                                  //~v004R~
        {                                                          //~0122R~
            enable=TRUE;                                           //~0122R~
	      if (wnp.Sjlang)                                          //~va23I~
            sMsg="f[^ݒ肵Ă";                   //~vj01R~
          else                                                     //~va23I~
            sMsg="Set question data.";                             //~va23I~
        }                                                          //~0122R~
        else                                                       //~0122R~
	      if (wnp.Sjlang)                                          //~va23I~
            sMsg="p^[[f[^ݒ肵Ă";             //~vj01R~
          else                                                     //~va23I~
            sMsg="Set pattern mask.";                              //~va23I~
        break;                                                     //~0122R~
    case MODE_FILEDATA:		//just after file in                   //~0116R~
		if ((Flags&F_MODEANS)!=0)                                  //~v004R~
	    	enable=TRUE;                                           //~0116I~
	  if (wnp.Sjlang)                                              //~va23I~
    	sMsg="CȂ΁eIfĂJnĂ";//~vj01R~
      else                                                         //~va23I~
    	sMsg="If there is no modification,press 'Try!' then timer starts.";//~va23I~
        break;                                                     //~0101I~
    case MODE_KEYINDATA:	//input from screen                    //~0116I~
        if ((Flags&F_MODEANS)!=0)                                  //~v004R~
            enable=TRUE;                                           //~0129R~
	  if (wnp.Sjlang)                                              //~va23I~
        sMsg="ݒ芮ȂeIfĂJnĂ"; //~vj01R~
      else                                                         //~va23I~
        sMsg="If end of question data setup,press 'Try!' then timer starts.";//~va23I~
        break;                                                     //~0116I~
    case MODE_ENDQDATA:                                             //~0116R~
//        if (Flags&F_MODEANS)                                     //~v003R~
//        {                                                        //~v003R~
	       if (wnp.Sjlang)                                         //~va23I~
	    	sMsg="͂IeHfă`FbNĂ";//~vj01R~
           else                                                    //~va23I~
	    	sMsg="Check your answer is correct or not by pressing 'Ans!' if input completed.";//~va23I~
    		enable=TRUE;                                           //~0123I~
//        }                                                        //~v003R~
//        else                                                     //~v003R~
//            sMsg.Format("쐬,ꍇ͉𓚃[hɂĂ");//~v003R~
        break;                                                     //~0116M~
    case MODE_KEYINANS:                                            //~0116I~
//        if (Flags & F_ANSCHK)                                    //~0205R~
//        {                                                        //~0205R~
//            if (NpsubRc)                                         //~0205R~
//            {                                                    //~0205R~
//                SetTempMsg("H");                            //~0205R~
//                enable=TRUE;                                     //~0205R~
//            }                                                    //~0205R~
//            else                                                 //~0205R~
//            {                                                    //~0205R~
//                SetTempMsg("I");                            //~0205R~
//                sMsg.Format("I");                           //~0205R~
//            }                                                    //~0205R~
//        }                                                        //~0205R~
//        else                                                     //~0205R~
//        {                                                        //~0205R~
//            sMsg.Format("͂esfŊmFĂ");//~0227R~
//            enable=TRUE;                                         //~0205R~
//        }                                                        //~0205R~
        if (NumCount==wnp.PEG_MAX)                                 //~va01R~
        {                                                          //~0212I~
        	if ((Flags & F_ERROR)!=0)                              //~v004R~
    			enable=TRUE;                                       //~0212I~
            else                                                   //~v012I~
	       if (wnp.Sjlang)                                         //~va23I~
        	sMsg="eHfŊmFĂ";                   //~vj01R~
           else                                                    //~va23I~
        	sMsg="eConfirm answer by 'Ans?' button.";             //~va23I~
        }                                                          //~0212I~
        else                                                       //~0205I~
        {                                                          //~0205I~
	      if (wnp.Sjlang)                                          //~va23I~
        	sMsg="󔒂𖄂߂Ă";                           //~vj01R~
          else                                                     //~va23I~
        	sMsg="fill empty place";                               //~va23I~
            enable=TRUE;                                           //~0205I~
        }                                                          //~0205I~
        break;                                                     //~0116I~
    case MODE_OUTANS:                                              //~0116I~
        if ((Flags & F_ERROR)!=0)                                  //~v004R~
    		enable=TRUE;                                           //~0130I~
	    sMsg=sSuccessMsg;                                          //~vj01R~
        break;                                                     //~0116I~
    }                                                              //~0101I~
//    if (!enable)                                                 //~0205R~
//        CurNum=0;                                                //~0205R~
//System.out.println("Mode="+Mode+",flag="+Flags+sMsg);            //~va03R~
    return enable;                                                 //~0101I~
}                                                                  //~0101I~
//===============================================================================//~0123R~
boolean	DropDown( Point point,int Pnum)                            //~vj01R~
{                                                                  //~9C09I~
    int    bx, by,newnum;                                          //~0102R~
    int    oldmode=Mode;                                           //~0123I~
    if (Pnum==-1)         //mouse                                  //~0129R~
    {                                                              //~0102I~
    	if ( ! ScreenToBoard( point.x, point.y, wkpoint) )         //~v004R~
        	return FALSE;                                          //~va23R~
	    bx=wkpoint.x;by=wkpoint.y;                                 //~v004I~
	    KbFocus=by*wnp.MAP_SIZE+bx;                                //~va01R~
	}                                                              //~0102I~
	else                  //kbd input                              //~0129R~
    {                                                              //~0102I~
    	bx=KbFocus%wnp.MAP_SIZE;                                   //~va01R~
    	by=KbFocus/wnp.MAP_SIZE;                                   //~va01R~
    }                                                              //~0102I~
    Hole   p_hole= BoardMap[ by ][ bx ];                           //~vj01R~
    if (Pnum==-1)                                                  //~v025I~
    	newnum=CurNum;		//from mouse                           //~v025I~
	else                                                           //~v025I~
    	newnum=Pnum;                                               //~v025I~
//  if ( ! CanMove(p_hole) )                                       //~v025R~
    if ( ! CanMove(p_hole,newnum) )                                //~v025I~
        return FALSE;                                              //~9C28I~
                                                                   //~0116I~
	if (Mode==MODE_NOINPUT)                                        //~0122R~
    	Mode=MODE_KEYINDATA;                                       //~0116I~
    else                                                           //~0123I~
	if (Mode==MODE_ENDQDATA)                                       //~0123I~
        if ((Flags & F_MODEANS)!=0)                                //~v004R~
    		Mode=MODE_KEYINANS;                                    //~0123R~
        else                                                       //~0123I~
    		Mode=MODE_KEYINDATA;	//accept modification          //~0123I~
                                                                   //~0116I~
//  if (Pnum==-1)                                                  //~v025R~
//  	newnum=CurNum;		//from mouse                           //~v025R~
//  else                                                           //~v025R~
//  	newnum=Pnum;                                               //~v025R~
    int num=p_hole.GetNum();                                      //~0101R~
    int addv=1;                                                    //~0101I~
    if ((Flags&F_MODEMAKE)!=0)    //pattern setting                //~v004R~
        if (num!=0||newnum==-PATTERN_ID)	//already set or force reset//~vj01R~
            p_hole.SetNum(0,0,0);                                 //~0101I~
        else                                                       //~0101I~
            p_hole.SetNum(PATTERN_ID,Mode,0);                     //~0101I~
    else                     //ans mode                            //~0129R~
    	if (num!=0)                                                //~vj01R~
        	if (newnum!=0 && (newnum!=num || Pnum!=-1))//accept key even if same//~v004R~
            {                                                      //~0123I~
	            p_hole.SetNum(newnum,Mode,0);                     //~0123R~
                addv=0;		//num chng,no count chng               //~0123I~
			}                                                      //~0123I~
    	    else                                                   //~0123R~
        	    p_hole.SetNum(0,0,0);                             //~0123R~
        else                                                       //~0123I~
        	if (newnum!=0)                                         //~vj01R~
	        	p_hole.SetNum(newnum,Mode,0);                     //~0123R~
            else                                                   //~0123I~
            	addv=0;                                            //~0123I~
	if (num!=0)                                                    //~vj01R~
    	NumCount-=addv;                                            //~0101R~
    else                                                           //~0101M~
    	NumCount+=addv;                                            //~0101R~
	SetNewNum(by,bx,p_hole,0,0);	//no setans	                   //~0312R~
    if (oldmode!=Mode||NumCount==wnp.PEG_MAX||NumCount==0)         //~va01R~
        ShowNumBtn();                                              //~0123I~
    return TRUE;                                                   //~9C28I~
}                                                                  //~9C09I~
//===============================================================================//~0205M~
//== chk drop down available                                       //~0205M~
//===============================================================================//~0205M~
//boolean    CanMove(Hole pHole)                                   //~v025R~
boolean    CanMove(Hole pHole,int Pnum)                            //~v025I~
{                                                                  //~0205M~
    if ((Flags & (F_MODEANS|F_MODEMAKE))==0)                       //~v004R~
    {                                                              //~v025I~
    	if (Mode==MODE_INIT)                                       //~v025I~
        {                                                          //~v025I~
    		Mode=MODE_NOINPUT;                                     //~v025I~
            if (Pnum==0)                                           //~v025I~
			    Flags|=F_MODEMAKE;                                 //~v025I~
            else                                                   //~v025I~
			    Flags|=F_MODEANS;                                  //~v025I~
            return true;                                           //~v025I~
    	}                                                          //~v025I~
    	return FALSE;                                              //~0205M~
    }                                                              //~v025I~
	if ((Flags & F_THREAD)!=0)	//running subthread                //~v004R~
    	return FALSE;                                              //~0205M~
    if (Mode==MODE_OUTANS && (Flags & F_ERROR)==0)                 //~v004R~
    	return FALSE;                                              //~0205M~
    int state=pHole.GetState();                                   //~0205M~
    if (pHole.GetErr()==Hole.HOLE_NEXT)                            //~vj01R~
	    return FALSE;                                              //~0205M~
                                                                   //~0205M~
    if (Mode>MODE_ENDQDATA)                                        //~0205M~
    	if (state!=0 && state<MODE_ENDQDATA)                       //~v004R~
	    	return FALSE;                                          //~0205M~
    return TRUE;                                                   //~0205M~
}                                                                  //~0205M~
//===============================================================================//~0205I~
//=rc:0:bypass,1:processed(need invalidate),==============================================================================//~0212I~
//===============================================================================//~0212I~
boolean SetMemo(Point point,int Pnum)                              //~vj01R~
{                                                                  //~0205I~
    int    bx, by,newnum;                                          //~0213R~
    if (Pnum==-1)         //mouse                                  //~0205I~
    {                                                              //~0205I~
    	if ( ! ScreenToBoard( point.x, point.y, wkpoint) )         //~v004R~
        	return FALSE;                                          //~va23R~
	    bx=wkpoint.x; by=wkpoint.y;                                //~v004I~
	    KbFocus=by*wnp.MAP_SIZE+bx;                                //~va01R~
	}                                                              //~0205I~
	else                  //kbd input                              //~0205I~
    {                                                              //~0205I~
    	bx=KbFocus%wnp.MAP_SIZE;                                   //~va01R~
    	by=KbFocus/wnp.MAP_SIZE;                                   //~va01R~
    }                                                              //~0205I~
//System.out.println("SetMemo num="+Pnum+",bx="+bx+",by="+by);     //~v012R~
    Hole   p_hole= BoardMap[ by ][ bx ];                           //~vj01R~
    if (!CanSetMemo(p_hole) )                                      //~0205R~
        return TRUE;                                               //~0213R~
                                                                   //~0205I~
    if (Pnum==-1)                                                  //~0205I~
    	newnum=CurNum;		//from mouse                           //~0205I~
	else                                                           //~0205I~
    	newnum=Pnum;                                               //~0205I~
	if (p_hole.SetMemo(newnum)!=0)		//set memo                 //~vj01R~
    	CountPenalty(PENALTY_MEMO);                                //~0213I~
    return TRUE;                                                   //~0212R~
}                                                                  //~0205I~
//===============================================================================//~0205I~
//== chk drop down available                                       //~0205I~
//===============================================================================//~0205I~
boolean    CanSetMemo(Hole pHole)                                  //~vj01R~
{                                                                  //~0205I~
    if (Mode!=MODE_KEYINANS && Mode!=MODE_ENDQDATA)                //~0206R~
    	return FALSE;                                              //~0205I~
    if (pHole.GetNum()!=0)                                         //~vj01R~
    	return FALSE;                                              //~0212I~
                                                                   //~0212I~
    return TRUE;                                                   //~0205I~
}                                                                  //~0205I~
//===============================================================================//~0205I~
void	SetNewNum(int by,int bx,Hole phole,int Psortsw,int Psetanssw)//~vj01R~
{                                                                  //~0130I~
	if (phole.GetState()<=MODE_ENDQDATA)                               //~0213I~
		pPat.SetNewData(by,bx,phole.GetNum(),Psortsw);           //~0213R~
    else                                                           //~0213I~
    	if (Psetanssw!=0)                                          //~vj01R~
		    pPat.SetAnsData(by,bx,phole.GetNum());               //~0312R~
    Flags&=~F_ERROR;                                               //~0130I~
}                                                                  //~0130I~
//===============================================================================//~0205I~
//rc=0:key ignored,1:key processed,-1:key processed but no need to redraw//~0206I~
//===============================================================================//~0206I~
int	KeyProc(int nChar)                                             //~vj01R~
{                                                                  //~0102I~
	                                                     //~0102I~
	Hole phole;                                                    //~vj01R~
    boolean rc;                                                        //~vj01R~
    int num;                                                       //~va20I~
//*************************************                            //~va20R~
    if (KbFocus<0 || KbFocus>=wnp.PEG_MAX)                         //~va01R~
        return -1;                                                 //~0206R~
                                                                   //~0206I~
//    if (nChar>=KeyEvent.VK_F1 && nChar<=KeyEvent.VK_F10)         //~va20R~
//    {                                                            //~va20R~
//        if (Shiftkey!=0)                                         //~va20R~
//            return -1;                                           //~va20R~
//        if (nChar==KeyEvent.VK_F10)                              //~va20R~
//            rc=SetMemo(null,0);                                  //~va20R~
//        else                                                     //~va20R~
//            rc=SetMemo(null,nChar-KeyEvent.VK_F1+1);             //~va20R~
//        if (!rc)                                                 //~va20R~
//            return -1;                                           //~va20R~
//        return 1;                                                //~va20R~
//    }                                                            //~va20R~
	if (nChar>='0' && nChar<='9')                                //~0102I~
    {                                                              //~0102I~
    	num=nChar-'0';                                             //~va20I~
//System.out.println("numkey"+num);                                //~va20R~
//        if (Shiftkey!=0)                                         //~va20R~
//            if (nChar=='0')                                      //~va20R~
//                return SetSameNum(0)-1;                          //~va20R~
//            else                                                 //~va20R~
//                return SetSameNum('0'-nChar)-1;                  //~va20R~
//                    //no chng=-1:no redraw,chng=0:no button but redraw//~va20R~
//                                                                 //~va20R~
		if (Shiftkey!=0)                                           //~va20I~
			if (Controlkey!=0)                                     //~va20I~
        	{                                                      //~va20I~
            	if (Ssamenumstr==null)                             //~va20I~
	        		Ssamenumstr=Integer.toString(num);		//S+C+num (samenum)//~va20I~
                else                                               //~va20I~
	        		Ssamenumstr+=Integer.toString(num);		//S+C+num (samenum)//~va20R~
//System.out.println("S+C="+Ssamenumstr);                          //~va20R~
                return 1;                                          //~va20I~
            }                                                      //~va20I~
            else                                                   //~va20I~
        	{                                                      //~va20I~
        		if (Sover10numstr==null)                           //~va20R~
	        		Sover10numstr=Integer.toString(num);   //S+num(num 1x,2x)//~va20I~
                else                                               //~va20I~
	        		Sover10numstr+=Integer.toString(num);   //S+num(num 1x,2x)//~va20I~
//System.out.println("S="+Sover10numstr);                          //~va20R~
                return 1;                                          //~va20I~
            }                                                      //~va20I~
        else                                                       //~va20I~
			if (Controlkey!=0)			//C+num                    //~va20I~
        	{                                                      //~va20I~
        		if (Smemonumstr==null)                             //~va20R~
	        		Smemonumstr=Integer.toString(num);             //~va20I~
                else                                               //~va20I~
	        		Smemonumstr+=Integer.toString(num);            //~va20I~
//System.out.println("C="+Smemonumstr);                            //~va20R~
                return 1;                                          //~va20I~
            }                                                      //~va20I~
    	rc=DropDown(null,nChar-'0');                               //~vj01R~
        if (rc)                                                    //~vj01R~
        	NextFocus();                                           //~0211R~
		return (rc?1:0);                                            //~vj01R~
	}                                                              //~0102I~
    if (nChar==KeyEvent.VK_SPACE)                                  //~vj01R~
    {                                                              //~0102I~
    	rc=DropDown(null,0);                                       //~vj01R~
        if (rc)                                                    //~vj01R~
        	NextFocus();                                           //~0211R~
		return (rc?1:0);                                            //~vj01R~
	}                                                              //~0102I~
//    int from=KbFocus;                                              //~0211R~
	switch(nChar)                                                  //~0102I~
    {                                                              //~0102I~
    case KeyEvent.VK_SHIFT:                                        //~vj01R~
    	Shiftkey=1;                                                //~0206I~
        return -1;      //no need redraw                           //~0206I~
    case KeyEvent.VK_CONTROL:                                      //~va20I~
    	Controlkey=1;                                              //~va20I~
        return -1;      //no need redraw                           //~va20I~
    case KeyEvent.VK_HOME:                                         //~vj01R~
    	KbFocus=0;                                                 //~0211R~
        break;                                                     //~0102I~
    case KeyEvent.VK_END:                                          //~vj01R~
    	KbFocus=wnp.PEG_MAX-1;                                     //~va01R~
        break;                                                     //~0102I~
    case KeyEvent.VK_UP:                                           //~vj01R~
        KbFocus-=wnp.MAP_SIZE;                                     //~va01R~
        if (KbFocus<0)                                             //~0211R~
        {                                                          //~0102I~
        	KbFocus+=wnp.PEG_MAX;                                  //~va01R~
            PrevFocus();                                           //~0211R~
        }                                                          //~0102I~
        break;                                                     //~0102I~
    case KeyEvent.VK_DOWN:                                         //~vj01R~
        KbFocus+=wnp.MAP_SIZE;                                     //~va01R~
        if (KbFocus>=wnp.PEG_MAX)                                  //~va01R~
        {                                                          //~0102I~
        	KbFocus-=wnp.PEG_MAX;                                  //~va01R~
            NextFocus();                                           //~0211R~
        }                                                          //~0102I~
        break;                                                     //~0102I~
    case KeyEvent.VK_LEFT:                                         //~vj01R~
        PrevFocus();                                               //~0211R~
        break;                                                     //~0102I~
    case KeyEvent.VK_RIGHT:                                        //~vj01R~
        NextFocus();                                               //~0211R~
        break;                                                     //~0102I~
    case KeyEvent.VK_DELETE:                                       //~vj01R~
	    if ((Flags&F_MODEMAKE)!=0)    //pattern setting            //~v004R~
    		DropDown(null,-PATTERN_ID);                            //~vj01R~
        else                                                       //~0129I~
        {                                                          //~0206I~
        	phole=BoardMap[KbFocus/wnp.MAP_SIZE][KbFocus%wnp.MAP_SIZE];//~va01R~
        	if (phole.GetNum()!=0)                                 //~vj01R~
    			DropDown(null,0);                                  //~vj01R~
            else                                                   //~0206I~
    			SetMemo(null,PATTERN_ID);	//map_size:clear id    //~vj01R~
        }                                                          //~0206I~
        break;                                                     //~0129I~
    case KeyEvent.VK_INSERT:                                       //~vj01R~
		return SetSameNum(1)-1;                                    //~0206R~
				//no chng=-1:no redraw,chng=0:no button but redraw //~0206I~
    case KeyEvent.VK_BACK_SPACE:       //back space                //~vj01R~
        PrevFocus();                                               //~0211R~
	    if ((Flags&F_MODEMAKE)!=0)    //pattern setting            //~v004R~
    		DropDown(null,-PATTERN_ID);                            //~vj01R~
        else                                                       //~0129I~
    		DropDown(null,0);                                      //~vj01R~
        break;                                                     //~0129I~
    default:                                                       //~0102I~
    	return -1;                                                 //~0206R~
	}                                                              //~0102I~
    return 1;                                                      //~0206R~
}//keyProc                                                         //~vj01R~
//===============================================================================//~0206M~
//rc  :TRUE:need to invalidate                                     //~0212R~
//===============================================================================//~0212I~
boolean    KeyUpProc(int nChar)                                    //~vj01R~
{                                                                  //~0211R~
	int num,shiftctl;                                              //~va20R~
//*****************                                                //~va20I~
//    if (Shiftkey)                                                //~0211R~
//        if (nChar>='1' && nChar<='9')                            //~0211R~
//        {                                                        //~0211R~
//            SetSameNum(0);                                       //~0211R~
//            return TRUE;                                         //~0211R~
//        }                                                        //~0211R~
//                                                                 //~0211R~
    switch(nChar)                                                  //~0211R~
    {                                                              //~0211R~
//    case VK_INSERT:                                              //~0211R~
//        SetSameNum(0);                                           //~0211R~
//        break;                                                   //~0211R~
    case KeyEvent.VK_SHIFT:                                        //~vj01R~
//System.out.println("keyup shift shift="+Shiftkey+",Ctl="+Controlkey);//~va20R~
		shiftctl=Shiftkey;                                         //~va20I~
        Shiftkey=0;                                                //~va20I~
        if (Controlkey!=0)                                         //~va20I~
        {                                                          //~va20I~
        	Controlkey=2;	//do when ctrl up                      //~va20I~
        	return FALSE;                                          //~va20R~
        }                                                          //~va20I~
        if (shiftctl==2)	//S+C                                  //~va20R~
        {                                                          //~va20I~
        	num=getkbdnum(Ssamenumstr);                             //~va20I~
        	Ssamenumstr=null;                                      //~va20I~
        }                                                          //~va20I~
        else               //S+                                    //~va20I~
        {                                                          //~va20I~
        	num=getkbdnum(Sover10numstr);                           //~va20I~
        	Sover10numstr=null;                                    //~va20I~
        }                                                          //~va20I~
        if (num<0)		                                           //~va20I~
        	return FALSE;                                          //~va20I~
//        if (SameNum)                                             //~0211R~
//            SetSameNum(0);                                       //~0211R~
        if (shiftctl==2)	//S+C                                  //~va20R~
        {                                                          //~va20I~
//System.out.println("keyup shift samenum="+num);                  //~va20R~
			SetSameNum(-num);                                      //~va20R~
        }                                                          //~va20I~
        else                                                       //~va20I~
        {                                                          //~va20I~
//System.out.println("keyup shift dropdown="+num);                 //~va20R~
	    	if (DropDown(null,num))                                 //~va20R~
        		NextFocus();                                       //~va20I~
        }                                                          //~va20I~
        break;                                                     //~va20R~
    case KeyEvent.VK_CONTROL:                                      //~va20I~
//System.out.println("keyup ctl shift="+Shiftkey+",Ctl="+Controlkey);//~va20R~
		shiftctl=Controlkey;                                       //~va20I~
        Controlkey=0;                                              //~va20I~
        if (Shiftkey!=0)                                        //~va20I~
        {                                                          //~va20I~
        	Shiftkey=2;		//do when shift up                     //~va20I~
        	return FALSE;                                          //~va20I~
        }                                                          //~va20I~
        if (shiftctl==2)	//S+C                                  //~va20R~
        {                                                          //~va20I~
        	num=getkbdnum(Ssamenumstr);                             //~va20I~
        	Ssamenumstr=null;                                      //~va20I~
    	}                                                          //~va20I~
        else               //S+                                    //~va20I~
        {                                                          //~va20I~
        	num=getkbdnum(Smemonumstr);                             //~va20I~
        	Smemonumstr=null;                                      //~va20I~
        }                                                          //~va20I~
        if (num<0)                                                 //~va20I~
        	return FALSE;                                          //~va20I~
        if (shiftctl==2)	//S+C                                  //~va20R~
        {                                                          //~va20I~
//System.out.println("keyup ctl samenum="+num);                    //~va20R~
			SetSameNum(-num);                                      //~va20R~
        }                                                          //~va20I~
        else				//C+                                   //~va20I~
        {                                                          //~va20I~
//System.out.println("keyup ctl memo="+num);                       //~va20R~
            SetMemo(null,num);                                     //~va20I~
        }                                                          //~va20I~
        break;                                                     //~va20I~
    default:                                                       //~0211R~
        return FALSE;                                              //~0211R~
    }                                                              //~0211R~
    return TRUE;                                                   //~va20R~
}                                                                  //~va20I~
//===============================================================================//~va20I~
private int getkbdnum(String Pnumstr)                              //~va20I~
{                                                                  //~va20I~
	int num=0,ii,len;                                              //~va20R~
//*********************                                            //~va20I~
	if (Pnumstr==null)                                             //~va20I~
    	return -1;                                                 //~va20I~
	len=Pnumstr.length();                                          //~va20I~
    if (len==0)                                                    //~va20I~
    	return -1;                                                 //~va20I~
	for (ii=0;ii<len;ii++)                                         //~va20R~
    {                                                              //~va20I~
    	num*=10;                                                   //~va20I~
    	num+=Pnumstr.charAt(ii)-'0';                               //~va20I~
    }                                                              //~va20I~
    if (num<0||num>wnp.MAP_SIZE)                                       //~va20I~
    	return -1;                                                 //~va20I~
//System.out.println("getkbdnum "+Pnumstr+"-->"+num);              //~va20R~
    return num;                                                    //~va20I~
}//int getkbdnum                                                   //~va20R~
//===============================================================================//~0205I~
void	NextFocus()                                                //~vj01R~
{                                                                  //~0102I~
	if (++KbFocus>=wnp.PEG_MAX)                                    //~va01R~
    	KbFocus=0;                                                 //~0211R~
}                                                                  //~0102I~
//===============================================================================//~0205I~
void	PrevFocus()                                                //~vj01R~
{                                                                  //~0102I~
	if (--KbFocus<0)                                               //~0211R~
    	KbFocus=wnp.PEG_MAX-1;                                     //~va01R~
}                                                                  //~0102I~
//===============================================================================//~0205I~
void SetNum(int Pnum,View Pview)                                   //~vj01R~
{                                                                  //~9C28I~
    CurNum=Pnum;                                                   //~9C28I~
    if (Pview!=null)                                               //~vj01R~
    	pView=Pview;                                               //~0109I~
}                                                                  //~9C28I~
//===============================================================================//~0205I~
int GetNum()                                                       //~vj01R~
{                                                                  //~9C30I~
    return CurNum;                                                 //~9C30I~
}                                                                  //~9C30I~
//===============================================================================//~0205I~
int GetKbFocus()                                                   //~v004R~
{                                                                  //~0102M~
	if (KbFocus>=wnp.PEG_MAX||KbFocus<0)                           //~va01R~
    	return -1;                                                  //~0102M~
	return KbFocus;                                                //~0211R~
}                                                                  //~0102M~
//===============================================================================//~0206I~
//parm:0:up,1:down,0>:Shift+PFK num down                           //~0211R~
//rc=0:no change,1:status change                                   //~0206I~
//===============================================================================//~0206I~
int SetSameNum(int Pdownsw)                                        //~v004R~
{                                                                  //~0206I~
    int oldnum;                                                    //~0206R~
	oldnum=SameNum;                                                //~0206I~
    if (Pdownsw==0)		//clear req                                //~vj01R~
    	SameNum=0;                                                 //~0206I~
    else                                                           //~0206I~
    {                                                              //~0206I~
        if (Pdownsw<0)                                             //~0213R~
            SameNum=-Pdownsw;                                      //~0206R~
        else                                                       //~0206R~
            SameNum=CurNum;                                        //~0206R~
    	if (oldnum==SameNum)	//same key pushed                  //~0211I~
        	SameNum=0;                                             //~0211I~
        else                                                       //~0213I~
    	    CountPenalty(PENALTY_SAMENUM);                         //~0213I~
	}                                                              //~0206I~
    return (oldnum!=SameNum)?1:0;                                 //~vj01R~
}//setsamenum                                                      //~0213R~
//===============================================================================//~0123R~
void    BoardToScreen( int bx, int by,Point Ppoint)                //~vj01R~
{
    Ppoint.x = wnp.BOARD_LEFT + bx * ( wnp.OBJECT_SIZE + wnp.GAP );//~vj01R~
    Ppoint.y = wnp.BOARD_TOP  + by * ( wnp.OBJECT_SIZE + wnp.GAP );//~vj01R~
}
//===============================================================================//~0123R~
void    ShowObject( Graphics pDC, int bx, int by, int sts,int PFocus)//~vj01R~
{
    int x, y;                                                      //~va23R~
    BoardToScreen( bx, by, wkpoint);                               //~va23R~
    x=wkpoint.x; y=wkpoint.y;                                      //~v004I~
	Color old_br=pDC.getColor();                                   //~vj01R~
    Color  br=OBJ_COLOR[sts];                                      //~va23R~
    
//System.out.println("ShowObject:Pfocus="+PFocus+",sts="+sts+",r="+br.getRed()+",g="+br.getGreen()+",b="+br.getBlue());//~va03R~
    if (PFocus!=0)                                                 //~vj01R~
    {                                                              //~0102I~
	    Color brFocus=COL_BG_FORCUS;                               //~va23R~
	    Color snFocus=COL_BG_SAMENUM;                              //~va23R~
//System.out.println("ShowObject:forcus="+PFocus+",r="+brFocus.getRed()+",g="+brFocus.getGreen()+",b="+brFocus.getBlue());//~vj01R~
//System.out.println("ShowObject:snforcus="+PFocus+",r="+snFocus.getRed()+",g="+snFocus.getGreen()+",b="+snFocus.getBlue());//~vj01R~
        switch(PFocus)                                             //~0211I~
        {                                                          //~0211I~
        case 3:		//forcus and samenum                           //~0211I~
        	pDC.setColor( snFocus); 
        	pDC.fillRect( x, y,wnp.OBJECT_SIZE,wnp.OBJECT_SIZE );  //~vj01R~
	    	pDC.setColor( brFocus);                                //~vj01R~
    		pDC.fillRect( x+2,y+2,wnp.OBJECT_SIZE-4,wnp.OBJECT_SIZE-4);//~vj01R~
	    	pDC.setColor( br);                                     //~vj01R~
    		pDC.fillRect( x+4,y+4,wnp.OBJECT_SIZE-8,wnp.OBJECT_SIZE-8);//~vj01R~
        	break;                                                 //~0211I~
        case 2:		//samenum                                      //~0211I~
        	pDC.setColor( snFocus); 
        	pDC.fillRect( x, y,wnp.OBJECT_SIZE,wnp.OBJECT_SIZE );  //~vj01R~
	    	pDC.setColor( br);                                     //~vj01R~
    		pDC.fillRect( x+3,y+3,wnp.OBJECT_SIZE-6,wnp.OBJECT_SIZE-6);//~vj01R~
        	break;                                                 //~0211I~
        default:    //focus                                        //~0211I~
        	pDC.setColor( brFocus); 
        	pDC.fillRect( x, y,wnp.OBJECT_SIZE,wnp.OBJECT_SIZE );  //~vj01R~
	    	pDC.setColor( br);                                     //~vj01R~
    		pDC.fillRect( x+2,y+2,wnp.OBJECT_SIZE-4,wnp.OBJECT_SIZE-4);//~vj01R~
        }                                                          //~0211I~
    }                                                              //~0102I~
    else                                                           //~0102I~
    {                                                              //~0102I~
	    pDC.setColor(br);                                          //~va03I~
    	pDC.fillRect( x, y,wnp.OBJECT_SIZE,wnp.OBJECT_SIZE );      //~vj01R~
	}                                                              //~0102I~
    pDC.setColor( old_br );                                        //~vj01R~
//System.out.println("ShowObject:old,r="+old_br.getRed()+",g="+old_br.getGreen()+",b="+old_br.getBlue());//~va03R~
}
//===============================================================================*///~0123R~
boolean    ScreenToBoard( int wx, int wy, Point Ppoint)            //~vj01R~
{                                                                  //~9C09I~
    int x = wx - wnp.BOARD_LEFT;                                   //~vj01R~
    int y = wy - wnp.BOARD_TOP;                                    //~vj01R~
    if ( x < 0 || wnp.BOARD_WIDTH <= x || y < 0 || wnp.BOARD_WIDTH <= y )//~vj01R~
        return FALSE;                                              //~9C09I~
    int bx = x / ( wnp.OBJECT_SIZE + wnp.GAP );                    //~va23R~
    int by = y / ( wnp.OBJECT_SIZE + wnp.GAP );                    //~vj01R~
    int obj_x = bx * ( wnp.OBJECT_SIZE + wnp.GAP );                //~va23R~
    int obj_y = by * ( wnp.OBJECT_SIZE + wnp.GAP );                //~vj01R~
    if ( obj_x + wnp.OBJECT_SIZE - 1 < x || obj_y + wnp.OBJECT_SIZE - 1 < y )//~vj01R~
        return FALSE;                                              //~9C09I~
    Ppoint.x= bx;                                                  //~vj01R~
    Ppoint.y= by;                                                  //~vj01R~
    return TRUE;                                                   //~9C09I~
}                                                                  //~9C09I~
//=============================================================================//~0123R~
int	GetPath()                                                      //~v004R~
{                                                                  //~9C12I~
    int cnt=0;                                                     //~0129I~
    for ( int bx = 0; bx < wnp.MAP_SIZE; bx ++ )                   //~va01R~
        for ( int by = 0; by < wnp.MAP_SIZE; by ++ )               //~va01R~
        {                                                          //~0129I~
            Hole phole=BoardMap[ bx ][ by ];                       //~vj01R~
            if (phole.GetNum()!=0)                                 //~vj01R~
                cnt++;                                             //~0129I~
        }                                                          //~0129I~
    return cnt;                                                    //~0129R~
}                                                                  //~9C12I~
//=============================================================================*///~9C12I~
int	GetMode()                                                      //~v004R~
{                                                                  //~9C12I~
	return Mode;                                                   //~9C12I~
}                                                                  //~9C12I~
//=============================================================================*///~9C31M~
void  OnClear()                                                    //~v004R~
{                                                                  //~9C31M~
    Score=ScoreMax=0;                                              //~0226I~
	if (ErrClear()!=0)                                             //~vj01R~
    {                                                              //~v003I~
	  if (wnp.Sjlang)                                              //~va23I~
    	SetTempMsg("G[NA[܂");                    //~v003R~
      else                                                         //~va23I~
    	SetTempMsg("Errors are cleared");                          //~va23I~
    	return;                                                    //~v003I~
    }                                                              //~v003I~
	if (MemoClear()!=0)                                            //~vj01R~
    {                                                              //~0213I~
	  if (wnp.Sjlang)                                              //~va23I~
    	SetTempMsg("NA[܂");                      //~0213I~
      else                                                         //~va23I~
    	SetTempMsg("Memos area cleared");                          //~va23I~
    	return;                                                    //~0213I~
    }                                                              //~0213I~
    while(TRUE)                                                    //~0103I~
	{                                                              //~0103I~
//System.out.println("onclear before clearsub mode="+Mode+",Flags="+Flags);//~v030R~
		if (OnClearSub(1)!=0)		//clear current level          //~vj01R~
            break;                                                 //~0205R~
//System.out.println("onclear after clearsub mode="+Mode);         //~v030R~
        if ((Flags & F_ONTRY)!=0)  //I'll try but no input         //~v004R~
        {                                                          //~0205M~
        	Flags&=~F_ONTRY;                                       //~0205M~
            break;                                                 //~0213R~
        }                                                          //~0205M~
//System.out.println("onclear before clearback mode="+Mode);       //~v030R~
        if (OnClearBack()!=0)      //reached to first              //~vj01R~
        {                                                          //~v030I~
        	if ((Flags & F_MODEMAKE)!=0)                           //~v030I~
            {                                                      //~v030I~
        		Flags &=~F_MODEMAKE;                               //~v030I~
        		Flags |=F_MODEANS;                                 //~v030I~
            }                                                      //~v030I~
            return;                                                //~0205I~
        }                                                          //~v030I~
//System.out.println("onclear after clearback mode="+Mode);        //~v030R~
	}                                                              //~0103I~
//System.out.println("onclear defore clearback2 mode="+Mode);      //~v030R~
    OnClearBack();                                                 //~0211R~
//System.out.println("onclear after clearback2 mode="+Mode);       //~v030R~
    while(TRUE)                                                    //~0205I~
	{                                                              //~0205I~
//System.out.println("onclear before clearsub2 mode="+Mode);       //~v030R~
		if (OnClearSub(0)!=0)		//chk curr level data exist    //~vj01R~
            break;                                                 //~0205I~
//System.out.println("onclear after clearsub2 mode="+Mode);        //~v030R~
        if ((Flags & F_ONTRY)!=0)  //I'll try but no input         //~v004R~
        	return;             //step back by next clear          //~0212I~
//System.out.println("onclear before clearsub3 mode="+Mode+",flags="+Flags);//~v030R~
        if (OnClearBack()!=0)      //reached to first              //~vj01R~
            return;                                                //~0205I~
//System.out.println("onclear after clearsub3 mode="+Mode);        //~v030R~
	}                                                              //~0205I~
}                                                                  //~9C31M~
//=============================================================================*///~0103I~
//clear data of a step                                             //~0103I~
//  parm:clear option,0 if chk count                               //~0123R~
//  return count                                                   //~0123R~
//=============================================================================*///~0103I~
int OnClearSub(int Popt)                                           //~v004R~
{                                                                  //~0103I~
    Hole    p_hole;                                                //~vj01R~
    int      cnt=0,state;                                          //~0108R~
    for ( int bx = 0; bx < wnp.MAP_SIZE; bx ++ )                   //~va01R~
        for ( int by = 0; by < wnp.MAP_SIZE; by ++ )               //~va01R~
        {                                                          //~0103I~
            p_hole = BoardMap[ by ][ bx ];                         //~0103I~
            p_hole.SetMemo(PATTERN_ID);    //clear all memo       //~0211I~
            if (p_hole.GetNum()!=0)                                //~vj01R~
            {                                                      //~0108I~
                state=p_hole.GetState();                          //~0108R~
                if (state==Mode)                                   //~0116R~
                {                                                  //~0103I~
                	cnt++;                                         //~0103I~
                    if (Popt!=0)                                   //~vj01R~
                    {                                              //~0103I~
                    	NumCount--;                                //~0103I~
                    	p_hole.SetNum(0,0,0);                     //~0103I~
						SetNewNum(by,bx,p_hole,0,1);               //~0312R~
                    }                                              //~0103I~
                }                                                  //~0103I~
			}                                                      //~0108I~
        }                                                          //~0103I~
	return cnt;
}                                                                  //~0103I~
//=============================================================================*///~v003I~
//clear err only                                                   //~v003I~
//  return cleared err count                                       //~v003I~
//=============================================================================*///~v003I~
int ErrClear()                                                     //~v004R~
{                                                                  //~v003I~
    Hole    p_hole;                                                //~vj01R~
    int      cnt=0;                                                //~v003I~
    for ( int bx = 0; bx < wnp.MAP_SIZE; bx ++ )                   //~va01R~
        for ( int by = 0; by < wnp.MAP_SIZE; by ++ )               //~va01R~
        {                                                          //~v003I~
            p_hole = BoardMap[ by ][ bx ];                         //~v003I~
            if (p_hole.GetErr()==Hole.HOLE_ERR)                    //~vj01R~
            {                                                      //~v003I~
            	cnt++;                                             //~v003I~
                NumCount--;                                        //~v003I~
	            p_hole.SetNum(0,0,0);                             //~v003I~
            }                                                      //~v003I~
        }                                                          //~v003I~
    Flags&=~F_ERROR;                                               //~v003R~
	return cnt;                                                    //~v003I~
}                                                                  //~v003I~
//=============================================================================*///~0213I~
//clear all memo data                                              //~0213I~
//  return cleared memo count                                      //~0213I~
//=============================================================================*///~0213I~
int MemoClear()                                                    //~v004R~
{                                                                  //~0213I~
    Hole    p_hole;                                                //~vj01R~
    int      cnt=0;                                                //~0213I~
    for ( int bx = 0; bx < wnp.MAP_SIZE; bx ++ )                   //~va01R~
        for ( int by = 0; by < wnp.MAP_SIZE; by ++ )               //~va01R~
        {                                                          //~0213I~
            p_hole = BoardMap[ by ][ bx ];                         //~0213I~
            cnt+=p_hole.SetMemo(PATTERN_ID);    //clear all memo  //~0213I~
        }                                                          //~0213I~
	return cnt;                                                    //~0213I~
}                                                                  //~0213I~
//=============================================================================*///~0103I~
//mode back; return 1 when reached to first step                   //~0103I~
//=============================================================================*///~0103I~
int OnClearBack()                                                  //~v004R~
{                                                                  //~0103I~
    switch(Mode)                                                   //~0103I~
    {
	case MODE_INIT:                                                //~0116R~
	case MODE_NOINPUT:                                             //~0205I~
    case MODE_FILEDATA:                                            //~0116R~
        sProbLevel="";                                             //~0213I~
        return 1;                                                  //~0103R~
    case MODE_KEYINDATA:                                           //~0116R~
        if (NumCount!=0)                                           //~vj01R~
	        Mode=MODE_FILEDATA;                                    //~0205R~
        else                                                       //~0205I~
	        Mode=MODE_NOINPUT;                                     //~0205I~
        Score=0;                                                   //~0213I~
        TryTimeSpan=0;                                             //~0213I~
        break;                                                     //~0103I~
    case MODE_ENDQDATA:                                            //~0116R~
        Mode=MODE_KEYINDATA;                                       //~0116I~
        break;                                                     //~0116I~
    case MODE_KEYINANS:                                            //~0116I~
        Mode=MODE_ENDQDATA;                                        //~0123R~
        break;                                                     //~0103I~
    case MODE_OUTANS:                                              //~0116R~
        Mode=MODE_KEYINANS;                                        //~0116I~
        FixedSeq=MaxFixed=0;   //strat solution                    //~0116I~
        break;                                                     //~0116I~
    }                                                              //~0103I~
    return 0;                                                      //~0103I~
}                                                                  //~0103I~
//**************************************************************** //~0116I~
void OnAnswer()                                                    //~v004R~
{                                                                  //~9C31M~
    Score=ScoreMax=0;                                              //~0226I~
	while(Mode>MODE_KEYINDATA)                                     //~0123R~
    {                                                              //~0123I~
    	OnClearSub(1);		//clear the level                      //~0123R~
        OnClearBack();      //level back                           //~0123I~
    }                                                              //~0123I~
    if (Mode==MODE_INIT)                                           //~0116I~
    	Mode=MODE_NOINPUT;                                        //~0116I~
    Flags|=F_MODEANS;                                              //~0116I~
    Flags&=~F_MODEMAKE;                                            //~0116I~
}                                                                  //~9C31M~
//**************************************************************** //~0116I~
void OnMake()                                                      //~v004R~
{                                                                  //~9C31M~
    Score=ScoreMax=0;                                              //~0226I~
	while(Mode>MODE_KEYINDATA)                                     //~0123R~
    {                                                              //~0123I~
    	OnClearSub(1);		//clear the level                      //~0123I~
        OnClearBack();      //level back                           //~0123I~
    }                                                              //~0123I~
    if (Mode==MODE_INIT)                                           //~0116I~
//  	Mode==MODE_NOINPUT;                                        //~v004R~
    	Mode=MODE_NOINPUT;                                         //~v004I~
    Flags&=~F_MODEANS;                                             //~0116I~
    Flags|=F_MODEMAKE;                                             //~0116I~
                                                                   //~0116M~
}                                                                  //~9C31M~
//**************************************************************** //~0116I~
void OnSetend(int Pendthreadsw)                                    //~v004R~
{                                                                  //~0116I~
    if (Pendthreadsw!=0)                                           //~vj01R~
    {                                                              //~0213R~
        if ((Flags & F_ERROR)!=0)    //no solution                 //~v004R~
            return;                                                //~0213R~
        SaveAnswerXnp();                                           //~0312I~
        TryStartTime=System.currentTimeMillis();                   //~vj01I~
        timerid=IDC_SETEND;                                        //~vj01M~
        timer_SETEND=new Timer(60000,pView);                       //~vj01I~
        timer_SETEND.setCoalesce(true);                            //~vj01I~
        timer_SETEND.setRepeats(true);                             //~vj01I~
        timer_SETEND.start();                                      //~vj01I~
        sSuccessMsg="";                                            //~0213R~
        SetTempMsg("");                                            //~0213R~
        Npwtryans.copy(Npworkt);		//save for score           //~v025R~
        CalcScore();        //get max score                        //~0226I~
        Score=0;                                                   //~0226I~
    	if ((Flags&F_READFILE)!=0)                                 //~v012I~
        {                                                          //~v012I~
	    	Flags&=~F_READFILE;                                    //~v012I~
			Restoreprevinput( );                                   //~v012I~
        }                                                          //~v012I~
    }                                                              //~0213R~
    else                                                           //~0213R~
    {                                                              //~0213R~
    	if (timer_SETEND!=null)                                    //~vj01R~
        {                                                          //~vj01I~
	    	timer_SETEND.stop();	//confirmation                 //~vj01I~
	    	timer_SETEND=null;                                     //~vj01I~
        }                                                          //~vj01I~
        if (CurNum==0)                                             //~vj01R~
            CurNum=1;                                              //~0130R~
        Mode=MODE_ENDQDATA;                                        //~0130R~
		pPat.ClearAnsData();                                      //~0213I~
        Penalty=0;			//reset penalty                        //~0213I~
        CallAns(0,null);                                           //~vj01R~
    }                                                              //~0213R~
}                                                                  //~0116I~
//**************************************************************** //~0109I~
//*ret :0:ok(set all):1 ok(more step),-1:err                       //~0116R~
//**************************************************************** //~0109I~
int GetSol(int Pendthreadsw)                                       //~v004R~
{                                                                  //~9C31I~
	int rc=0,opt;                                                //~0129R~
	if (Mode!=MODE_OUTANS)                                         //~0116R~
    {                      
    	if (Pendthreadsw==0)                                       //~vj01R~
        {                                                          //~0122I~
        	if ((Flags & F_ONRCHK)!=0)                             //~v004R~
//      		opt=xnpsub.XNP_REDUNDANTCK;                        //~v022R~
        		opt=xnpsub.XNP_REDUNDANTCK|xnpsub.XNP_RLEVELMASK;  //~v022I~
            else                                                   //~0130I~
            	opt=0;                                             //~0130I~
        	if (CallAns(opt,null)==0)                              //~vj01R~
                return 0;                                          //~0123I~
        	return -1;                                             //~0123I~
        }                                                          //~0122I~
    }                                                              //~0108I~
//mode answer                                                      //~0123I~
    if (MaxFixed==wnp.PEG_MAX)                                     //~va01R~
        if (FixedSeq<MaxFixed)                                     //~0129I~
        {                                                          //~0129R~
            FixedSeq++;                                            //~0129R~
            SetNextAnswer(FixedSeq);                               //~0129R~
            if (FixedSeq<MaxFixed)                                 //~0129R~
                rc=1;                                              //~0129R~
            else                                                   //~0129I~
		        SaveAnswer();                                      //~0129I~
        }                                                          //~0129R~
    return rc;                                                     //~0109R~
}                                                                  //~9C31I~
//**************************************************************** //~0205I~
void OnNext(int Pendthreadsw)                                      //~v004R~
{                                                                  //~0205I~
    NPWORKT pnpwt;                                                 //~vj01R~
	M99 pm99;                                                      //~vj01R~
	int idatano,bx,by=0;                                   //~vj01R~
//mode answer                                                      //~0205I~
    if (Pendthreadsw==0)                                           //~vj01R~
    {                                                              //~0205I~
        if (Mode<MODE_ENDQDATA)                                         //~0205I~
            Mode=MODE_ENDQDATA;                                         //~0205I~
//set curr data as init data                                       //~0205I~
    	for (bx=0; bx < wnp.MAP_SIZE; bx ++ )                      //~va01R~
        	for (by=0; by < wnp.MAP_SIZE; by ++ )                  //~va01R~
            	Stempdata[bx][by]=BoardMap[bx][by].GetNum();         //~0205I~
                                                                   //~0205I~
        CallAns(0,Stempdata);                                       //~0205I~
        return;                                                    //~0205I~
    }                                                              //~0205I~
//*endthread                                                       //~0205I~
    pnpwt=Npworkt;                                                 //~v004R~
    idatano=pnpwt.idatano;                                        //~0205I~
    if (MaxFixed!=wnp.PEG_MAX)	//err                              //~va01R~
    {                                                              //~0205I~
	  if (wnp.Sjlang)                                              //~va23I~
        SetTempMsg("𓚂Ɍ肪L܂");                        //~v003R~
      else                                                         //~va23I~
        SetTempMsg("Incorrect answer.");                           //~va23I~
    	return;                                                    //~0205I~
    }                                                              //~0205I~
    pm99=pnpwt.m99[0][0];     //answer                             //~vj01I~
    for (bx = 0; bx < wnp.MAP_SIZE; bx ++ )                        //~va01R~
    {                                                              //~0205I~
        for (by = 0; by < wnp.MAP_SIZE; by ++ )                    //~va01R~
        {                                                          //~0205I~
            pm99=pnpwt.m99[bx][by];     //answer                   //~v004R~
            if (pm99.fnum!=0)                                      //~vj01R~
                if (pm99.fseq==idatano+1)                         //~0205I~
                    break;                                         //~0205I~
        }                                                          //~0205I~
        if (by<wnp.MAP_SIZE)                                       //~va01R~
            break;                                                 //~0205I~
    }                                                              //~0205I~
    if (bx>=wnp.MAP_SIZE)                                          //~va01R~
    	return;                                                    //~0205I~
    KbFocus=bx*wnp.MAP_SIZE+by;                                    //~va01R~
    FixedSeq=pm99.fseq;                                           //~0205I~
    DropDown(null,pm99.fnum);                                      //~vj01R~
    bx=KbFocus%wnp.MAP_SIZE;                                       //~va01R~
    by=KbFocus/wnp.MAP_SIZE;                                       //~va01R~
    BoardMap[ by ][ bx ].SetNum(-1,-1,Hole.HOLE_NEXT);             //~vj01R~
    SetTempMsg("Ok");                                              //~0205I~
    return;                                                        //~0205I~
}                                                                  //~0205I~
//**************************************************************** //~0122I~
void OnGo(int Pendthreadsw)                                        //~v004R~
{                                                                  //~9C31I~
	if ((Flags&F_MODEANS)!=0)                                      //~v004R~
    {                                                              //~0109I~
    	if (NumCount==wnp.PEG_MAX)                                 //~va01R~
        {                                                          //~0130I~
        	if (CheckAnswer(1)!=0)                                 //~vj01R~
		    	CountPenalty(PENALTY_ERR);                         //~0312I~
            Flags&=~F_ONGO;                                        //~0130I~
		}                                                          //~0130I~
        else                                                       //~0129I~
            if (GetSol(Pendthreadsw)==1)       //more step         //~0205R~
            {                                                      //~vj01I~
                timerid=IDC_GO;                                    //~vj01M~
                timer_GO=new Timer(50,pView);                      //~vj01I~
                timer_GO.setCoalesce(true);                        //~vj01I~
                timer_GO.setRepeats(true);                         //~vj01I~
                timer_GO.start();                                  //~vj01I~
            }                                                      //~vj01I~
            else          //first start thread or err at endthread //~0130R~
            	if ((Flags & F_ERROR)!=0)//from                    //~v004R~
                	Flags&=~F_ONGO;                                //~0130R~
    }                                                              //~0109I~
    else                                                           //~0109I~
	if ((Flags&F_MODEMAKE)!=0)                                     //~v004R~
    {                                                              //~0123I~
        if (CallMake()!=0)                                         //~vj01R~
        	Flags&=~F_ONGO;                                        //~0123I~
	}                                                              //~0123I~
    else                                                           //~0109I~
        SetTempMsg("ݒ肵Ă");                        //~v003R~
    	                                                           //~0109I~
}                                                                  //~9C31I~
//**************************************************************** //~0122I~
void OnStop()                                                      //~v004R~
{                                                                  //~0110I~
	if ((Flags&F_THREAD)==0)                                       //~v004R~
    	return;                                                    //~0110I~
	xnpsub.GblSubthreadStopReq=1;                                  //~vj01R~
}                                                                  //~0110I~
//**************************************************************** //~0122I~
//*ret 1:req sw to ans mode(make normal end)                       //~v002I~
//**************************************************************** //~v002I~
int  OnEndThread()                                                 //~v004R~
{                                                                  //~0109I~
    M99 pm99;                                                      //~vj01R~
    NPWORKT pnpwt=Npworkt;                                         //~vj01R~
//System.out.println("OnEndThraed");                               //~v025R~
	Flags&=~F_THREAD;                                              //~0109I~
    if (NpsubRc!=0 && xnpsub.GblSubthreadStopReq==0)               //~vj01R~
        Flags|=F_ERROR;                                            //~0130I~
	                                                               //~0110I~
	if ((Flags & F_MODEMAKE)!=0)                                   //~v004R~
    {                                                              //~0122R~
    	pPat.Seed=ActSeed;                                        //~0129I~
		Flags&=~F_ONGO;                                            //~0123I~
        if (NpsubRc!=0)                                            //~vj01R~
            return 0;                                              //~v002R~
        NumCount=0;                                                //~0205R~
        for ( int bx = 0; bx < wnp.MAP_SIZE; bx ++ )               //~va01R~
            for ( int by = 0; by < wnp.MAP_SIZE; by ++ )           //~va01R~
            {                                                      //~0122R~
                Hole phole=BoardMap[ bx ][ by ];                   //~vj01R~
                pm99=pnpwt.m99[bx][by];     //answer               //~v004R~
                if (pm99.fnum!=0 && pm99.dlvl==xnpsub.LEVEL_INIT)  //~vj01R~
                {                                                  //~0205I~
                    phole.SetNum(pm99.fnum,MODE_KEYINDATA,0);    //~0129R~
                    NumCount++;                                    //~0205I~
				}                                                  //~0205I~
                else                                               //~0129I~
                    phole.SetNum(0,0,0);                          //~0129I~
				SetNewNum(bx,by,phole,0,1);                        //~0312R~
            }                                                      //~0122R~
        FixedSeq=pnpwt.idatano;                                   //~0122R~
        Mode=MODE_ENDQDATA;                                        //~0122R~
        return 1;                                                  //~v002R~
    }                                                              //~0122I~
//answer end                                                       //~0122I~
    if ((Flags & F_ONNEXT)!=0)                                     //~v004R~
    {                                                              //~0213I~
	    MaxFixed=pnpwt.seqno;                                     //~0213I~
		OnNext(1);				//advance a step                   //~0205M~
    }                                                              //~0213I~
    else                                                           //~0205M~
    if ((Flags & F_ONTRY)!=0)                                      //~v004R~
        OnSetend(1);                                               //~0213I~
    else                                                           //~0213I~
    {                                                              //~0205I~
	    MaxFixed=pnpwt.seqno;                                     //~0213I~
    	SetAllAnswer();                                            //~0205R~
    	if ((Flags & F_ONRCHK)!=0)                                 //~v004R~
			OnRchk(1);		//answer thread end                    //~0205R~
    	else                                                       //~0205R~
            OnGo(1);                //answer thread end,kick timer //~0213R~
	}                                                              //~0205I~
    return 0;                                                      //~v002R~
}//OnEndThread                                                     //~0205R~
//**************************************************************** //~0122I~
//*return elapsed time                                             //~0212I~
//**************************************************************** //~0212I~
int  OnTimer(ActionEvent e)                                      //~vj01R~
{                                                                  //~0109I~
	int Pid=timerid;                                                   //~vj01I~
    long ctime;                                                    //~vj01R~
	long ts;                                                       //~vj01R~
    int   span=0;                                                  //~0212R~
                                                                   //~0212I~
//System.out.println("OnTimer");                                   //~v025R~
	if (Pid==IDC_GO)                                               //~0109I~
    {                                                              //~0109I~
		if ((Flags & F_ONGO)==0)                                   //~v004R~
        	return 0;                                                //~0110I~
		if (GetSol(1)==0)		//reached to last answer           //~vj01R~
        {                                                          //~0109I~
    		if (timer_GO!=null)                                    //~vj01I~
            {                                                      //~vj01I~
    			timer_GO.stop();                                   //~vj01R~
    			timer_GO=null;                                     //~vj01I~
            }                                                      //~vj01I~
        	Flags&=~F_ONGO;                                        //~0109I~
		}                                                          //~0109I~
	}                                                              //~0109I~
    else                                                           //~0109I~
	if (Pid==IDC_MAKE||Pid==IDC_ANSWER)                            //~0122R~
    {                                                              //~0109I~
		if ((Flags & F_THREAD)==0)                                 //~v004R~
        	return 0;                                                //~0110I~
		if (Timeout==0)                                            //~vj01R~
        	return 0;                                                //~0110I~
        ctime=System.currentTimeMillis();                          //~vj01I~
		ts=ctime-StartTime;                                        //~0212I~
        if ((int)(ts/1000)>Timeout)                                //~vj01R~
			xnpsub.GblSubthreadStopReq=2;                          //~vj01R~
	}                                                              //~0109I~
    else                                                           //~0212I~
	if (Pid==IDC_SETEND)                                           //~0212I~
    {                                                              //~0212I~
		if ((Flags & F_ONTRY)!=0)                                  //~v004R~
        {                                                          //~0212I~
	        ctime=System.currentTimeMillis();                      //~vj01I~
			ts=ctime-TryStartTime;                                 //~0212I~
			span=TryTimeSpan=(int)(ts/1000);                       //~vj01R~
        }                                                          //~0212I~
        else                                                       //~0212I~
        {                                                          //~vj01I~
        	if (timer_SETEND!=null)                                //~vj01I~
            {                                                      //~vj01I~
	            timer_SETEND.stop();                               //~vj01I~
	            timer_SETEND=null;                                 //~vj01I~
            }                                                      //~vj01I~
        }                                                          //~vj01I~
	}                                                              //~0212I~
    else                                                           //~0212I~
	if (Pid==IDC_SUCCESS)                                          //~0211I~
    	span=OnSuccess();                                          //~0212R~
	return span;                                                   //~0212I~
}//OnTimer                                                         //~0212R~
//**************************************************************** //~0122I~
void OnRchk(int Pendthreadsw)                                      //~v004R~
{                                                                  //~9C31I~
	int cnt,ii,bx,by;                                              //~vj01R~
	int[]  pi;                                                     //~vj01I~
    if (Pendthreadsw==0)                                           //~vj01R~
    {	                                                           //~0122I~
    	if (GetSol(0)==0)	//submitted                            //~vj01R~
    		return;			//wait thread comp                     //~0122R~
    	Flags&=~F_ONRCHK;                                          //~0122I~
        return;                                                    //~0122I~
    }                                                              //~0122I~
    if (NpsubRc==0)       //no err                                 //~vj01R~
    {                                                              //~0109I~
	    cnt=Npworkt.rclistcnt;                                      //~0109I~
//      s="璷x MaxLevel== "+Npworkt.rclevel+",Level 1  "+cnt+" ӏ";//~v023R~
//      SetTempMsg(s);                                             //~v023R~
        if (cnt!=0)                                                //~vj01R~
        {                                                          //~0109I~
            pi=Npworkt.rclist;                                      //~0109I~
            for (ii=0;ii<cnt;ii++)                                 //~0109I~
            {                                                      //~0109I~
            	bx=pi[ii+ii];                                      //~vj01I~
            	by=pi[ii+ii+1];                                    //~vj01I~
                BoardMap[ bx ][ by ].SetNum(-1,-1,Hole.HOLE_RCHK);	//redundancy err//~vj01R~
            }                                                      //~0109I~
        }                                                          //~0109I~
    }                                                              //~0109I~
    Flags&=~F_ONRCHK;                                               //~0109I~
}                                                                  //~9C31I~
//**************************************************************** //~0130I~
boolean OnSort()                                                   //~vj01R~
{                                                                  //~0130I~
    Hole phole;                                                    //~vj01R~
    int  num,bx,by,rc=0;                                           //~vj01R~
    int[][] pdata=new int[wnp.MAP_SIZE][wnp.MAP_SIZE];             //~va01R~
//*********                                                        //~0130I~
    for (bx = 0; bx < wnp.MAP_SIZE; bx ++ )                        //~va01R~
        for (by = 0; by < wnp.MAP_SIZE; by ++ )                    //~va01R~
        {                                                          //~0130I~
            num=BoardMap[bx][by].GetNum();                        //~0130I~
            if (num<0 || num >wnp.MAP_SIZE)                            //~va19R~
            	rc=4;                                              //~0130I~
            pdata[bx][by]=num;                                     //~0130I~
		}                                                          //~0130I~
    if (rc==0)                                                     //~vj01R~
		rc=sub1.xnpsortdata(pdata,pPat.QuestionData);              //~vj01R~
    if (rc!=0)                                                     //~vj01R~
    {                                                              //~0130I~
	  if (wnp.Sjlang)                                              //~va23I~
    	SetTempMsg("ł܂");                              //~0130R~
      else                                                         //~va23I~
    	SetTempMsg("Sort failed.");                                //~va23I~
        return FALSE;                                              //~0212R~
	}                                                              //~0130I~
//set sorted data                                                  //~0130I~
    for (bx = 0; bx < wnp.MAP_SIZE; bx ++ )                        //~va01R~
        for (by = 0; by < wnp.MAP_SIZE; by ++ )                    //~va01R~
        {                                                          //~0130I~
            phole=BoardMap[bx][by];                                //~0130R~
            phole.SetNum(pdata[bx][by],-1,-1);	//replace number   //~0130I~
            if (pPat.QuestionData[bx][by]!=0)                      //~vj01R~
				SetNewNum(bx,by,phole,1,1);//sort option           //~0312R~
        }                                                          //~0130I~
	if ((pPat.Datasw & CPattern.DATA_ANS)!=0)	//answer avail     //~vj01R~
		SaveAnswer();                                              //~v002I~
	return TRUE;                                                   //~0212I~
}                                                                  //~0130I~
//**************************************************************** //~0213I~
void CountPenalty(int Ppenalty)                                    //~v004R~
{                                                                  //~0213I~
    Penalty+=Ppenalty;                                             //~0213I~
}                                                                  //~0213I~
//**************************************************************** //~0213I~
void CalcScore()                                                   //~vj01R~
{                                                                  //~0213I~
    M99 pm99;                                                      //~vj01R~
    NPWORKT pnpwt=Npwtryans;                                       //~vj01R~
    int level,score;                                               //~0226R~
    int err,errall=0;                                              //~v024I~
//************************************                             //~v024R~
	Score=0;                                                       //~0213I~
	ScoreMax=0;                                                    //~0213I~
	if (pnpwt.seqno==0)	//init data                                //~v025R~
    	return;                                                    //~va03I~
    for (int bx = 0; bx < wnp.MAP_SIZE; bx ++ )                    //~va01R~
        for (int by = 0; by < wnp.MAP_SIZE; by ++ )                //~va01R~
        {                                                          //~0213I~
		    pm99=pnpwt.m99[bx][by];     //answer                   //~v004R~
            if (pm99.dlvl!=xnpsub.LEVEL_INIT)                  //q data//~vj01R~
            {   
				level=pm99.dlvl>>8;//~0213I~
                score=0;                                           //~0226I~
                switch(level)                                      //~0226I~
                {                                                  //~0226I~
                case xnpsub.LEVEL_EASY_F:                          //~vj01R~
                    score=5;                                       //~0226I~
                    break;                                         //~0226I~
                case xnpsub.LEVEL_MEDIUM_F:                        //~vj01R~
                    score=50;                                      //~0226I~
                    break;                                         //~0226I~
                case xnpsub.LEVEL_HARD_F:                          //~vj01R~
                    score=300;                                     //~0226R~
                    break;                                         //~0226I~
                case xnpsub.LEVEL_HARDP1_F:                        //~vj01R~
                    score=400;                                     //~0226R~
                    break;                                         //~0226I~
                case xnpsub.LEVEL_HARDP2_F:                        //~vj01R~
                    score=500;                                     //~0226R~
                    break;                                         //~0226I~
                }                                                  //~0226I~
            	ScoreMax+=score;                                   //~0226R~
		    	err=BoardMap[bx][by].GetErr();                     //~v024R~
		    	if (err==Hole.HOLE_PENDDATA)	//by next key              //~v024I~
                	errall=1;                                      //~v024I~
                else                                               //~v024I~
		    	if (err!=Hole.HOLE_NEXT)	//by next key          //~v024I~
            		Score+=score;                                  //~0226R~
			}                                                      //~0213I~
        }                                                          //~0213I~
    if (errall!=0)                                                    //~v024I~
    	Score+=pPat.Score;	//prev session score                   //~v024I~
	Score-=Penalty;                                                //~0226M~
    int min5=(TryTimeSpan+300)/300;		//by 5 min                 //~0213I~
    if (min5>PENALTY_NOTIME)                                       //~0226I~
        Score-=(min5-PENALTY_NOTIME)*PENALTY_TIME;                 //~0226I~
    if (Score==0)                                                  //~vj01R~
    	Score=1;                                                   //~0213I~
}//CalcScore                                                       //~0213I~
//************************************************************     //~0122I~
int CallAns(int Poption,int[][] Ppdata)                            //~vj01R~
{                                                                  //~0122I~
	int  opt,rc;                                         //~vj01R~
	int  tmsgfreq=1000;		//time msg frequency                   //~vj01R~
	int  repeatmax=xnpsub.ANS_TIMEOUT;  	//loop max             //~vj01R~
    Object[] plist=new Object[8];                                  //~vj01I~
	String rcmsg=new String("");                                   //~vj01R~
                                                                   //~vj01I~
    plistans=plist;                                                //~vj01I~
                                                                   //~0122I~
    if ((pdata=Ppdata)==null)                                      //~vj01R~
    {                                                              //~0205I~
		pdata=pPat.QuestionData;                                   //~vj01R~
		ResetErr(1);	//clear also HOLE_NEXT                     //~0205I~
	}                                                              //~0205I~
    else                                                           //~0205I~
		ResetErr(0);    //leave HOLE_NEXT                          //~0205I~
    Npworkt.clear();                                               //~vj01R~
                                                                   //~0122I~
    opt=(xnpsub.XNP_PILOT|xnpsub.XNP_PILOTNOMSG|xnpsub.XNP_NOPRINTIN|xnpsub.XNP_NOPRINTOUT);//~vj01R~
	opt|=Poption;                                                  //~0130R~
	opt&=xnpsub.XNP_SOLVMASK;                                      //~vj01R~
                                                                   //~0122I~
	plist[0]=this;                                                 //~0122I~
	plist[1]=new Integer(opt);                                     //~v004I~
	plist[2]=pdata;                                                //~0122I~
	plist[3]=Npworkt;                                              //~v004R~
	plist[4]=new Integer(tmsgfreq);                                //~v004I~
	plist[5]=new Integer(repeatmax);                               //~v004I~
	plist[6]=null;                                                 //~vj01R~
	plist[7]=rcmsg;                                                //~v004R~
                                                                   //~0122I~
    NpsubRc=0;                                                     //~0122I~
                                                                   //~0122I~
	Thread 	pThread=new Thread(this,Integer.toString(IDC_ANSWER)); //~vj01I~
	if (pThread!=null)                                             //~vj01R~
    {                                                              //~0122I~
	  if (wnp.Sjlang)                                              //~va23I~
        SetTempMsg("𓚊Jn");                                    //~0122I~
      else                                                         //~va23I~
        SetTempMsg("Started to answer");                           //~va23I~
    	Flags|=F_THREAD;                                           //~0122I~
        StartTime=System.currentTimeMillis();                      //~vj01I~
        timerid=IDC_ANSWER;                                        //~vj01I~
        timer_ANS=new Timer(xnpsub.ANS_MSGFREQ*1000,pView);        //~vj01I~
        timer_ANS.setCoalesce(true);                               //~vj01I~
        timer_ANS.setRepeats(true);                                //~vj01I~
        timer_ANS.start();                                         //~vj01I~
    	//5 sec ms frequency                                       //~vj01I~
        rc=0;                                                      //~0122I~
//        if (Mode==MODE_KEYINANS)                                 //~0205R~
//            Flags|=F_ANSCHK;    //answer chk                     //~0205R~
//        else                                                     //~0205R~
//            Flags&=~F_ANSCHK;                                    //~0205R~
        	                                                       //~0123I~
        pThread.start();                                           //~vj01I~
	}                                                              //~0122I~
	else                                                           //~0122I~
    {                                                              //~0122I~
	  if (wnp.Sjlang)                                              //~va23I~
    	SetTempMsg("Xbh쐬Ɏs܂");                  //~0122I~
      else                                                         //~va23I~
    	SetTempMsg("CreateThread failed.");                        //~va23I~
        rc=4;                                                      //~0122I~
	}                                                              //~0122I~
    return rc;                                                     //~0122I~
}                                                                  //~0122I~
int AnsThread()                                                    //~vj01R~
{                                                                  //~0122I~
	Object[] plist=plistans;                                       //~vj01R~
	Board pBoard=(Board)plist[0];                                  //~vj01R~
	int   opt=((Integer)plist[1]).intValue();                      //~vj01I~
	int[][] pdata=(int[][])plist[2];                                   //~vj01R~
	NPWORKT pnpwt=(NPWORKT)plist[3];                               //~vj01R~
	int tmsgfreq=((Integer)plist[4]).intValue();                   //~vj01I~
	int repeatmax=((Integer)plist[5]).intValue();                  //~vj01I~
	int prc=0;                                                     //~vj01R~
	String rcmsg=(String)plist[7];                                 //~vj01R~
                                                                   //~0122I~
    try                                                            //~0122I~
    {                                                              //~0122I~
    	GblSubthreadsw=1;                                          //~0122I~
		xnpsub.GblSubthreadStopReq=0;                              //~vj01R~
	    GblNpsubMsg=null;                                          //~vj01R~
                                                                   //~0122I~
	    prc=sub1.xnpgetanswer(opt,pdata,pnpwt,tmsgfreq,repeatmax); //~vj01R~
		pBoard.Npsuberr1(prc);                                     //~vj01R~
        NpsubRc=prc;                                               //~v012I~
//System.out.println("anssub rc="+prc);                            //~v012R~
	}                                                              //~0122I~
    catch(uerrexit_excp e){                                        //~vj01I~
        e.printStackTrace();                                       //~va01R~
    	Npsuberr4(e);                                              //~vj01I~
    }                                                              //~vj01I~
    catch(RuntimeException e){                                     //~vj01I~
        e.printStackTrace();                                       //~va01I~
    	Npsuberr2(e);                                              //~vj01I~
    }                                                              //~vj01I~
    if (timer_ANS!=null)                                           //~vj01I~
    {                                                              //~vj01I~
    	timer_ANS.stop();                                          //~vj01I~
    	timer_ANS=null;                                            //~vj01I~
    }                                                              //~vj01I~
	plist[6]=new Integer(prc);                                     //~vj01I~
	notifyfinished();                                              //~vj01I~
    return 0;                                                      //~0122I~
}                                                                  //~0122I~
int CallMake()                                                     //~v004R~
{                                                                  //~0109I~
	int  opt,level,den,rc;                                         //~vj01R~
	int  tmsgfreq=1000;		//time msg frequency                   //~vj01R~
	int  repeatmax=0x0fffffff;  	//loop max                     //~vj01R~
//  int  plan=9;	//search pos from max candidate                //~v041R~
//  int  plan=-9;	//search pos from min candidate                //~v043R~
    int  plan=9;	//search pos from max candidate                //~v043I~
	String rcmsg=new String("");                                   //~vj01R~
                                                                   //~0109I~
    Object[] plist=new Object[13];                                 //~vj01I~
    plistmake=plist;                                               //~vj01I~
                                                                   //~0109I~
    pPat.Seed=ActSeed=0;                                          //~0129I~
	ResetErr(1);                                                   //~0205R~
    if (pPat.ChkData())                                         //~0109I~
	    pdata=pPat.QuestionData;                                   //~vj01R~
	else                                                           //~0109I~
    	pdata=null;			//no pattern data                      //~vj01R~
    Npworkt.clear();                                               //~vj01R~
                                                                   //~0110I~
	opt=0;                                                         //~0110I~
  if (pdata!=null)                                                 //~v025I~
    if ((Flags & F_RIGID)!=0)                                      //~v004R~
	    opt|=xnpsub.XNP_RIGID;                                     //~vj01R~
                                                                   //~va16R~
    if ((Flags & F_NOREDUNDANT)!=0)                                //~va16R~
	    opt|=xnpsub.XNP_DELREDUNDANT;                              //~va16R~
                                                                   //~va16R~
	opt&=xnpsub.XNP_MAKEMASK;                                      //~vj01R~
                                                                   //~0109I~
    if ((Flags & F_LVL1)!=0)                                       //~v004R~
    	level='E';                                                 //~0109I~
    else                                                           //~0109I~
    if ((Flags & F_LVL2)!=0)                                       //~v004R~
    	level='M';                                                 //~0109I~
    else                                                           //~0109I~
    if ((Flags & F_LVL3)!=0)                                       //~v004R~
    	level='H';                                                 //~0109I~
    else                                                           //~0109I~
    	level=0;                                                   //~0109I~
                                                                   //~0109I~
//    if ((Flags & F_DEN3)!=0)                                     //~va03R~
//        den=wnp.BOARDTYPE;                                       //~va03R~
//    else                                                         //~va03R~
//    if ((Flags & F_DEN4)!=0)                                     //~va03R~
//        den=wnp.BOARDTYPE+1;                                     //~va03R~
//    else                                                         //~va03R~
//    if ((Flags & F_DEN5)!=0)                                     //~va03R~
//        den=wnp.BOARDTYPE+2;                                     //~va03R~
//    else                                                         //~va03R~
//        den=xnpsub2.SETMAX;                                      //~va03R~
    den=Dencity;                                                   //~va03I~
                                                                   //~0109I~
	plist[0]=this;                                                 //~0109I~
	plist[1]=new Integer(opt);                                     //~v004I~
	plist[2]=Npworkt;                                              //~v004R~
	plist[3]=pdata;                                                //~0109I~
	plist[4]=new Integer(den);                                     //~v004I~
	plist[5]=new Integer(tmsgfreq);                                //~v004I~
	plist[6]=new Integer(repeatmax);                               //~v004I~
	plist[7]=new Integer(Seed);                                    //~v004I~
	plist[8]=new Integer(plan);                                    //~v004I~
	plist[9]=new Integer(level);                                   //~v004I~
	plist[10]=null;                                                //~vj01R~
	plist[11]=null;                                                //~vj01R~
	plist[12]=rcmsg;                                               //~v004R~

    NpsubRc=0;                                                 //~0110I~

	Thread pThread=new Thread(this,Integer.toString(IDC_MAKE));    //~vj01I~
	if (pThread!=null)                                             //~vj01R~
    {                                                              //~0109I~
        SetTempMsg("쐬Jn");                                    //~0110R~
    	Flags|=F_THREAD;                                           //~0109I~
        StartTime=System.currentTimeMillis();                      //~vj01I~
        timerid=IDC_MAKE;                                          //~vj01I~
        timer_MAKE=new Timer(5000,pView);                          //~vj01I~
        timer_MAKE.setCoalesce(true);                              //~vj01I~
        timer_MAKE.setRepeats(true);                               //~vj01I~
        timer_MAKE.start();                                        //~vj01I~
   //5 sec ms frequency                                            //~vj01I~
        pThread.start();                                           //~vj01I~
        rc=0;                                                      //~0123I~
	}                                                              //~0109I~
	else                                                           //~0109I~
    {                                                              //~0123I~
	  if (wnp.Sjlang)                                              //~va23I~
    	SetTempMsg("Xbh쐬Ɏs܂");                  //~0109I~
      else                                                         //~va23I~
    	SetTempMsg("CreateThread failed.");                        //~va23I~
        rc=4;                                                      //~0123I~
    }                                                              //~0123I~
    return rc;                                                     //~0123I~
}                                                                  //~0109I~
int MakeThread()                                                   //~vj01R~
{
	Object[] plist=plistmake;                                      //~vj01I~
	Board pBoard=(Board)plist[0];                                  //~vj01R~
	int   opt=((Integer)plist[1]).intValue();                      //~vj01I~
	NPWORKT pnpwt=(NPWORKT)plist[2];                               //~vj01R~
	int[][] pdata=(int[][])plist[3];                               //~vj01I~
	int den=((Integer)plist[4]).intValue();                        //~vj01I~
	int tmsgfreq=((Integer)plist[5]).intValue();                   //~vj01I~
	int repeatmax=((Integer)plist[6]).intValue();                  //~vj01I~
	int seed=((Integer)plist[7]).intValue();                       //~vj01I~
	int plan=((Integer)plist[8]).intValue();                       //~vj01I~
	int level=((Integer)plist[9]).intValue();                      //~vj01I~
	int pactseed=0;
	int [] seedout=new int[1];//~vj01R~
	int prc=0;                                                     //~vj01R~
	String rcmsg=(String)plist[12];                                //~vj01I~
    seedout[0]=0;                                                               //~0109I~
    try                                                            //~0109I~
    {                                                              //~0109I~
    	GblSubthreadsw=1;                                          //~0110R~
		xnpsub.GblSubthreadStopReq=0;                              //~vj01R~
	    GblNpsubMsg=null;                                          //~vj01R~
                                                                   //~0110I~
		prc=sub2.xnpmakequestion(opt,pnpwt,                        //~vj01R~
				pdata,den,tmsgfreq,repeatmax,seed,plan,level,seedout);//~0109I~
		pBoard.Npsuberr1(prc);                                     //~vj01R~
		NpsubRc=prc;                                               //~v012I~
		ActSeed=seedout[0];                                        //~v012I~
//System.out.println("makesub rc="+prc+",seed="+ActSeed);          //~v012R~
	}                                                              //~0109I~
    catch(uerrexit_excp e){                                        //~vj01I~
        e.printStackTrace();                                       //~va01I~
    	Npsuberr4(e);                                              //~vj01I~
    }                                                              //~vj01I~
    catch(RuntimeException e){                                     //~vj01I~
        e.printStackTrace();                                       //~va01I~
    	Npsuberr2(e);                                              //~vj01I~
    } 
    pactseed=seedout[0];//~vj01I~
    if (timer_MAKE!=null)                                          //~vj01I~
    {                                                              //~vj01I~
    	timer_MAKE.stop();                                         //~vj01I~
    	timer_MAKE=null;                                           //~vj01I~
    }                                                              //~vj01I~
	notifyfinished();                                              //~vj01I~
    return 0;                                                      //~0109I~
}                                                                  //~0109I~
void Npsuberr1(int rc)                                             //~v004R~
{                                                                  //~0122M~
    String s;                                                      //~vj01R~
	String pc;                                                     //~vj01R~
    if ((pc=GblNpsubMsg)==null)                                    //~vj01R~
    	pc="";                                                     //~0122M~
    if (rc==0)                                                     //~vj01R~
    {                                                              //~0211I~
		Slevelsummary=Npworkt.level;                               //~va21I~
        s=pc;                                                      //~vj01R~
        if ((Npworkt.level & xnpsub.LEVEL_HARDP2_S)!=0)            //~vj01R~
	      if (wnp.Sjlang)                                          //~va23I~
        	sProbLevel="++";                                     //~0211M~
          else                                                     //~va23I~
        	sProbLevel="H++";                                      //~va23R~
        else                                                       //~0211M~
        if ((Npworkt.level & xnpsub.LEVEL_HARDP1_S)!=0)            //~vj01R~
	      if (wnp.Sjlang)                                          //~va23I~
        	sProbLevel="+";                                      //~0211M~
          else                                                     //~va23I~
        	sProbLevel="H+";                                       //~va23R~
        else                                                       //~0211M~
        if ((Npworkt.level & xnpsub.LEVEL_HARD_S)!=0)              //~vj01R~
	      if (wnp.Sjlang)                                          //~va23I~
        	sProbLevel="";                                       //~0211M~
          else                                                     //~va23I~
        	sProbLevel="Hrd";                                      //~va23R~
        else                                                       //~0211M~
        if ((Npworkt.level & xnpsub.LEVEL_MEDIUM_S)!=0)            //~vj01R~
	      if (wnp.Sjlang)                                          //~va23I~
        	sProbLevel="";                                       //~0211M~
          else                                                     //~va23I~
        	sProbLevel="Med";                                      //~va23R~
        else                                                       //~0211M~
        if ((Npworkt.level & xnpsub.LEVEL_EASY_S)!=0)              //~vj01R~
	      if (wnp.Sjlang)                                          //~va23I~
        	sProbLevel="";                                       //~0211R~
          else                                                     //~va23I~
        	sProbLevel="Esy";                                      //~va23R~
        else                                                       //~0211I~
        	sProbLevel="";                                         //~0211I~
	}                                                              //~0211I~
    else                                                           //~0122M~
    {                                                              //~0211I~
	  if (wnp.Sjlang)                                              //~va23I~
        s="s;(rc="+rc+")"+pc;                                   //~vj01R~
      else                                                         //~va23I~
        s="failed;(rc="+rc+")"+pc;                                 //~va23I~
        sProbLevel="";                                             //~0211I~
	}                                                              //~0211I~
    SetTempMsg(s);                                                 //~0122M~
    sSuccessMsg=s;                                                //~0129I~
}                                                                  //~0122M~
private void Npsuberr2(RuntimeException e)                         //~va01R~
{                                                                  //~0122M~
//    if ((msgbuff=e.getLocalizedMessage())!=null)                 //~va01R~
//        SetTempMsg(msgbuff);                                     //~va01R~
//    else                                                         //~va01R~
//        SetTempMsg("CException");                            //~va01R~
    SetTempMsg(e.toString());                                      //~va01I~
    NpsubRc=253;                                                   //~0122M~
}                                                                  //~0122M~
void Npsuberr4(uerrexit_excp e)                                    //~vj01I~
{                                                                  //~vj01I~
	SetTempMsg(GblNpsubMsg);                                       //~vj01I~
    NpsubRc=254;                                                   //~vj01I~
}                                                                  //~vj01I~
private void notifyfinished(){                                     //~vj01I~
//System.out.println("notify thraed");                             //~v025R~
	final Runnable dofinished=new Runnable(){                      //~vj01I~
		public void run(){                                         //~vj01I~
			pView.OnEndThread();                                   //~vj01I~
		}                                                          //~vj01I~
	};                                                             //~vj01I~
		SwingUtilities.invokeLater(dofinished);                    //~vj01I~
                                                                   //~vj01I~
}                                                                  //~vj01I~
//**************************************************************** //~vj01I~
//* class Hole                                                     //~vj01I~
//**************************************************************** //~vj01I~
private class Hole {                                               //~v004I~
    public static final int  HOLE_ERR    = 1;                      //~vj01I~
    public static final int  HOLE_RCHK   = 2;                      //~vj01I~
    public static final int  HOLE_NEXT   =16;    //used Next Button//~vj01I~
    public static final int  HOLE_NEXTERR=17;    //used Next Button//~vj01I~
	public static final int  HOLE_PENDDATA=18;   //read from file  //~v024I~
	private  int    BoardX, BoardY;                                //~vj01I~
    private  int     State;           //mode of board              //~vj01I~
    private  int     Err;           //mode of board                //~vj01I~
    private  int     Num;           //mode of board                //~vj01I~
    private  int[]   Memo=new int[4];                              //~vj01R~
    private  int     MemoCnt;                                      //~vj01I~
                                                                   //~vj01I~
Hole( int board_x, int board_y )                                   //~v004I~
{                                                                  //~v004M~
    BoardX = board_x;                                              //~v004M~
    BoardY = board_y;                                              //~v004M~
    Num=0;                                                         //~v004M~
    State=0;                                                       //~v004M~
    Err=0;                                                         //~v004M~
	MemoCnt=0;                                                     //~v004M~
	Arrays.fill(Memo,0);                                           //~vj01I~
}                                                                  //~v004M~
//===============================================================================*///~v004M~
int GetNum()                                                       //~vj01R~
{                                                                  //~v004M~
    return Num;                                                    //~v004M~
}                                                                  //~v004M~
//===============================================================================//~v004M~
void SetNum(int Pnum,int Pmode,int Perr)                           //~v004I~
{                                                                  //~v004M~
	if (Pmode>=0)                                                  //~v004M~
    	State=Pmode;                                               //~v004M~
	if (Pnum>=0)                                                   //~v004M~
    	Num=Pnum;                                                  //~v004M~
                                                                   //~v004M~
	if (Perr>=0)                                                   //~v004M~
    	if (Err>=HOLE_NEXT && Perr==HOLE_ERR)                      //~v004M~
        	Err=HOLE_NEXTERR;                                      //~v004M~
        else                                                       //~v004M~
	    	Err=Perr;                                              //~v004M~
}                                                                  //~v004M~
//===============================================================================//~v004M~
//num=0:clear first memo,10:clear all memo=====================================//~v004M~
//return:cleared count for all clear;1 if memo changed for other case//~v004M~
//===============================================================================//~v004M~
int  SetMemo(int Pnum)                                             //~v004I~
{                                                                  //~v004M~
//System.out.println("Hole:SetMemo num="+Pnum);                    //~v012R~
	int ii,jj,rc=0;                                                //~v004M~
//  int[] temp=new int[10];                                        //~va19R~
    if (Pnum==PATTERN_ID)		//clear req                        //~v004M~
    {                                                              //~v004M~
		Arrays.fill(Memo,0);                                       //~vj01I~
        ii=MemoCnt;                                                //~v004M~
		MemoCnt=0;                                                 //~v004M~
        return ii;                                                 //~v004M~
    }                                                              //~v004M~
    if (Pnum<0 || Pnum>wnp.MAP_SIZE)                                   //~va19R~
    	return 0;                                                  //~v004M~
    if (Pnum!=0)                                                   //~vj01R~
    {                                                              //~v004M~
    	for (ii=0;ii<4;ii++)                                       //~v004M~
        	if (Memo[ii]==Pnum)                                    //~v004M~
            {                                                      //~v004M~
            	Memo[ii]=0;	//clear if same num                    //~v004M~
                rc=1;                                              //~v004M~
                break;                                             //~v004M~
			}                                                      //~v004M~
		if (ii==4)   			//new num                          //~v004M~
            for (ii=0;ii<4;ii++)                                   //~v004M~
                if (Memo[ii]==0)                                   //~vj01R~
                {                                                  //~v004M~
                    Memo[ii]=Pnum;                                 //~v004M~
	                rc=1;                                          //~v004M~
                    break;                                         //~v004M~
                }                                                  //~v004M~
	}                                                              //~v004M~
    else	//Pnum==0		//clear first                          //~v004M~
    	for (ii=0;ii<4;ii++)                                       //~v004M~
        	if (Memo[ii]!=0)                                       //~vj01R~
            {                                                      //~v004M~
            	Memo[ii]=0;                                        //~v004M~
                rc=1;                                              //~v004M~
                break;                                             //~v004M~
			}                                                      //~v004M~
	Arrays.fill(temp,0);                                           //~vj01R~
    for (ii=0;ii<4;ii++)                                           //~v004M~
    	temp[Memo[ii]]=1;                                          //~v004M~
	Arrays.fill(Memo,0);                                           //~vj01R~
    for (ii=1,jj=0;ii<=wnp.MAP_SIZE;ii++)                              //~va19R~
        if (temp[ii]!=0)                                           //~vj01R~
            Memo[jj++]=ii;                                         //~v004M~
	MemoCnt=jj;                                                    //~v004M~
    return rc;                                                     //~v004M~
}                                                                  //~v004M~
//===============================================================================//~v004M~
int GetState()                                                     //~vj01R~
{                                                                  //~v004M~
    return State;                                                  //~v004M~
}                                                                  //~v004M~
//===============================================================================//~v004M~
int GetErr()                                                       //~v004I~
{                                                                  //~v004M~
    return Err;                                                    //~v004M~
}                                                                  //~v004M~
//===============================================================================//~v004M~
void    Show( Graphics pDC,int PFocus,int Psamenum,boolean Pansmode)//~vj01R~
{                                                                  //~v004M~
	String szNum;                                                  //~vj01R~
    int x, y,ii;                                                   //~v004M~
    Color br=pDC.getColor();                                         //~vj01I~
    int memox,memoy;                                               //~va19I~
//******************************                                   //~va19I~
//System.out.println("Focus="+PFocus+",Psamenum="+Psamenum+",pansmode="+(Pansmode?1:0));//~va03R~
    if (Num!=0)                                                    //~vj01R~
    {                                                              //~v004M~
    	if (Psamenum==Num)                                         //~v004M~
        	PFocus+=2;                                             //~v004M~
        if (Err==HOLE_ERR||Err==HOLE_NEXTERR)                      //~v004M~
        {                                                          //~v004M~
            ShowObject( pDC, BoardX, BoardY, ST_ERR,PFocus);       //~va23R~
            pDC.setColor(COL_NUM_E);                               //~vj01R~
//System.out.println("Show:Num="+Num+",r="+COL_NUM_E.getRed()+",g="+COL_NUM_E.getGreen()+",b="+COL_NUM_E.getBlue());//~vj01R~
		}                                                          //~v004M~
        else                                                       //~v004M~
        if (Err==HOLE_NEXT)                                        //~v004M~
        {                                                          //~vj01R~
            ShowObject( pDC, BoardX, BoardY, ST_NEXT,PFocus);      //~va23R~
            pDC.setColor(COL_NUM_NEXT);                            //~vj01R~
//System.out.println("Show:Num="+Num+",r="+COL_NUM_NEXT.getRed()+",g="+COL_NUM_NEXT.getGreen()+",b="+COL_NUM_NEXT.getBlue());//~va03R~
		}                                                          //~v004M~
        else                                                       //~v004M~
        if (Err==HOLE_RCHK)                                        //~v004M~
        {                                                          //~v004M~
            ShowObject( pDC, BoardX, BoardY, ST_RCHK,PFocus);      //~va23R~
            pDC.setColor(COL_NUM_RCHK);                            //~vj01R~
//System.out.println("Show:Num="+Num+",r="+COL_NUM_RCHK.getRed()+",g="+COL_NUM_RCHK.getGreen()+",b="+COL_NUM_RCHK.getBlue());//~vj01R~
		}                                                          //~v004M~
        else                                                       //~v004M~
        if (State<=MODE_ENDQDATA)                                  //~v004M~
        {                                                          //~v004M~
            if (Pansmode)                                          //~vj01R~
				if (Num==PATTERN_ID)                               //~v004M~
			        ShowObject( pDC, BoardX, BoardY,ST_EMPTY,PFocus);//~va23R~
                else                                               //~v004M~
                {                                                  //~v004M~
                    ShowObject( pDC, BoardX, BoardY, ST_QDATA,PFocus);//~va23R~
                    pDC.setColor(COL_NUM_Q);                       //~vj01R~
//System.out.println("Show:Num="+Num+",r="+COL_NUM_Q.getRed()+",g="+COL_NUM_Q.getGreen()+",b="+COL_NUM_Q.getBlue());//~vj01R~
                }                                                  //~v004M~
            else                                                   //~v004M~
            {                                                      //~v004M~
                ShowObject( pDC, BoardX, BoardY, ST_PAT,PFocus);   //~va23R~
                pDC.setColor(COL_NUM_P);                           //~vj01R~
//System.out.println("Show:Num="+Num+",r="+COL_NUM_P.getRed()+",g="+COL_NUM_P.getGreen()+",b="+COL_NUM_P.getBlue());//~vj01R~
            }                                                      //~v004M~
        }                                                          //~v004M~
        else                                                       //~v004M~
        {                                                          //~v004M~
            ShowObject( pDC, BoardX, BoardY, ST_ANS,PFocus);       //~va23R~
            pDC.setColor(COL_NUM_A);                               //~vj01R~
//System.out.println("Show:Num="+Num+",r="+COL_NUM_A.getRed()+",g="+COL_NUM_A.getGreen()+",b="+COL_NUM_A.getBlue());//~vj01R~
        }                                                          //~v004M~
	}                                                              //~v004M~
	else                                                           //~v004M~
        ShowObject( pDC, BoardX, BoardY,ST_EMPTY,PFocus);          //~va23R~
//Num Text                                                         //~v004M~
    BoardToScreen( BoardX,BoardY, wkpoint);                        //~va23R~
    x=wkpoint.x; y=wkpoint.y;                                      //~v004I~
	pDC.setFont(new java.awt.Font(wnp.Sfontname, java.awt.Font.PLAIN,NumTextFontsz));//~va23R~
    if (Num!=0)                                                    //~vj01R~
    {                                                              //~v004M~
//		pDC.SetBkMode(TRANSPARENT);                                //~vj01R~
        if (Num==PATTERN_ID)                                       //~v004M~
        {                                                          //~v004M~
            if (!Pansmode)                                         //~vj01R~
	    		szNum="";                                          //~vj01R~
            else                                                   //~v004M~
                szNum=" ";                                         //~vj01R~
		}                                                          //~v004M~
        else                                                       //~v004M~
            if (!Pansmode)                                         //~vj01R~
	    		szNum="";                                          //~vj01R~
                                                                   //~v004M~
		else                                                       //~v004M~
                szNum=Integer.toString(Num);                       //~vj01R~
        if (Num<10)                                                //~va01I~
			pDC.drawString(szNum,x+NumTextPosx,y+NumTextPosy);   //1 digit//~va01I~
        else                                                       //~va01I~
			pDC.drawString(szNum,x+NumTextPosx10,y+NumTextPosy); //2 digit//~va01R~
	}                                                              //~v004M~
	else                                                           //~v004M~
    	if (Pansmode && MemoCnt!=0)                                //~vj01R~
        {                                                          //~v004M~
//			pDC.SetBkMode(TRANSPARENT);                            //~vj01R~
//  		pDC.setFont(new java.awt.Font(wnp.Sfontname, java.awt.Font.PLAIN,wnp.MEMOTEXT_SIZE));//~va23R~
            pDC.setColor(COL_NUM_A);                               //~vj01R~
//System.out.println("Show2:Num="+Num+",r="+COL_NUM_A.getRed()+",g="+COL_NUM_A.getGreen()+",b="+COL_NUM_A.getBlue());//~vj01R~
            for (ii=0;ii<MemoCnt;ii++)                             //~v004M~
            {                                                      //~v004M~
                if (Memo[ii]==0)                                   //~vj01R~
                    break;                                         //~v004M~
                if (Memo[ii]>=10)                                   //~va19I~
					pDC.setFont(new java.awt.Font(wnp.Sfontname, java.awt.Font.PLAIN,wnp.MEMOTEXT10_SIZE));//~va23R~
                else                                               //~va19I~
					pDC.setFont(new java.awt.Font(wnp.Sfontname, java.awt.Font.PLAIN,wnp.MEMOTEXT_SIZE));//~va23R~
                szNum=Integer.toString(Memo[ii]);                  //~vj01R~
//              pDC.drawString(szNum,x+wnp.MEMOTEXT_MARGIN*3+(ii%2!=0 ? wnp.MEMOTEXT_SIZE-wnp.MEMOTEXT_MARGIN:0),//~va19R~
                memox=wnp.MEMOTEXT_MARGIN*3;                       //~va19R~
                if (ii%2!=0)  // 1,3                               //~va19R~
                {                                                  //~va19I~
                    memox+=wnp.MEMOTEXT_SIZE-wnp.MEMOTEXT_MARGIN;  //~va19I~
                	if (Memo[ii]>=10)                              //~va19I~
						memox-=(wnp.MEMOTEXT_MARGIN-1);            //~va19R~
                }                                                  //~va19I~
                else          //0,2                                //~va19R~
                {                                                  //~va19I~
                	if (Memo[ii]>=10)                              //~va19R~
    					memox-=(wnp.MEMOTEXT_MARGIN+1);            //~va19R~
                }                                                  //~va19I~
                memoy=wnp.OBJECT_SIZE-2-wnp.MEMOTEXT_MARGIN;       //~va19I~
                if (ii/2==0)                                      //~va19I~
                	memoy-=wnp.MEMOTEXT_SIZE-1;                    //~va19I~
                pDC.drawString(szNum,x+memox,y+memoy);             //~va19I~
            }                                                      //~v004M~
			pDC.setFont(new java.awt.Font(wnp.Sfontname, java.awt.Font.PLAIN, 32));//~va23R~
        }                                                          //~v004M~
	pDC.setColor(br);                                              //~vj01I~
}                                                                  //~v004M~
}//class Hole                                                      //~v004I~
public void run() {                                                //~vj01I~
	Thread th=Thread.currentThread();                              //~vj01I~
	int threadid=xnpsub.uatoi(th.getName());                       //~vj01R~
	if (threadid==IDC_ANSWER)                                      //~vj01I~
		AnsThread();                                               //~vj01I~
	else if(threadid==IDC_MAKE)                                    //~vj01I~
		MakeThread();                                              //~vj01I~
                                                                   //~vj01I~
}                                                                  //~vj01I~
}//class Board                                                     //~v004I~
