//CID://+va23R~:                                                   //+va23R~
//*****************************************************************//~va01I~
//va23:051221 langauge ctl(English and japanese)                   //+va23I~
//v024:051103 (BUG)restore also score when restore pending game    //~va24I~
//va01:051013 5*5 support                                          //~va01I~
//*****************************************************************//~va01I~
import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

import javax.swing.JOptionPane;

public class CPattern {                                            //~5921I~
                                                                 //~5921I~
private static String SEED_PREFIX;                                 //+va23R~
private static String SCORE_PREFIX;                                //+va23R~
public static final int DATA_FILE=0x01;    //file read            //~5921I~
public static final int DATA_ERR =0x02;    //data has err         //~5921I~
public static final int DATA_ANS =0x10;    //answer gotten        //~5921I~
public static final int MAXLINE  =256;                            //~5921I~
                                                                   //~5921I~
public	int[][] QuestionData=new int[wnp.MAP_SIZE][wnp.MAP_SIZE];                      //~5922R~
public	int[][] PendingData=new int[wnp.MAP_SIZE][wnp.MAP_SIZE];   //~5A06I~
public	String Name;                                               //~5921I~
public   int   Datasw;                                             //~5921I~
public   int   Seed;                                               //~5921I~
public   int   Score,ScoreMax;                                     //~va24I~
public int [][] AnswerData=new int[wnp.MAP_SIZE][wnp.MAP_SIZE];    //~5922I~
                                                                   //~5921I~
private	int  Modifiedsw;                                           //~5921I~

/////////////////////////////////////////////////////////////////////////////

public CPattern()                                             //~5921R~
{
	Name="New.xnp";                                                //~5A06R~
//    for (int y=0;y<wnp.MAP_SIZE;y++)                             //~5A06R~
//        for (int x=0;x<wnp.MAP_SIZE;x++)                         //~5A06R~
//            QuestionData[y][x]=0;                                //~5A06R~
	if (wnp.Sjlang)                                                //+va23I~
		SEED_PREFIX="ԍ";                                  //+va23I~
    else                                                           //+va23I~
		SEED_PREFIX="Prob No=";                                    //+va23I~
	if (wnp.Sjlang)                                                //+va23I~
		SCORE_PREFIX="XRA";                                   //+va23I~
    else                                                           //+va23I~
		SCORE_PREFIX="Score=";                                     //+va23I~
	xnpsub.boardnumclear(QuestionData);                            //~5A06I~
	xnpsub.boardnumclear(PendingData);                             //~5A06I~
    Datasw=0;                                                      //~0108R~
    Modifiedsw=0;                                                  //~0108I~
    Seed=0;                                                        //~5923I~
}

public void Serialize (Object ar,File Pfile,int Pwritesw)throws IOException//~5A06R~
{
	int x,y;
	BufferedReader br;
	FileWriter    fw;
	String line;
	StringBuffer sb=new StringBuffer(MAXLINE);
    int  idata,ii,jj,err=0;                                        //~0129R~
    char ch;
    int mode;                                                      //~5A06I~
    int pendsw=0;                                                  //~5A06I~
    int[][]  inpnum=new int[wnp.MAP_SIZE][wnp.MAP_SIZE];                     //~5A06I~
    Board pBoard;                                                  //~5A06I~
    int pos;                                                       //~5A06I~
    String token;                                                  //~5A06I~
    String name;                                                   //~5A06I~
//**********************************                               //~5A06I~
	pBoard=View.aBoard;                                            //~5A06I~
    mode=pBoard.GetMode();                                         //~5A06I~
	name=Pfile.getPath();                                          //~5A06I~
    if (Pwritesw!=0) //on output                                //~0103R~
    {                                                              //~0102I~
    	pBoard.CalcScore();		//intermidate score calc           //~va24I~
//chk pending data                                                 //~5A06I~
	    pBoard.GetInpnum(inpnum);	//get                          //~5A06I~
        for (y=0;y<wnp.MAP_SIZE;y++)                                   //~5A06I~
        {                                                          //~5A06I~
            for (x=0;x<wnp.MAP_SIZE;x++)                               //~5A06I~
            {                                                      //~5A06I~
                if (QuestionData[y][x]==0)                         //~5A06I~
                    if (inpnum[y][x]!=0)                           //~5A06I~
                    {                                              //~5A06I~
                        pendsw=1;                                  //~5A06I~
                        break;                                     //~5A06I~
                    }                                              //~5A06I~
            }                                                      //~5A06I~
        }                                                          //~5A06I~
    	fw=(FileWriter)ar;
    	line="# FileName="+name;                                   //~5A06R~
      if (pendsw==0||                                              //~5A06I~
          (mode==Board.MODE_OUTANS && (Datasw & DATA_ANS)!=0))	//ans avail(not modified)//~5A06I~
      {                                                            //~5A06I~
    	PutLine(fw,line,2);                                        //~0102R~
        if (Seed!=0)                                               //~5A06R~
        {                                                          //~0129I~
	      if (wnp.Sjlang)                                          //+va23I~
    		line="#------ f[^ ------("+SEED_PREFIX+Seed+")";//~5A06R~
          else                                                     //+va23I~
    		line="#------Question Data-----("+SEED_PREFIX+Seed+")";//+va23I~
    		PutLine(fw,line,2);                                    //~0129R~
		}                                                          //~0129I~
        else                                                       //~0129I~
	      if (wnp.Sjlang)                                          //+va23I~
    		PutLine(fw,"#------ f[^ ------",2);      //~0129R~
          else                                                     //+va23I~
    		PutLine(fw,"#------Question Data-----",2);             //+va23I~
        for (y=0;y<wnp.MAP_SIZE;y++)                                   //~0102I~
        {                                                          //~0102I~
            sb.setLength(0);                                       //~5A06R~
            for (x=0;x<wnp.MAP_SIZE;x++)                           //~5A06R~
            {                                                      //~5A06R~
                if (QuestionData[y][x]!=0)                         //~5A06R~
                  if (QuestionData[y][x]>=10)                      //~va01R~
                    sb.append("  "+QuestionData[y][x]);            //~5A06R~
                  else                                             //~va01I~
                    sb.append("   "+QuestionData[y][x]);           //~va01I~
                else                                               //~5A06R~
                    sb.append("   _");                             //~va01R~
                                                                   //~5A06R~
                if (((x+1)%wnp.BOARDTYPE)==0)                      //~va01R~
                    sb.append("  ");                               //~va01R~
            }                                                      //~5A06R~
            if ((y+1)%wnp.BOARDTYPE==0)                            //~va01I~
                sb.append("\n");                                   //~va01I~
            PutLine(fw,sb.toString(),1);                           //~5A06R~
        }                                                          //~0102I~
//  	if ((Datasw & DATA_ANS)!=0)	//ans avail(not modified)      //~5A06R~
    	if (mode==Board.MODE_OUTANS && (Datasw & DATA_ANS)!=0)	//ans avail(not modified)//~5A06I~
        {                                                          //~0129I~
    		PutLine(fw," ",2);                              //~0129I~
	      if (wnp.Sjlang)                                          //+va23I~
    		PutLine(fw,"#------  ------",2);              //~0129I~
          else                                                     //+va23I~
    		PutLine(fw,"#-----Answer-----",2);                     //+va23I~
        	for (y=0;y<wnp.MAP_SIZE;y++)                               //~0129I~
        	{   
	            sb.setLength(0);                                   //~5A06I~
	        	for (x=0;x<wnp.MAP_SIZE;x++)                           //~0129I~
                {                                                  //~0129I~
    	        	if (QuestionData[y][x]!=0)                        //~0129I~
    	          	  if (QuestionData[y][x]>=10)                  //~va01R~
                    	sb.append("  "+QuestionData[y][x]);        //~5923R~
                      else                                         //~va01I~
                    	sb.append("   "+QuestionData[y][x]);       //~va01I~
                    else                                           //~0129I~
                    	if (AnswerData[y][x]!=0)                   //~5923I~
                    	  if (AnswerData[y][x]>=10)                //~va01R~
                    		sb.append(" *"+AnswerData[y][x]);      //~5923R~
                          else                                     //~va01I~
                    		sb.append("  *"+AnswerData[y][x]);     //~va01I~
                        else                                       //~5923I~
                    		sb.append("   _");                     //~va01R~
                                                                   //~0129I~
					if (((x+1)%wnp.BOARDTYPE)==0)                  //~va01R~
                    	sb.append("  ");                           //~va01R~
				}                                                  //~0129I~
	            if ((y+1)%wnp.BOARDTYPE==0)                        //~va01I~
    	            sb.append("\n");                               //~va01I~
	    		PutLine(fw,sb.toString(),1);                         //~0129I~
        	}                                                      //~0129I~
        }                                                          //~0129I~
      }                                                            //~5A06I~
      else                                                         //~5A06I~
      {                                                            //~5A06I~
    		PutLine(fw," ",2);                                     //~5A06I~
//            if (Seed!=0)                                         //~va24R~
//            {                                                    //~va24R~
//                line="#------ ro ------("+SEED_PREFIX+Seed;//~va24R~
//                PutLine(fw,line,2);                              //~va24R~
//            }                                                    //~va24R~
//            else                                                 //~va24R~
//                PutLine(fw,"#------ ro ------",2);         //~va24R~
	      if (wnp.Sjlang)                                          //+va23I~
            line="#------ ro ------("+SEED_PREFIX+Seed+";"+SCORE_PREFIX+pBoard.Score+"/"+pBoard.ScoreMax;//~va24I~
          else                                                     //+va23I~
            line="#------PendingData-----("+SEED_PREFIX+Seed+";"+SCORE_PREFIX+pBoard.Score+"/"+pBoard.ScoreMax;//+va23I~
            PutLine(fw,line,2);                                    //~va24I~
        	for (y=0;y<wnp.MAP_SIZE;y++)                               //~5A06I~
        	{                                                      //~5A06I~
	            sb.setLength(0);                                   //~5A06I~
	        	for (x=0;x<wnp.MAP_SIZE;x++)                           //~5A06I~
                {                                                  //~5A06I~
    	        	if (QuestionData[y][x]!=0)                     //~5A06I~
    	        	  if (QuestionData[y][x]>=10)                  //~va01R~
                    	sb.append("  "+QuestionData[y][x]);        //~5A06I~
                      else                                         //~va01I~
                    	sb.append("   "+QuestionData[y][x]);       //~va01I~
                    else                                           //~5A06I~
                    	if (inpnum[y][x]!=0)                       //~5A06I~
                    	  if (inpnum[y][x]>=10)                    //~va01R~
                    		sb.append(" ?"+inpnum[y][x]);          //~5A06I~
                          else                                     //~va01I~
                    		sb.append("  ?"+inpnum[y][x]);         //~va01I~
                        else                                       //~5A06I~
                    		sb.append("   _");                     //~va01R~
                                                                   //~5A06I~
					if (((x+1)%wnp.BOARDTYPE)==0)                  //~va01R~
                    	sb.append("  ");                           //~va01R~
				}                                                  //~5A06I~
	            if ((y+1)%wnp.BOARDTYPE==0)                        //~va01I~
    	            sb.append("\n");                               //~va01I~
	    		PutLine(fw,sb.toString(),1);                       //~5A06I~
        	}                                                      //~5A06I~
      }                                                            //~5A06I~
	    Modifiedsw=0;                                              //~0129I~
    }                                                              //~0102I~
	else        //on input                                         //~0103R~
    {                
		
        br=(BufferedReader)ar;
	    Datasw=DATA_FILE;                                          //~0129R~
        ClearAnsData();                                            //~5923I~
        xnpsub.boardnumclear(PendingData);                         //~5A06I~
	    Modifiedsw=0;                                              //~0108I~
        Score=ScoreMax=0;                                          //~va24I~
// 		try {                                                      //~5A06R~
	    for (ii=0;;)                                               //~0102I~
        {                                                          //~0102I~
 
			if ((line=br.readLine().trim()).equals(""))            //~5A06R~
                continue;                                          //~5A06I~
            if (line.charAt(0)=='#')                               //~5A06R~
            {                                                      //~5A06I~
                if ((pos=line.indexOf(SEED_PREFIX))>=0)            //~5A06I~
                	Seed=xnpsub.uatoi(line.substring(pos+SEED_PREFIX.length()));//~5A06R~
                if ((pos=line.indexOf(SCORE_PREFIX))>=0)           //~va24I~
                {                                                  //~va24I~
                	String subst=line.substring(pos+SCORE_PREFIX.length());//~va24R~
                	Score=xnpsub.uatoi(subst);                     //~va24I~
                    pos=subst.indexOf("/");                        //~va24R~
                    if (pos>=0)                                    //~va24R~
                		ScoreMax=xnpsub.uatoi(subst.substring(pos+1));//~va24I~
                }                                                  //~va24I~
            	continue;                                          //~0102I~
            }                                                      //~5A06I~
//            if (line.length()==wnp.PEG_MAX) //81 digt and lf     //~va01R~
//            {                                                    //~va01R~
//                for (jj=0;jj<wnp.PEG_MAX;jj++)                   //~va01R~
//                {                                                //~va01R~
//                    ch=line.charAt(jj);                          //~va01R~
//                    if (ch>='0' && ch<='9')                      //~va01R~
//                        idata=ch-'0';                            //~va01R~
//                    else                                         //~va01R~
//                        idata=0;                                 //~va01R~
//                    QuestionData[jj/wnp.MAP_SIZE][jj%wnp.MAP_SIZE]=idata;//~va01R~
//                }                                                //~va01R~
//                ii=PEG_MAX;                                      //~va01R~
//                break;      //return                             //~va01R~
//            }                                                    //~va01R~
            StringTokenizer st=new StringTokenizer(line," ");
            int fldno=st.countTokens();//~0102I~
            if (fldno<=0)   //no data or all space                 //~0102I~
                continue;                                          //~0102I~
            if (fldno!=wnp.MAP_SIZE)                                   //~0102I~
            {                                                      //~0102I~
            	err=1;                                             //~0102I~
                continue;                                          //~0102I~
            }                                                      //~0102I~
            for (jj=0;jj<wnp.MAP_SIZE;jj++)//~0102I~
            {                                                      //~0123I~
            	token=st.nextToken();                              //~5A06I~
              if (token.charAt(0)=='?')	//pending data             //~5A06I~
              {                                                    //~5A06I~
              	if (token.length()>1)                              //~5A06I~
	            	PendingData[ii][jj]=xnpsub.uatoi(token.substring(1));//~5A06I~
                else                                               //~5A06I~
	            	PendingData[ii][jj]=0;                         //~5A06I~
              }                                                    //~5A06I~
              else                                                 //~5A06I~
            	QuestionData[ii][jj]=xnpsub.uatoi(token);          //~5A06R~
            }                                                      //~0123I~
            if (++ii==wnp.MAP_SIZE)                                    //~va01R~
            	break;                                             //~0102I~
    	}                                                          //~5A06R~
//      }                                                          //~5A06I~
//  	} catch (IOException e) {                                  //~5A06R~
//  		err=1;                                                 //~5A06R~
//  		e.printStackTrace();                                   //~5A06R~
//  	}                                                          //~5A06R~
	    //~0102I~
		Name=name;                                                 //~5A06I~
        if (err!=0)                                                   //~0102I~
        {                                                          //~0108I~
	      if (wnp.Sjlang)                                          //+va23I~
		    JOptionPane.showMessageDialog(null,"f[^Ɍ肪܂","NP", JOptionPane.ERROR_MESSAGE);//~5930R~
          else                                                     //+va23I~
		    JOptionPane.showMessageDialog(null,"Inconsistent question data","NP", JOptionPane.ERROR_MESSAGE);//+va23I~
            Datasw|=DATA_ERR; //err data                           //~0129R~
        }                                                          //~0108I~
        else                                                       //~5A06I~
	    	Modifiedsw=0;                                          //~5A06I~
     }                                                              //~0102I~
}

private void equals(CPattern src)                           //~5921R~
{
	Name=src.Name;                                                 //~0102R~
	int x,y;                                                       //~0102I~
    for (y=0;y<wnp.MAP_SIZE;y++)                                       //~0102I~
        for (x=0;x<wnp.MAP_SIZE;x++)                                   //~0102I~
            QuestionData[y][x]=src.QuestionData[y][x];             //~0102I~
}
private void PutLine (FileWriter fw,String line,int Plfno) throws IOException //~5A06R~
{                                                                  //~0102I~
//  try {                                                          //~5A06R~
		fw.write(line,0,line.length());
                                    //~0102I~
        String sep=System.getProperty("line.separator");                                    //~0102R~
	    for (int ii=0;ii<Plfno;ii++)                                       //~0102I~
        {	                                                           //~0102I~
    	    fw.write(sep,0,sep.length());                                           //~0102R~
        }  
//  } catch (IOException e) {                                      //~5A06R~
//                                                                 //~5A06R~
//  	e.printStackTrace();                                       //~5A06R~
//  }                                                              //~5A06R~
}                                                                  //~0102I~

public boolean ChkData()                                         //~5921R~
{                                                                  //~0102I~
    for (int y=0;y<wnp.MAP_SIZE;y++)                                   //~0102I~
        for (int x=0;x<wnp.MAP_SIZE;x++)                               //~0102I~
        	if (QuestionData[y][x]!=0)            //~0102I~
                return true;                                       //~0102I~
	return false;                                                  //~0102I~
}                                                                  //~0102I~
//*********************************************************************//~0103I~
public void SetNewData(int bx,int by,int num,int Psortsw)         //~5921R~
{                                                                  //~0108I~
    if ((int)QuestionData[bx][by]!=num)                                 //~0108R~
    {                                                              //~0108I~
    	QuestionData[bx][by]=num;                                  //~0108I~
    	Modifiedsw=1;                                              //~0108R~
        if (Psortsw==0)                                              //~0130I~
        Datasw&=~DATA_ANS;    //ans not avail                      //~0129I~
    }                                                              //~0108I~
}                                                                  //~0108I~
//*********************************************************************//~0129I~
public void SetAnsData(int bx,int by,int num)                      //~5922R~
{                                                                  //~0129I~
	Datasw|=DATA_ANS;		//for later modification;              //~0129I~
    AnswerData[bx][by]=num;                                        //~0129I~
}                                                                  //~0129I~
//*********************************************************************//~5923I~
public int  GetAnsData(int bx,int by)                              //~5923R~
{                                                                  //~5923I~
    return AnswerData[bx][by];                                     //~5923I~
}                                                                  //~5923I~
public void ClearAnsData()                                         //~5923R~
{                                                                  //~5923I~
	Datasw&=~DATA_ANS;		//for later modification;              //~5923I~
    for (int y=0;y<wnp.MAP_SIZE;y++)                               //~5923I~
        for (int x=0;x<wnp.MAP_SIZE;x++)                           //~5923I~
        	AnswerData[y][x]=0;                                    //~5923I~
}                                                                  //~5923I~
public int GetModified()                                           //~5925R~
{                                                                  //~0108I~
	int modsw=Modifiedsw;                                              //~0108I~
	Modifiedsw=0;                                                  //~0108I~
    return modsw;                                                  //~0108I~
}                                                                  //~0108I~
}//class CPattern                                                  //~5921I~
